/*
 * Mercury Editor is a CoffeeScript and jQuery based WYSIWYG editor.  Documentation and other useful information can be
 * found at https://github.com/jejacks0n/mercury
 *

 *
 * Minimum jQuery requirements are 1.7

 *
 * You can include the Rails jQuery ujs script here to get some nicer behaviors in modals, panels and lightviews when
 * using :remote => true within the contents rendered in them.
 * require jquery_ujs
 *
 * Add any requires for the support libraries that integrate nicely with Mercury Editor.
 * require mercury/support/history
 *
 * Require Mercury Editor itself.

 *
 * Require any localizations you wish to support
 * Example: es.locale, or fr.locale -- regional dialects are in each language file so never en_US for instance.
 * require mercury/locales/swedish_chef.locale
 *
 * Add all requires for plugins that extend or change the behavior of Mercury Editor.
 * require mercury/plugins/save_as_xml/plugin.js
 *
 * Require any files you want to use that either extend, or change the default Mercury behavior.
 * require mercury_overrides
 */
window.Mercury={config:{toolbars:{primary:{undoredo:{undo:["Undo","Undo your last action"],redo:["Redo","Redo your last action"],sep:" "},insertLink:["Link","Insert Link",{modal:"/mercury/modals/link.html",regions:["full","markdown"]}],insertTable:["Table","Insert Table",{modal:"/mercury/modals/table.html",regions:["full","markdown"]}],insertCharacter:["Character","Special Characters",{modal:"/mercury/modals/character.html",regions:["full","markdown"]}],},editable:{_regions:["full","markdown"],predefined:{style:["Style",null,{select:"/mercury/selects/style.html",preload:true}],sep1:" ",formatblock:["Block Format",null,{select:"/mercury/selects/formatblock.html",preload:true}],sep2:"-"},colors:{backColor:["Background Color",null,{palette:"/mercury/palettes/backcolor.html",context:true,preload:true,regions:["full"]}],sep1:" ",foreColor:["Text Color",null,{palette:"/mercury/palettes/forecolor.html",context:true,preload:true,regions:["full"]}],sep2:"-"},decoration:{bold:["Bold",null,{context:true}],italic:["Italicize",null,{context:true}],overline:["Overline",null,{context:true,regions:["full"]}],strikethrough:["Strikethrough",null,{context:true,regions:["full"]}],underline:["Underline",null,{context:true,regions:["full"]}],sep:"-"},script:{subscript:["Subscript",null,{context:true}],superscript:["Superscript",null,{context:true}],sep:"-"},justify:{justifyLeft:["Align Left",null,{context:true,regions:["full"]}],justifyCenter:["Center",null,{context:true,regions:["full"]}],justifyRight:["Align Right",null,{context:true,regions:["full"]}],justifyFull:["Justify Full",null,{context:true,regions:["full"]}],sep:"-"},list:{insertUnorderedList:["Unordered List",null,{context:true}],insertOrderedList:["Numbered List",null,{context:true}],sep:"-"},indent:{outdent:["Decrease Indentation"],indent:["Increase Indentation"],sep:"-"},rules:{horizontalRule:["Horizontal Rule","Insert a horizontal rule"],sep1:"-"},formatting:{removeFormatting:["Remove Formatting","Remove formatting for the selection",{regions:["full"]}],sep2:" "},editors:{htmlEditor:["Edit HTML","Edit the HTML content",{regions:["full"]}]}},snippets:{_custom:true,actions:{editSnippet:["Edit Snippet Settings"],sep1:" ",removeSnippet:["Remove Snippet"]}}},regions:{attribute:"data-mercury",identifier:"id",dataAttributes:[]},snippets:{method:"POST",optionsUrl:"/mercury/snippets/:name/options.html",previewUrl:"/mercury/snippets/:name/preview.html"},uploading:{enabled:true,allowedMimeTypes:["image/jpeg","image/gif","image/png"],maxFileSize:1235242880,inputName:"image[image]",url:"/mercury/images",handler:false},localization:{enabled:false,preferredLocale:"swedish_chef-BORK"},behaviors:{htmlEditor:function(){Mercury.modal("/mercury/modals/htmleditor.html",{title:"HTML Editor",fullHeight:true,handler:"htmlEditor"})}},globalBehaviors:{exit:function(){window.location.href=this.iframeSrc()},barrelRoll:function(){$("body").css({webkitTransform:"rotate(360deg)"})}},csrfSelector:'meta[name="csrf-token"]',csrfHeader:"X-CSRF-Token",editorUrlRegEx:/([http|https]:\/\/.[^\/]*)\/editor\/?(.*)/i,nonHijackableClasses:[],pasting:{sanitize:"whitelist",whitelist:{h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],table:[],thead:[],tbody:[],tfoot:[],tr:[],th:["colspan","rowspan"],td:["colspan","rowspan"],div:["class"],span:["class"],ul:[],ol:[],li:[],b:[],strong:[],i:[],em:[],u:[],strike:[],br:[],p:[],hr:[],a:["href","target","title","name"],img:["src","title","alt"]}},injectedStyles:'[data-mercury]       { min-height: 10px; outline: 1px dotted #09F } [data-mercury]:focus { outline: none; -webkit-box-shadow: 0 0 10px #09F, 0 0 1px #045; box-shadow: 0 0 10px #09F, 0 0 1px #045 }[data-mercury].focus { outline: none; -webkit-box-shadow: 0 0 10px #09F, 0 0 1px #045; box-shadow: 0 0 10px #09F, 0 0 1px #045 }[data-mercury]:after { content: "."; display: block; visibility: hidden; clear: both; height: 0; overflow: hidden; }[data-mercury] table { border: 1px dotted red; min-width: 6px; }[data-mercury] th    { border: 1px dotted red; min-width: 6px; }[data-mercury] td    { border: 1px dotted red; min-width: 6px; }[data-mercury] .mercury-textarea       { border: 0; box-sizing: border-box; -moz-box-sizing: border-box; -webkit-box-sizing: border-box; resize: none; }[data-mercury] .mercury-textarea:focus { outline: none; -webkit-box-shadow: none; -moz-box-shadow: none; box-shadow: none; }'},silent:true,debug:false};
/*
 * jQuery JavaScript Library v1.7
 * http://jquery.com/
 *
 * Copyright 2011, John Resig
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * Includes Sizzle.js
 * http://sizzlejs.com/
 * Copyright 2011, The Dojo Foundation
 * Released under the MIT, BSD, and GPL Licenses.
 *
 * Date: Thu Nov 3 16:18:21 2011 -0400
 */
(function(window,undefined){var document=window.document,navigator=window.navigator,location=window.location;var jQuery=(function(){var jQuery=function(selector,context){return new jQuery.fn.init(selector,context,rootjQuery)},_jQuery=window.jQuery,_$=window.$,rootjQuery,quickExpr=/^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,rnotwhite=/\S/,trimLeft=/^\s+/,trimRight=/\s+$/,rdigit=/\d/,rsingleTag=/^<(\w+)\s*\/?>(?:<\/\1>)?$/,rvalidchars=/^[\],:{}\s]*$/,rvalidescape=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,rvalidtokens=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,rvalidbraces=/(?:^|:|,)(?:\s*\[)+/g,rwebkit=/(webkit)[ \/]([\w.]+)/,ropera=/(opera)(?:.*version)?[ \/]([\w.]+)/,rmsie=/(msie) ([\w.]+)/,rmozilla=/(mozilla)(?:.*? rv:([\w.]+))?/,rdashAlpha=/-([a-z]|[0-9])/ig,rmsPrefix=/^-ms-/,fcamelCase=function(all,letter){return(letter+"").toUpperCase()},userAgent=navigator.userAgent,browserMatch,readyList,DOMContentLoaded,toString=Object.prototype.toString,hasOwn=Object.prototype.hasOwnProperty,push=Array.prototype.push,slice=Array.prototype.slice,trim=String.prototype.trim,indexOf=Array.prototype.indexOf,class2type={};jQuery.fn=jQuery.prototype={constructor:jQuery,init:function(selector,context,rootjQuery){var match,elem,ret,doc;if(!selector){return this}if(selector.nodeType){this.context=this[0]=selector;this.length=1;return this}if(selector==="body"&&!context&&document.body){this.context=document;this[0]=document.body;this.selector=selector;this.length=1;return this}if(typeof selector==="string"){if(selector.charAt(0)==="<"&&selector.charAt(selector.length-1)===">"&&selector.length>=3){match=[null,selector,null]}else{match=quickExpr.exec(selector)}if(match&&(match[1]||!context)){if(match[1]){context=context instanceof jQuery?context[0]:context;doc=(context?context.ownerDocument||context:document);ret=rsingleTag.exec(selector);if(ret){if(jQuery.isPlainObject(context)){selector=[document.createElement(ret[1])];jQuery.fn.attr.call(selector,context,true)}else{selector=[doc.createElement(ret[1])]}}else{ret=jQuery.buildFragment([match[1]],[doc]);selector=(ret.cacheable?jQuery.clone(ret.fragment):ret.fragment).childNodes}return jQuery.merge(this,selector)}else{elem=document.getElementById(match[2]);if(elem&&elem.parentNode){if(elem.id!==match[2]){return rootjQuery.find(selector)}this.length=1;this[0]=elem}this.context=document;this.selector=selector;return this}}else{if(!context||context.jquery){return(context||rootjQuery).find(selector)}else{return this.constructor(context).find(selector)}}}else{if(jQuery.isFunction(selector)){return rootjQuery.ready(selector)}}if(selector.selector!==undefined){this.selector=selector.selector;this.context=selector.context}return jQuery.makeArray(selector,this)},selector:"",jquery:"1.7",length:0,size:function(){return this.length},toArray:function(){return slice.call(this,0)},get:function(num){return num==null?this.toArray():(num<0?this[this.length+num]:this[num])},pushStack:function(elems,name,selector){var ret=this.constructor();if(jQuery.isArray(elems)){push.apply(ret,elems)}else{jQuery.merge(ret,elems)}ret.prevObject=this;ret.context=this.context;if(name==="find"){ret.selector=this.selector+(this.selector?" ":"")+selector}else{if(name){ret.selector=this.selector+"."+name+"("+selector+")"}}return ret},each:function(callback,args){return jQuery.each(this,callback,args)},ready:function(fn){jQuery.bindReady();readyList.add(fn);return this},eq:function(i){return i===-1?this.slice(i):this.slice(i,+i+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(slice.apply(this,arguments),"slice",slice.call(arguments).join(","))},map:function(callback){return this.pushStack(jQuery.map(this,function(elem,i){return callback.call(elem,i,elem)}))},end:function(){return this.prevObject||this.constructor(null)},push:push,sort:[].sort,splice:[].splice};jQuery.fn.init.prototype=jQuery.fn;jQuery.extend=jQuery.fn.extend=function(){var options,name,src,copy,copyIsArray,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=false;if(typeof target==="boolean"){deep=target;target=arguments[1]||{};i=2}if(typeof target!=="object"&&!jQuery.isFunction(target)){target={}}if(length===i){target=this;--i}for(;i<length;i++){if((options=arguments[i])!=null){for(name in options){src=target[name];copy=options[name];if(target===copy){continue}if(deep&&copy&&(jQuery.isPlainObject(copy)||(copyIsArray=jQuery.isArray(copy)))){if(copyIsArray){copyIsArray=false;clone=src&&jQuery.isArray(src)?src:[]}else{clone=src&&jQuery.isPlainObject(src)?src:{}}target[name]=jQuery.extend(deep,clone,copy)}else{if(copy!==undefined){target[name]=copy}}}}}return target};jQuery.extend({noConflict:function(deep){if(window.$===jQuery){window.$=_$}if(deep&&window.jQuery===jQuery){window.jQuery=_jQuery}return jQuery},isReady:false,readyWait:1,holdReady:function(hold){if(hold){jQuery.readyWait++}else{jQuery.ready(true)}},ready:function(wait){if((wait===true&&!--jQuery.readyWait)||(wait!==true&&!jQuery.isReady)){if(!document.body){return setTimeout(jQuery.ready,1)}jQuery.isReady=true;if(wait!==true&&--jQuery.readyWait>0){return }readyList.fireWith(document,[jQuery]);if(jQuery.fn.trigger){jQuery(document).trigger("ready").unbind("ready")}}},bindReady:function(){if(readyList){return }readyList=jQuery.Callbacks("once memory");if(document.readyState==="complete"){return setTimeout(jQuery.ready,1)}if(document.addEventListener){document.addEventListener("DOMContentLoaded",DOMContentLoaded,false);window.addEventListener("load",jQuery.ready,false)}else{if(document.attachEvent){document.attachEvent("onreadystatechange",DOMContentLoaded);window.attachEvent("onload",jQuery.ready);var toplevel=false;try{toplevel=window.frameElement==null}catch(e){}if(document.documentElement.doScroll&&toplevel){doScrollCheck()}}}},isFunction:function(obj){return jQuery.type(obj)==="function"},isArray:Array.isArray||function(obj){return jQuery.type(obj)==="array"},isWindow:function(obj){return obj&&typeof obj==="object"&&"setInterval" in obj},isNumeric:function(obj){return obj!=null&&rdigit.test(obj)&&!isNaN(obj)},type:function(obj){return obj==null?String(obj):class2type[toString.call(obj)]||"object"},isPlainObject:function(obj){if(!obj||jQuery.type(obj)!=="object"||obj.nodeType||jQuery.isWindow(obj)){return false}try{if(obj.constructor&&!hasOwn.call(obj,"constructor")&&!hasOwn.call(obj.constructor.prototype,"isPrototypeOf")){return false}}catch(e){return false}var key;for(key in obj){}return key===undefined||hasOwn.call(obj,key)},isEmptyObject:function(obj){for(var name in obj){return false}return true},error:function(msg){throw msg},parseJSON:function(data){if(typeof data!=="string"||!data){return null}data=jQuery.trim(data);if(window.JSON&&window.JSON.parse){return window.JSON.parse(data)}if(rvalidchars.test(data.replace(rvalidescape,"@").replace(rvalidtokens,"]").replace(rvalidbraces,""))){return(new Function("return "+data))()}jQuery.error("Invalid JSON: "+data)},parseXML:function(data){var xml,tmp;try{if(window.DOMParser){tmp=new DOMParser();xml=tmp.parseFromString(data,"text/xml")}else{xml=new ActiveXObject("Microsoft.XMLDOM");xml.async="false";xml.loadXML(data)}}catch(e){xml=undefined}if(!xml||!xml.documentElement||xml.getElementsByTagName("parsererror").length){jQuery.error("Invalid XML: "+data)}return xml},noop:function(){},globalEval:function(data){if(data&&rnotwhite.test(data)){(window.execScript||function(data){window["eval"].call(window,data)})(data)}},camelCase:function(string){return string.replace(rmsPrefix,"ms-").replace(rdashAlpha,fcamelCase)},nodeName:function(elem,name){return elem.nodeName&&elem.nodeName.toUpperCase()===name.toUpperCase()},each:function(object,callback,args){var name,i=0,length=object.length,isObj=length===undefined||jQuery.isFunction(object);if(args){if(isObj){for(name in object){if(callback.apply(object[name],args)===false){break}}}else{for(;i<length;){if(callback.apply(object[i++],args)===false){break}}}}else{if(isObj){for(name in object){if(callback.call(object[name],name,object[name])===false){break}}}else{for(;i<length;){if(callback.call(object[i],i,object[i++])===false){break}}}}return object},trim:trim?function(text){return text==null?"":trim.call(text)}:function(text){return text==null?"":text.toString().replace(trimLeft,"").replace(trimRight,"")},makeArray:function(array,results){var ret=results||[];if(array!=null){var type=jQuery.type(array);if(array.length==null||type==="string"||type==="function"||type==="regexp"||jQuery.isWindow(array)){push.call(ret,array)}else{jQuery.merge(ret,array)}}return ret},inArray:function(elem,array,i){var len;if(array){if(indexOf){return indexOf.call(array,elem,i)}len=array.length;i=i?i<0?Math.max(0,len+i):i:0;for(;i<len;i++){if(i in array&&array[i]===elem){return i}}}return -1},merge:function(first,second){var i=first.length,j=0;if(typeof second.length==="number"){for(var l=second.length;j<l;j++){first[i++]=second[j]}}else{while(second[j]!==undefined){first[i++]=second[j++]}}first.length=i;return first},grep:function(elems,callback,inv){var ret=[],retVal;inv=!!inv;for(var i=0,length=elems.length;i<length;i++){retVal=!!callback(elems[i],i);if(inv!==retVal){ret.push(elems[i])}}return ret},map:function(elems,callback,arg){var value,key,ret=[],i=0,length=elems.length,isArray=elems instanceof jQuery||length!==undefined&&typeof length==="number"&&((length>0&&elems[0]&&elems[length-1])||length===0||jQuery.isArray(elems));if(isArray){for(;i<length;i++){value=callback(elems[i],i,arg);if(value!=null){ret[ret.length]=value}}}else{for(key in elems){value=callback(elems[key],key,arg);if(value!=null){ret[ret.length]=value}}}return ret.concat.apply([],ret)},guid:1,proxy:function(fn,context){if(typeof context==="string"){var tmp=fn[context];context=fn;fn=tmp}if(!jQuery.isFunction(fn)){return undefined}var args=slice.call(arguments,2),proxy=function(){return fn.apply(context,args.concat(slice.call(arguments)))};proxy.guid=fn.guid=fn.guid||proxy.guid||jQuery.guid++;return proxy},access:function(elems,key,value,exec,fn,pass){var length=elems.length;if(typeof key==="object"){for(var k in key){jQuery.access(elems,k,key[k],exec,fn,value)}return elems}if(value!==undefined){exec=!pass&&exec&&jQuery.isFunction(value);for(var i=0;i<length;i++){fn(elems[i],key,exec?value.call(elems[i],i,fn(elems[i],key)):value,pass)}return elems}return length?fn(elems[0],key):undefined},now:function(){return(new Date()).getTime()},uaMatch:function(ua){ua=ua.toLowerCase();var match=rwebkit.exec(ua)||ropera.exec(ua)||rmsie.exec(ua)||ua.indexOf("compatible")<0&&rmozilla.exec(ua)||[];return{browser:match[1]||"",version:match[2]||"0"}},sub:function(){function jQuerySub(selector,context){return new jQuerySub.fn.init(selector,context)}jQuery.extend(true,jQuerySub,this);jQuerySub.superclass=this;jQuerySub.fn=jQuerySub.prototype=this();jQuerySub.fn.constructor=jQuerySub;jQuerySub.sub=this.sub;jQuerySub.fn.init=function init(selector,context){if(context&&context instanceof jQuery&&!(context instanceof jQuerySub)){context=jQuerySub(context)}return jQuery.fn.init.call(this,selector,context,rootjQuerySub)};jQuerySub.fn.init.prototype=jQuerySub.fn;var rootjQuerySub=jQuerySub(document);return jQuerySub},browser:{}});jQuery.each("Boolean Number String Function Array Date RegExp Object".split(" "),function(i,name){class2type["[object "+name+"]"]=name.toLowerCase()});browserMatch=jQuery.uaMatch(userAgent);if(browserMatch.browser){jQuery.browser[browserMatch.browser]=true;jQuery.browser.version=browserMatch.version}if(jQuery.browser.webkit){jQuery.browser.safari=true}if(rnotwhite.test("\xA0")){trimLeft=/^[\s\xA0]+/;trimRight=/[\s\xA0]+$/}rootjQuery=jQuery(document);if(document.addEventListener){DOMContentLoaded=function(){document.removeEventListener("DOMContentLoaded",DOMContentLoaded,false);jQuery.ready()}}else{if(document.attachEvent){DOMContentLoaded=function(){if(document.readyState==="complete"){document.detachEvent("onreadystatechange",DOMContentLoaded);jQuery.ready()}}}}function doScrollCheck(){if(jQuery.isReady){return }try{document.documentElement.doScroll("left")}catch(e){setTimeout(doScrollCheck,1);return }jQuery.ready()}if(typeof define==="function"&&define.amd&&define.amd.jQuery){define("jquery",[],function(){return jQuery})}return jQuery})();var flagsCache={};function createFlags(flags){var object=flagsCache[flags]={},i,length;flags=flags.split(/\s+/);for(i=0,length=flags.length;i<length;i++){object[flags[i]]=true}return object}jQuery.Callbacks=function(flags){flags=flags?(flagsCache[flags]||createFlags(flags)):{};var list=[],stack=[],memory,firing,firingStart,firingLength,firingIndex,add=function(args){var i,length,elem,type,actual;for(i=0,length=args.length;i<length;i++){elem=args[i];type=jQuery.type(elem);if(type==="array"){add(elem)}else{if(type==="function"){if(!flags.unique||!self.has(elem)){list.push(elem)}}}}},fire=function(context,args){args=args||[];memory=!flags.memory||[context,args];firing=true;firingIndex=firingStart||0;firingStart=0;firingLength=list.length;for(;list&&firingIndex<firingLength;firingIndex++){if(list[firingIndex].apply(context,args)===false&&flags.stopOnFalse){memory=true;break}}firing=false;if(list){if(!flags.once){if(stack&&stack.length){memory=stack.shift();self.fireWith(memory[0],memory[1])}}else{if(memory===true){self.disable()}else{list=[]}}}},self={add:function(){if(list){var length=list.length;add(arguments);if(firing){firingLength=list.length}else{if(memory&&memory!==true){firingStart=length;fire(memory[0],memory[1])}}}return this},remove:function(){if(list){var args=arguments,argIndex=0,argLength=args.length;for(;argIndex<argLength;argIndex++){for(var i=0;i<list.length;i++){if(args[argIndex]===list[i]){if(firing){if(i<=firingLength){firingLength--;if(i<=firingIndex){firingIndex--}}}list.splice(i--,1);if(flags.unique){break}}}}}return this},has:function(fn){if(list){var i=0,length=list.length;for(;i<length;i++){if(fn===list[i]){return true}}}return false},empty:function(){list=[];return this},disable:function(){list=stack=memory=undefined;return this},disabled:function(){return !list},lock:function(){stack=undefined;if(!memory||memory===true){self.disable()}return this},locked:function(){return !stack},fireWith:function(context,args){if(stack){if(firing){if(!flags.once){stack.push([context,args])}}else{if(!(flags.once&&memory)){fire(context,args)}}}return this},fire:function(){self.fireWith(this,arguments);return this},fired:function(){return !!memory}};return self};var sliceDeferred=[].slice;jQuery.extend({Deferred:function(func){var doneList=jQuery.Callbacks("once memory"),failList=jQuery.Callbacks("once memory"),progressList=jQuery.Callbacks("memory"),state="pending",lists={resolve:doneList,reject:failList,notify:progressList},promise={done:doneList.add,fail:failList.add,progress:progressList.add,state:function(){return state},isResolved:doneList.fired,isRejected:failList.fired,then:function(doneCallbacks,failCallbacks,progressCallbacks){deferred.done(doneCallbacks).fail(failCallbacks).progress(progressCallbacks);return this},always:function(){return deferred.done.apply(deferred,arguments).fail.apply(deferred,arguments)},pipe:function(fnDone,fnFail,fnProgress){return jQuery.Deferred(function(newDefer){jQuery.each({done:[fnDone,"resolve"],fail:[fnFail,"reject"],progress:[fnProgress,"notify"]},function(handler,data){var fn=data[0],action=data[1],returned;if(jQuery.isFunction(fn)){deferred[handler](function(){returned=fn.apply(this,arguments);if(returned&&jQuery.isFunction(returned.promise)){returned.promise().then(newDefer.resolve,newDefer.reject,newDefer.notify)}else{newDefer[action+"With"](this===deferred?newDefer:this,[returned])}})}else{deferred[handler](newDefer[action])}})}).promise()},promise:function(obj){if(obj==null){obj=promise}else{for(var key in promise){obj[key]=promise[key]}}return obj}},deferred=promise.promise({}),key;for(key in lists){deferred[key]=lists[key].fire;deferred[key+"With"]=lists[key].fireWith}deferred.done(function(){state="resolved"},failList.disable,progressList.lock).fail(function(){state="rejected"},doneList.disable,progressList.lock);if(func){func.call(deferred,deferred)}return deferred},when:function(firstParam){var args=sliceDeferred.call(arguments,0),i=0,length=args.length,pValues=new Array(length),count=length,pCount=length,deferred=length<=1&&firstParam&&jQuery.isFunction(firstParam.promise)?firstParam:jQuery.Deferred(),promise=deferred.promise();function resolveFunc(i){return function(value){args[i]=arguments.length>1?sliceDeferred.call(arguments,0):value;if(!(--count)){deferred.resolveWith(deferred,args)}}}function progressFunc(i){return function(value){pValues[i]=arguments.length>1?sliceDeferred.call(arguments,0):value;deferred.notifyWith(promise,pValues)}}if(length>1){for(;i<length;i++){if(args[i]&&args[i].promise&&jQuery.isFunction(args[i].promise)){args[i].promise().then(resolveFunc(i),deferred.reject,progressFunc(i))}else{--count}}if(!count){deferred.resolveWith(deferred,args)}}else{if(deferred!==firstParam){deferred.resolveWith(deferred,length?[firstParam]:[])}}return promise}});jQuery.support=(function(){var div=document.createElement("div"),documentElement=document.documentElement,all,a,select,opt,input,marginDiv,support,fragment,body,testElementParent,testElement,testElementStyle,tds,events,eventName,i,isSupported;div.setAttribute("className","t");div.innerHTML="   <link/><table></table><a href='/a' style='top:1px;float:left;opacity:.55;'>a</a><input type='checkbox'/><nav></nav>";all=div.getElementsByTagName("*");a=div.getElementsByTagName("a")[0];if(!all||!all.length||!a){return{}}select=document.createElement("select");opt=select.appendChild(document.createElement("option"));input=div.getElementsByTagName("input")[0];support={leadingWhitespace:(div.firstChild.nodeType===3),tbody:!div.getElementsByTagName("tbody").length,htmlSerialize:!!div.getElementsByTagName("link").length,style:/top/.test(a.getAttribute("style")),hrefNormalized:(a.getAttribute("href")==="/a"),opacity:/^0.55/.test(a.style.opacity),cssFloat:!!a.style.cssFloat,unknownElems:!!div.getElementsByTagName("nav").length,checkOn:(input.value==="on"),optSelected:opt.selected,getSetAttribute:div.className!=="t",enctype:!!document.createElement("form").enctype,submitBubbles:true,changeBubbles:true,focusinBubbles:false,deleteExpando:true,noCloneEvent:true,inlineBlockNeedsLayout:false,shrinkWrapBlocks:false,reliableMarginRight:true};input.checked=true;support.noCloneChecked=input.cloneNode(true).checked;select.disabled=true;support.optDisabled=!opt.disabled;try{delete div.test}catch(e){support.deleteExpando=false}if(!div.addEventListener&&div.attachEvent&&div.fireEvent){div.attachEvent("onclick",function(){support.noCloneEvent=false});div.cloneNode(true).fireEvent("onclick")}input=document.createElement("input");input.value="t";input.setAttribute("type","radio");support.radioValue=input.value==="t";input.setAttribute("checked","checked");div.appendChild(input);fragment=document.createDocumentFragment();fragment.appendChild(div.lastChild);support.checkClone=fragment.cloneNode(true).cloneNode(true).lastChild.checked;div.innerHTML="";div.style.width=div.style.paddingLeft="1px";body=document.getElementsByTagName("body")[0];testElement=document.createElement(body?"div":"body");testElementStyle={visibility:"hidden",width:0,height:0,border:0,margin:0,background:"none"};if(body){jQuery.extend(testElementStyle,{position:"absolute",left:"-999px",top:"-999px"})}for(i in testElementStyle){testElement.style[i]=testElementStyle[i]}testElement.appendChild(div);testElementParent=body||documentElement;testElementParent.insertBefore(testElement,testElementParent.firstChild);support.appendChecked=input.checked;support.boxModel=div.offsetWidth===2;if("zoom" in div.style){div.style.display="inline";div.style.zoom=1;support.inlineBlockNeedsLayout=(div.offsetWidth===2);div.style.display="";div.innerHTML="<div style='width:4px;'></div>";support.shrinkWrapBlocks=(div.offsetWidth!==2)}div.innerHTML="<table><tr><td style='padding:0;border:0;display:none'></td><td>t</td></tr></table>";tds=div.getElementsByTagName("td");isSupported=(tds[0].offsetHeight===0);tds[0].style.display="";tds[1].style.display="none";support.reliableHiddenOffsets=isSupported&&(tds[0].offsetHeight===0);div.innerHTML="";if(document.defaultView&&document.defaultView.getComputedStyle){marginDiv=document.createElement("div");marginDiv.style.width="0";marginDiv.style.marginRight="0";div.appendChild(marginDiv);support.reliableMarginRight=(parseInt((document.defaultView.getComputedStyle(marginDiv,null)||{marginRight:0}).marginRight,10)||0)===0}if(div.attachEvent){for(i in {submit:1,change:1,focusin:1}){eventName="on"+i;isSupported=(eventName in div);if(!isSupported){div.setAttribute(eventName,"return;");isSupported=(typeof div[eventName]==="function")}support[i+"Bubbles"]=isSupported}}jQuery(function(){var container,outer,inner,table,td,offsetSupport,conMarginTop=1,ptlm="position:absolute;top:0;left:0;width:1px;height:1px;margin:0;",vb="visibility:hidden;border:0;",style="style='"+ptlm+"border:5px solid #000;padding:0;'",html="<div "+style+"><div></div></div><table "+style+" cellpadding='0' cellspacing='0'><tr><td></td></tr></table>";body=document.getElementsByTagName("body")[0];if(!body){return }container=document.createElement("div");container.style.cssText=vb+"width:0;height:0;position:static;top:0;margin-top:"+conMarginTop+"px";body.insertBefore(container,body.firstChild);testElement=document.createElement("div");testElement.style.cssText=ptlm+vb;testElement.innerHTML=html;container.appendChild(testElement);outer=testElement.firstChild;inner=outer.firstChild;td=outer.nextSibling.firstChild.firstChild;offsetSupport={doesNotAddBorder:(inner.offsetTop!==5),doesAddBorderForTableAndCells:(td.offsetTop===5)};inner.style.position="fixed";inner.style.top="20px";offsetSupport.fixedPosition=(inner.offsetTop===20||inner.offsetTop===15);inner.style.position=inner.style.top="";outer.style.overflow="hidden";outer.style.position="relative";offsetSupport.subtractsBorderForOverflowNotVisible=(inner.offsetTop===-5);offsetSupport.doesNotIncludeMarginInBodyOffset=(body.offsetTop!==conMarginTop);body.removeChild(container);testElement=container=null;jQuery.extend(support,offsetSupport)});testElement.innerHTML="";testElementParent.removeChild(testElement);testElement=fragment=select=opt=body=marginDiv=div=input=null;return support})();jQuery.boxModel=jQuery.support.boxModel;var rbrace=/^(?:\{.*\}|\[.*\])$/,rmultiDash=/([A-Z])/g;jQuery.extend({cache:{},uuid:0,expando:"jQuery"+(jQuery.fn.jquery+Math.random()).replace(/\D/g,""),noData:{embed:true,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",applet:true},hasData:function(elem){elem=elem.nodeType?jQuery.cache[elem[jQuery.expando]]:elem[jQuery.expando];return !!elem&&!isEmptyDataObject(elem)},data:function(elem,name,data,pvt){if(!jQuery.acceptData(elem)){return }var privateCache,thisCache,ret,internalKey=jQuery.expando,getByName=typeof name==="string",isNode=elem.nodeType,cache=isNode?jQuery.cache:elem,id=isNode?elem[jQuery.expando]:elem[jQuery.expando]&&jQuery.expando,isEvents=name==="events";if((!id||!cache[id]||(!isEvents&&!pvt&&!cache[id].data))&&getByName&&data===undefined){return }if(!id){if(isNode){elem[jQuery.expando]=id=++jQuery.uuid}else{id=jQuery.expando}}if(!cache[id]){cache[id]={};if(!isNode){cache[id].toJSON=jQuery.noop}}if(typeof name==="object"||typeof name==="function"){if(pvt){cache[id]=jQuery.extend(cache[id],name)}else{cache[id].data=jQuery.extend(cache[id].data,name)}}privateCache=thisCache=cache[id];if(!pvt){if(!thisCache.data){thisCache.data={}}thisCache=thisCache.data}if(data!==undefined){thisCache[jQuery.camelCase(name)]=data}if(isEvents&&!thisCache[name]){return privateCache.events}if(getByName){ret=thisCache[name];if(ret==null){ret=thisCache[jQuery.camelCase(name)]}}else{ret=thisCache}return ret},removeData:function(elem,name,pvt){if(!jQuery.acceptData(elem)){return }var thisCache,i,l,internalKey=jQuery.expando,isNode=elem.nodeType,cache=isNode?jQuery.cache:elem,id=isNode?elem[jQuery.expando]:jQuery.expando;if(!cache[id]){return }if(name){thisCache=pvt?cache[id]:cache[id].data;if(thisCache){if(jQuery.isArray(name)){name=name}else{if(name in thisCache){name=[name]}else{name=jQuery.camelCase(name);if(name in thisCache){name=[name]}else{name=name.split(" ")}}}for(i=0,l=name.length;i<l;i++){delete thisCache[name[i]]}if(!(pvt?isEmptyDataObject:jQuery.isEmptyObject)(thisCache)){return }}}if(!pvt){delete cache[id].data;if(!isEmptyDataObject(cache[id])){return }}if(jQuery.support.deleteExpando||!cache.setInterval){delete cache[id]}else{cache[id]=null}if(isNode){if(jQuery.support.deleteExpando){delete elem[jQuery.expando]}else{if(elem.removeAttribute){elem.removeAttribute(jQuery.expando)}else{elem[jQuery.expando]=null}}}},_data:function(elem,name,data){return jQuery.data(elem,name,data,true)},acceptData:function(elem){if(elem.nodeName){var match=jQuery.noData[elem.nodeName.toLowerCase()];if(match){return !(match===true||elem.getAttribute("classid")!==match)}}return true}});jQuery.fn.extend({data:function(key,value){var parts,attr,name,data=null;if(typeof key==="undefined"){if(this.length){data=jQuery.data(this[0]);if(this[0].nodeType===1&&!jQuery._data(this[0],"parsedAttrs")){attr=this[0].attributes;for(var i=0,l=attr.length;i<l;i++){name=attr[i].name;if(name.indexOf("data-")===0){name=jQuery.camelCase(name.substring(5));dataAttr(this[0],name,data[name])}}jQuery._data(this[0],"parsedAttrs",true)}}return data}else{if(typeof key==="object"){return this.each(function(){jQuery.data(this,key)})}}parts=key.split(".");parts[1]=parts[1]?"."+parts[1]:"";if(value===undefined){data=this.triggerHandler("getData"+parts[1]+"!",[parts[0]]);if(data===undefined&&this.length){data=jQuery.data(this[0],key);data=dataAttr(this[0],key,data)}return data===undefined&&parts[1]?this.data(parts[0]):data}else{return this.each(function(){var $this=jQuery(this),args=[parts[0],value];$this.triggerHandler("setData"+parts[1]+"!",args);jQuery.data(this,key,value);$this.triggerHandler("changeData"+parts[1]+"!",args)})}},removeData:function(key){return this.each(function(){jQuery.removeData(this,key)})}});function dataAttr(elem,key,data){if(data===undefined&&elem.nodeType===1){var name="data-"+key.replace(rmultiDash,"-$1").toLowerCase();data=elem.getAttribute(name);if(typeof data==="string"){try{data=data==="true"?true:data==="false"?false:data==="null"?null:jQuery.isNumeric(data)?parseFloat(data):rbrace.test(data)?jQuery.parseJSON(data):data}catch(e){}jQuery.data(elem,key,data)}else{data=undefined}}return data}function isEmptyDataObject(obj){for(var name in obj){if(name==="data"&&jQuery.isEmptyObject(obj[name])){continue}if(name!=="toJSON"){return false}}return true}function handleQueueMarkDefer(elem,type,src){var deferDataKey=type+"defer",queueDataKey=type+"queue",markDataKey=type+"mark",defer=jQuery._data(elem,deferDataKey);if(defer&&(src==="queue"||!jQuery._data(elem,queueDataKey))&&(src==="mark"||!jQuery._data(elem,markDataKey))){setTimeout(function(){if(!jQuery._data(elem,queueDataKey)&&!jQuery._data(elem,markDataKey)){jQuery.removeData(elem,deferDataKey,true);defer.fire()}},0)}}jQuery.extend({_mark:function(elem,type){if(elem){type=(type||"fx")+"mark";jQuery._data(elem,type,(jQuery._data(elem,type)||0)+1)}},_unmark:function(force,elem,type){if(force!==true){type=elem;elem=force;force=false}if(elem){type=type||"fx";var key=type+"mark",count=force?0:((jQuery._data(elem,key)||1)-1);if(count){jQuery._data(elem,key,count)}else{jQuery.removeData(elem,key,true);handleQueueMarkDefer(elem,type,"mark")}}},queue:function(elem,type,data){var q;if(elem){type=(type||"fx")+"queue";q=jQuery._data(elem,type);if(data){if(!q||jQuery.isArray(data)){q=jQuery._data(elem,type,jQuery.makeArray(data))}else{q.push(data)}}return q||[]}},dequeue:function(elem,type){type=type||"fx";var queue=jQuery.queue(elem,type),fn=queue.shift(),hooks={};if(fn==="inprogress"){fn=queue.shift()}if(fn){if(type==="fx"){queue.unshift("inprogress")}jQuery._data(elem,type+".run",hooks);fn.call(elem,function(){jQuery.dequeue(elem,type)},hooks)}if(!queue.length){jQuery.removeData(elem,type+"queue "+type+".run",true);handleQueueMarkDefer(elem,type,"queue")}}});jQuery.fn.extend({queue:function(type,data){if(typeof type!=="string"){data=type;type="fx"}if(data===undefined){return jQuery.queue(this[0],type)}return this.each(function(){var queue=jQuery.queue(this,type,data);if(type==="fx"&&queue[0]!=="inprogress"){jQuery.dequeue(this,type)}})},dequeue:function(type){return this.each(function(){jQuery.dequeue(this,type)})},delay:function(time,type){time=jQuery.fx?jQuery.fx.speeds[time]||time:time;type=type||"fx";return this.queue(type,function(next,hooks){var timeout=setTimeout(next,time);hooks.stop=function(){clearTimeout(timeout)}})},clearQueue:function(type){return this.queue(type||"fx",[])},promise:function(type,object){if(typeof type!=="string"){object=type;type=undefined}type=type||"fx";var defer=jQuery.Deferred(),elements=this,i=elements.length,count=1,deferDataKey=type+"defer",queueDataKey=type+"queue",markDataKey=type+"mark",tmp;function resolve(){if(!(--count)){defer.resolveWith(elements,[elements])}}while(i--){if((tmp=jQuery.data(elements[i],deferDataKey,undefined,true)||(jQuery.data(elements[i],queueDataKey,undefined,true)||jQuery.data(elements[i],markDataKey,undefined,true))&&jQuery.data(elements[i],deferDataKey,jQuery.Callbacks("once memory"),true))){count++;tmp.add(resolve)}}resolve();return defer.promise()}});var rclass=/[\n\t\r]/g,rspace=/\s+/,rreturn=/\r/g,rtype=/^(?:button|input)$/i,rfocusable=/^(?:button|input|object|select|textarea)$/i,rclickable=/^a(?:rea)?$/i,rboolean=/^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,getSetAttribute=jQuery.support.getSetAttribute,nodeHook,boolHook,fixSpecified;jQuery.fn.extend({attr:function(name,value){return jQuery.access(this,name,value,true,jQuery.attr)},removeAttr:function(name){return this.each(function(){jQuery.removeAttr(this,name)})},prop:function(name,value){return jQuery.access(this,name,value,true,jQuery.prop)},removeProp:function(name){name=jQuery.propFix[name]||name;return this.each(function(){try{this[name]=undefined;delete this[name]}catch(e){}})},addClass:function(value){var classNames,i,l,elem,setClass,c,cl;if(jQuery.isFunction(value)){return this.each(function(j){jQuery(this).addClass(value.call(this,j,this.className))})}if(value&&typeof value==="string"){classNames=value.split(rspace);for(i=0,l=this.length;i<l;i++){elem=this[i];if(elem.nodeType===1){if(!elem.className&&classNames.length===1){elem.className=value}else{setClass=" "+elem.className+" ";for(c=0,cl=classNames.length;c<cl;c++){if(!~setClass.indexOf(" "+classNames[c]+" ")){setClass+=classNames[c]+" "}}elem.className=jQuery.trim(setClass)}}}}return this},removeClass:function(value){var classNames,i,l,elem,className,c,cl;if(jQuery.isFunction(value)){return this.each(function(j){jQuery(this).removeClass(value.call(this,j,this.className))})}if((value&&typeof value==="string")||value===undefined){classNames=(value||"").split(rspace);for(i=0,l=this.length;i<l;i++){elem=this[i];if(elem.nodeType===1&&elem.className){if(value){className=(" "+elem.className+" ").replace(rclass," ");for(c=0,cl=classNames.length;c<cl;c++){className=className.replace(" "+classNames[c]+" "," ")}elem.className=jQuery.trim(className)}else{elem.className=""}}}}return this},toggleClass:function(value,stateVal){var type=typeof value,isBool=typeof stateVal==="boolean";if(jQuery.isFunction(value)){return this.each(function(i){jQuery(this).toggleClass(value.call(this,i,this.className,stateVal),stateVal)})}return this.each(function(){if(type==="string"){var className,i=0,self=jQuery(this),state=stateVal,classNames=value.split(rspace);while((className=classNames[i++])){state=isBool?state:!self.hasClass(className);self[state?"addClass":"removeClass"](className)}}else{if(type==="undefined"||type==="boolean"){if(this.className){jQuery._data(this,"__className__",this.className)}this.className=this.className||value===false?"":jQuery._data(this,"__className__")||""}}})},hasClass:function(selector){var className=" "+selector+" ",i=0,l=this.length;for(;i<l;i++){if(this[i].nodeType===1&&(" "+this[i].className+" ").replace(rclass," ").indexOf(className)>-1){return true}}return false},val:function(value){var hooks,ret,isFunction,elem=this[0];if(!arguments.length){if(elem){hooks=jQuery.valHooks[elem.nodeName.toLowerCase()]||jQuery.valHooks[elem.type];if(hooks&&"get" in hooks&&(ret=hooks.get(elem,"value"))!==undefined){return ret}ret=elem.value;return typeof ret==="string"?ret.replace(rreturn,""):ret==null?"":ret}return undefined}isFunction=jQuery.isFunction(value);return this.each(function(i){var self=jQuery(this),val;if(this.nodeType!==1){return }if(isFunction){val=value.call(this,i,self.val())}else{val=value}if(val==null){val=""}else{if(typeof val==="number"){val+=""}else{if(jQuery.isArray(val)){val=jQuery.map(val,function(value){return value==null?"":value+""})}}}hooks=jQuery.valHooks[this.nodeName.toLowerCase()]||jQuery.valHooks[this.type];if(!hooks||!("set" in hooks)||hooks.set(this,val,"value")===undefined){this.value=val}})}});jQuery.extend({valHooks:{option:{get:function(elem){var val=elem.attributes.value;return !val||val.specified?elem.value:elem.text}},select:{get:function(elem){var value,i,max,option,index=elem.selectedIndex,values=[],options=elem.options,one=elem.type==="select-one";if(index<0){return null}i=one?index:0;max=one?index+1:options.length;for(;i<max;i++){option=options[i];if(option.selected&&(jQuery.support.optDisabled?!option.disabled:option.getAttribute("disabled")===null)&&(!option.parentNode.disabled||!jQuery.nodeName(option.parentNode,"optgroup"))){value=jQuery(option).val();if(one){return value}values.push(value)}}if(one&&!values.length&&options.length){return jQuery(options[index]).val()}return values},set:function(elem,value){var values=jQuery.makeArray(value);jQuery(elem).find("option").each(function(){this.selected=jQuery.inArray(jQuery(this).val(),values)>=0});if(!values.length){elem.selectedIndex=-1}return values}}},attrFn:{val:true,css:true,html:true,text:true,data:true,width:true,height:true,offset:true},attr:function(elem,name,value,pass){var ret,hooks,notxml,nType=elem.nodeType;if(!elem||nType===3||nType===8||nType===2){return undefined}if(pass&&name in jQuery.attrFn){return jQuery(elem)[name](value)}if(!("getAttribute" in elem)){return jQuery.prop(elem,name,value)}notxml=nType!==1||!jQuery.isXMLDoc(elem);if(notxml){name=name.toLowerCase();hooks=jQuery.attrHooks[name]||(rboolean.test(name)?boolHook:nodeHook)}if(value!==undefined){if(value===null){jQuery.removeAttr(elem,name);return undefined}else{if(hooks&&"set" in hooks&&notxml&&(ret=hooks.set(elem,value,name))!==undefined){return ret}else{elem.setAttribute(name,""+value);return value}}}else{if(hooks&&"get" in hooks&&notxml&&(ret=hooks.get(elem,name))!==null){return ret}else{ret=elem.getAttribute(name);return ret===null?undefined:ret}}},removeAttr:function(elem,value){var propName,attrNames,name,l,i=0;if(elem.nodeType===1){attrNames=(value||"").split(rspace);l=attrNames.length;for(;i<l;i++){name=attrNames[i].toLowerCase();propName=jQuery.propFix[name]||name;jQuery.attr(elem,name,"");elem.removeAttribute(getSetAttribute?name:propName);if(rboolean.test(name)&&propName in elem){elem[propName]=false}}}},attrHooks:{type:{set:function(elem,value){if(rtype.test(elem.nodeName)&&elem.parentNode){jQuery.error("type property can't be changed")}else{if(!jQuery.support.radioValue&&value==="radio"&&jQuery.nodeName(elem,"input")){var val=elem.value;elem.setAttribute("type",value);if(val){elem.value=val}return value}}}},value:{get:function(elem,name){if(nodeHook&&jQuery.nodeName(elem,"button")){return nodeHook.get(elem,name)}return name in elem?elem.value:null},set:function(elem,value,name){if(nodeHook&&jQuery.nodeName(elem,"button")){return nodeHook.set(elem,value,name)}elem.value=value}}},propFix:{tabindex:"tabIndex",readonly:"readOnly","for":"htmlFor","class":"className",maxlength:"maxLength",cellspacing:"cellSpacing",cellpadding:"cellPadding",rowspan:"rowSpan",colspan:"colSpan",usemap:"useMap",frameborder:"frameBorder",contenteditable:"contentEditable"},prop:function(elem,name,value){var ret,hooks,notxml,nType=elem.nodeType;if(!elem||nType===3||nType===8||nType===2){return undefined}notxml=nType!==1||!jQuery.isXMLDoc(elem);if(notxml){name=jQuery.propFix[name]||name;hooks=jQuery.propHooks[name]}if(value!==undefined){if(hooks&&"set" in hooks&&(ret=hooks.set(elem,value,name))!==undefined){return ret}else{return(elem[name]=value)}}else{if(hooks&&"get" in hooks&&(ret=hooks.get(elem,name))!==null){return ret}else{return elem[name]}}},propHooks:{tabIndex:{get:function(elem){var attributeNode=elem.getAttributeNode("tabindex");return attributeNode&&attributeNode.specified?parseInt(attributeNode.value,10):rfocusable.test(elem.nodeName)||rclickable.test(elem.nodeName)&&elem.href?0:undefined}}}});jQuery.attrHooks.tabindex=jQuery.propHooks.tabIndex;boolHook={get:function(elem,name){var attrNode,property=jQuery.prop(elem,name);return property===true||typeof property!=="boolean"&&(attrNode=elem.getAttributeNode(name))&&attrNode.nodeValue!==false?name.toLowerCase():undefined},set:function(elem,value,name){var propName;if(value===false){jQuery.removeAttr(elem,name)}else{propName=jQuery.propFix[name]||name;if(propName in elem){elem[propName]=true}elem.setAttribute(name,name.toLowerCase())}return name}};if(!getSetAttribute){fixSpecified={name:true,id:true};nodeHook=jQuery.valHooks.button={get:function(elem,name){var ret;ret=elem.getAttributeNode(name);return ret&&(fixSpecified[name]?ret.nodeValue!=="":ret.specified)?ret.nodeValue:undefined},set:function(elem,value,name){var ret=elem.getAttributeNode(name);if(!ret){ret=document.createAttribute(name);elem.setAttributeNode(ret)}return(ret.nodeValue=value+"")}};jQuery.attrHooks.tabindex.set=nodeHook.set;jQuery.each(["width","height"],function(i,name){jQuery.attrHooks[name]=jQuery.extend(jQuery.attrHooks[name],{set:function(elem,value){if(value===""){elem.setAttribute(name,"auto");return value}}})});jQuery.attrHooks.contenteditable={get:nodeHook.get,set:function(elem,value,name){if(value===""){value="false"}nodeHook.set(elem,value,name)}}}if(!jQuery.support.hrefNormalized){jQuery.each(["href","src","width","height"],function(i,name){jQuery.attrHooks[name]=jQuery.extend(jQuery.attrHooks[name],{get:function(elem){var ret=elem.getAttribute(name,2);return ret===null?undefined:ret}})})}if(!jQuery.support.style){jQuery.attrHooks.style={get:function(elem){return elem.style.cssText.toLowerCase()||undefined},set:function(elem,value){return(elem.style.cssText=""+value)}}}if(!jQuery.support.optSelected){jQuery.propHooks.selected=jQuery.extend(jQuery.propHooks.selected,{get:function(elem){var parent=elem.parentNode;if(parent){parent.selectedIndex;if(parent.parentNode){parent.parentNode.selectedIndex}}return null}})}if(!jQuery.support.enctype){jQuery.propFix.enctype="encoding"}if(!jQuery.support.checkOn){jQuery.each(["radio","checkbox"],function(){jQuery.valHooks[this]={get:function(elem){return elem.getAttribute("value")===null?"on":elem.value}}})}jQuery.each(["radio","checkbox"],function(){jQuery.valHooks[this]=jQuery.extend(jQuery.valHooks[this],{set:function(elem,value){if(jQuery.isArray(value)){return(elem.checked=jQuery.inArray(jQuery(elem).val(),value)>=0)}}})});var rnamespaces=/\.(.*)$/,rformElems=/^(?:textarea|input|select)$/i,rperiod=/\./g,rspaces=/ /g,rescape=/[^\w\s.|`]/g,rtypenamespace=/^([^\.]*)?(?:\.(.+))?$/,rhoverHack=/\bhover(\.\S+)?/,rkeyEvent=/^key/,rmouseEvent=/^(?:mouse|contextmenu)|click/,rquickIs=/^(\w*)(?:#([\w\-]+))?(?:\.([\w\-]+))?$/,quickParse=function(selector){var quick=rquickIs.exec(selector);if(quick){quick[1]=(quick[1]||"").toLowerCase();quick[3]=quick[3]&&new RegExp("(?:^|\\s)"+quick[3]+"(?:\\s|$)")}return quick},quickIs=function(elem,m){return((!m[1]||elem.nodeName.toLowerCase()===m[1])&&(!m[2]||elem.id===m[2])&&(!m[3]||m[3].test(elem.className)))},hoverHack=function(events){return jQuery.event.special.hover?events:events.replace(rhoverHack,"mouseenter$1 mouseleave$1")};jQuery.event={add:function(elem,types,handler,data,selector){var elemData,eventHandle,events,t,tns,type,namespaces,handleObj,handleObjIn,quick,handlers,special;if(elem.nodeType===3||elem.nodeType===8||!types||!handler||!(elemData=jQuery._data(elem))){return }if(handler.handler){handleObjIn=handler;handler=handleObjIn.handler}if(!handler.guid){handler.guid=jQuery.guid++}events=elemData.events;if(!events){elemData.events=events={}}eventHandle=elemData.handle;if(!eventHandle){elemData.handle=eventHandle=function(e){return typeof jQuery!=="undefined"&&(!e||jQuery.event.triggered!==e.type)?jQuery.event.dispatch.apply(eventHandle.elem,arguments):undefined};eventHandle.elem=elem}types=hoverHack(types).split(" ");for(t=0;t<types.length;t++){tns=rtypenamespace.exec(types[t])||[];type=tns[1];namespaces=(tns[2]||"").split(".").sort();special=jQuery.event.special[type]||{};type=(selector?special.delegateType:special.bindType)||type;special=jQuery.event.special[type]||{};handleObj=jQuery.extend({type:type,origType:tns[1],data:data,handler:handler,guid:handler.guid,selector:selector,namespace:namespaces.join(".")},handleObjIn);if(selector){handleObj.quick=quickParse(selector);if(!handleObj.quick&&jQuery.expr.match.POS.test(selector)){handleObj.isPositional=true}}handlers=events[type];if(!handlers){handlers=events[type]=[];handlers.delegateCount=0;if(!special.setup||special.setup.call(elem,data,namespaces,eventHandle)===false){if(elem.addEventListener){elem.addEventListener(type,eventHandle,false)}else{if(elem.attachEvent){elem.attachEvent("on"+type,eventHandle)}}}}if(special.add){special.add.call(elem,handleObj);if(!handleObj.handler.guid){handleObj.handler.guid=handler.guid}}if(selector){handlers.splice(handlers.delegateCount++,0,handleObj)}else{handlers.push(handleObj)}jQuery.event.global[type]=true}elem=null},global:{},remove:function(elem,types,handler,selector){var elemData=jQuery.hasData(elem)&&jQuery._data(elem),t,tns,type,namespaces,origCount,j,events,special,handle,eventType,handleObj;if(!elemData||!(events=elemData.events)){return }types=hoverHack(types||"").split(" ");for(t=0;t<types.length;t++){tns=rtypenamespace.exec(types[t])||[];type=tns[1];namespaces=tns[2];if(!type){namespaces=namespaces?"."+namespaces:"";for(j in events){jQuery.event.remove(elem,j+namespaces,handler,selector)}return }special=jQuery.event.special[type]||{};type=(selector?special.delegateType:special.bindType)||type;eventType=events[type]||[];origCount=eventType.length;namespaces=namespaces?new RegExp("(^|\\.)"+namespaces.split(".").sort().join("\\.(?:.*\\.)?")+"(\\.|$)"):null;if(handler||namespaces||selector||special.remove){for(j=0;j<eventType.length;j++){handleObj=eventType[j];if(!handler||handler.guid===handleObj.guid){if(!namespaces||namespaces.test(handleObj.namespace)){if(!selector||selector===handleObj.selector||selector==="**"&&handleObj.selector){eventType.splice(j--,1);if(handleObj.selector){eventType.delegateCount--}if(special.remove){special.remove.call(elem,handleObj)}}}}}}else{eventType.length=0}if(eventType.length===0&&origCount!==eventType.length){if(!special.teardown||special.teardown.call(elem,namespaces)===false){jQuery.removeEvent(elem,type,elemData.handle)}delete events[type]}}if(jQuery.isEmptyObject(events)){handle=elemData.handle;if(handle){handle.elem=null}jQuery.removeData(elem,["events","handle"],true)}},customEvent:{getData:true,setData:true,changeData:true},trigger:function(event,data,elem,onlyHandlers){if(elem&&(elem.nodeType===3||elem.nodeType===8)){return }var type=event.type||event,namespaces=[],cache,exclusive,i,cur,old,ontype,special,handle,eventPath,bubbleType;if(type.indexOf("!")>=0){type=type.slice(0,-1);exclusive=true}if(type.indexOf(".")>=0){namespaces=type.split(".");type=namespaces.shift();namespaces.sort()}if((!elem||jQuery.event.customEvent[type])&&!jQuery.event.global[type]){return }event=typeof event==="object"?event[jQuery.expando]?event:new jQuery.Event(type,event):new jQuery.Event(type);event.type=type;event.isTrigger=true;event.exclusive=exclusive;event.namespace=namespaces.join(".");event.namespace_re=event.namespace?new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.)?")+"(\\.|$)"):null;ontype=type.indexOf(":")<0?"on"+type:"";if(onlyHandlers||!elem){event.preventDefault()}if(!elem){cache=jQuery.cache;for(i in cache){if(cache[i].events&&cache[i].events[type]){jQuery.event.trigger(event,data,cache[i].handle.elem,true)}}return }event.result=undefined;if(!event.target){event.target=elem}data=data!=null?jQuery.makeArray(data):[];data.unshift(event);special=jQuery.event.special[type]||{};if(special.trigger&&special.trigger.apply(elem,data)===false){return }eventPath=[[elem,special.bindType||type]];if(!onlyHandlers&&!special.noBubble&&!jQuery.isWindow(elem)){bubbleType=special.delegateType||type;old=null;for(cur=elem.parentNode;cur;cur=cur.parentNode){eventPath.push([cur,bubbleType]);old=cur}if(old&&old===elem.ownerDocument){eventPath.push([old.defaultView||old.parentWindow||window,bubbleType])}}for(i=0;i<eventPath.length;i++){cur=eventPath[i][0];event.type=eventPath[i][1];handle=(jQuery._data(cur,"events")||{})[event.type]&&jQuery._data(cur,"handle");if(handle){handle.apply(cur,data)}handle=ontype&&cur[ontype];if(handle&&jQuery.acceptData(cur)){handle.apply(cur,data)}if(event.isPropagationStopped()){break}}event.type=type;if(!event.isDefaultPrevented()){if((!special._default||special._default.apply(elem.ownerDocument,data)===false)&&!(type==="click"&&jQuery.nodeName(elem,"a"))&&jQuery.acceptData(elem)){if(ontype&&elem[type]&&((type!=="focus"&&type!=="blur")||event.target.offsetWidth!==0)&&!jQuery.isWindow(elem)){old=elem[ontype];if(old){elem[ontype]=null}jQuery.event.triggered=type;elem[type]();jQuery.event.triggered=undefined;if(old){elem[ontype]=old}}}}return event.result},dispatch:function(event){event=jQuery.event.fix(event||window.event);var handlers=((jQuery._data(this,"events")||{})[event.type]||[]),delegateCount=handlers.delegateCount,args=[].slice.call(arguments,0),run_all=!event.exclusive&&!event.namespace,specialHandle=(jQuery.event.special[event.type]||{}).handle,handlerQueue=[],i,j,cur,ret,selMatch,matched,matches,handleObj,sel,hit,related;args[0]=event;event.delegateTarget=this;if(delegateCount&&!event.target.disabled&&!(event.button&&event.type==="click")){for(cur=event.target;cur!=this;cur=cur.parentNode||this){selMatch={};matches=[];for(i=0;i<delegateCount;i++){handleObj=handlers[i];sel=handleObj.selector;hit=selMatch[sel];if(handleObj.isPositional){hit=(hit||(selMatch[sel]=jQuery(sel))).index(cur)>=0}else{if(hit===undefined){hit=selMatch[sel]=(handleObj.quick?quickIs(cur,handleObj.quick):jQuery(cur).is(sel))}}if(hit){matches.push(handleObj)}}if(matches.length){handlerQueue.push({elem:cur,matches:matches})}}}if(handlers.length>delegateCount){handlerQueue.push({elem:this,matches:handlers.slice(delegateCount)})}for(i=0;i<handlerQueue.length&&!event.isPropagationStopped();i++){matched=handlerQueue[i];event.currentTarget=matched.elem;for(j=0;j<matched.matches.length&&!event.isImmediatePropagationStopped();j++){handleObj=matched.matches[j];if(run_all||(!event.namespace&&!handleObj.namespace)||event.namespace_re&&event.namespace_re.test(handleObj.namespace)){event.data=handleObj.data;event.handleObj=handleObj;ret=(specialHandle||handleObj.handler).apply(matched.elem,args);if(ret!==undefined){event.result=ret;if(ret===false){event.preventDefault();event.stopPropagation()}}}}}return event.result},props:"attrChange attrName relatedNode srcElement altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(event,original){if(event.which==null){event.which=original.charCode!=null?original.charCode:original.keyCode}return event}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement wheelDelta".split(" "),filter:function(event,original){var eventDoc,doc,body,button=original.button,fromElement=original.fromElement;if(event.pageX==null&&original.clientX!=null){eventDoc=event.target.ownerDocument||document;doc=eventDoc.documentElement;body=eventDoc.body;event.pageX=original.clientX+(doc&&doc.scrollLeft||body&&body.scrollLeft||0)-(doc&&doc.clientLeft||body&&body.clientLeft||0);event.pageY=original.clientY+(doc&&doc.scrollTop||body&&body.scrollTop||0)-(doc&&doc.clientTop||body&&body.clientTop||0)}if(!event.relatedTarget&&fromElement){event.relatedTarget=fromElement===event.target?original.toElement:fromElement}if(!event.which&&button!==undefined){event.which=(button&1?1:(button&2?3:(button&4?2:0)))}return event}},fix:function(event){if(event[jQuery.expando]){return event}var i,prop,originalEvent=event,fixHook=jQuery.event.fixHooks[event.type]||{},copy=fixHook.props?this.props.concat(fixHook.props):this.props;event=jQuery.Event(originalEvent);for(i=copy.length;i;){prop=copy[--i];event[prop]=originalEvent[prop]}if(!event.target){event.target=originalEvent.srcElement||document}if(event.target.nodeType===3){event.target=event.target.parentNode}if(event.metaKey===undefined){event.metaKey=event.ctrlKey}return fixHook.filter?fixHook.filter(event,originalEvent):event},special:{ready:{setup:jQuery.bindReady},focus:{delegateType:"focusin",noBubble:true},blur:{delegateType:"focusout",noBubble:true},beforeunload:{setup:function(data,namespaces,eventHandle){if(jQuery.isWindow(this)){this.onbeforeunload=eventHandle}},teardown:function(namespaces,eventHandle){if(this.onbeforeunload===eventHandle){this.onbeforeunload=null}}}},simulate:function(type,elem,event,bubble){var e=jQuery.extend(new jQuery.Event(),event,{type:type,isSimulated:true,originalEvent:{}});if(bubble){jQuery.event.trigger(e,null,elem)}else{jQuery.event.dispatch.call(elem,e)}if(e.isDefaultPrevented()){event.preventDefault()}}};jQuery.event.handle=jQuery.event.dispatch;jQuery.removeEvent=document.removeEventListener?function(elem,type,handle){if(elem.removeEventListener){elem.removeEventListener(type,handle,false)}}:function(elem,type,handle){if(elem.detachEvent){elem.detachEvent("on"+type,handle)}};jQuery.Event=function(src,props){if(!(this instanceof jQuery.Event)){return new jQuery.Event(src,props)}if(src&&src.type){this.originalEvent=src;this.type=src.type;this.isDefaultPrevented=(src.defaultPrevented||src.returnValue===false||src.getPreventDefault&&src.getPreventDefault())?returnTrue:returnFalse}else{this.type=src}if(props){jQuery.extend(this,props)}this.timeStamp=src&&src.timeStamp||jQuery.now();this[jQuery.expando]=true};function returnFalse(){return false}function returnTrue(){return true}jQuery.Event.prototype={preventDefault:function(){this.isDefaultPrevented=returnTrue;var e=this.originalEvent;if(!e){return }if(e.preventDefault){e.preventDefault()}else{e.returnValue=false}},stopPropagation:function(){this.isPropagationStopped=returnTrue;var e=this.originalEvent;if(!e){return }if(e.stopPropagation){e.stopPropagation()}e.cancelBubble=true},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=returnTrue;this.stopPropagation()},isDefaultPrevented:returnFalse,isPropagationStopped:returnFalse,isImmediatePropagationStopped:returnFalse};jQuery.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(orig,fix){jQuery.event.special[orig]=jQuery.event.special[fix]={delegateType:fix,bindType:fix,handle:function(event){var target=this,related=event.relatedTarget,handleObj=event.handleObj,selector=handleObj.selector,oldType,ret;if(!related||handleObj.origType===event.type||(related!==target&&!jQuery.contains(target,related))){oldType=event.type;event.type=handleObj.origType;ret=handleObj.handler.apply(this,arguments);event.type=oldType}return ret}}});if(!jQuery.support.submitBubbles){jQuery.event.special.submit={setup:function(){if(jQuery.nodeName(this,"form")){return false}jQuery.event.add(this,"click._submit keypress._submit",function(e){var elem=e.target,form=jQuery.nodeName(elem,"input")||jQuery.nodeName(elem,"button")?elem.form:undefined;if(form&&!form._submit_attached){jQuery.event.add(form,"submit._submit",function(event){if(this.parentNode){jQuery.event.simulate("submit",this.parentNode,event,true)}});form._submit_attached=true}})},teardown:function(){if(jQuery.nodeName(this,"form")){return false}jQuery.event.remove(this,"._submit")}}}if(!jQuery.support.changeBubbles){jQuery.event.special.change={setup:function(){if(rformElems.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio"){jQuery.event.add(this,"propertychange._change",function(event){if(event.originalEvent.propertyName==="checked"){this._just_changed=true}});jQuery.event.add(this,"click._change",function(event){if(this._just_changed){this._just_changed=false;jQuery.event.simulate("change",this,event,true)}})}return false}jQuery.event.add(this,"beforeactivate._change",function(e){var elem=e.target;if(rformElems.test(elem.nodeName)&&!elem._change_attached){jQuery.event.add(elem,"change._change",function(event){if(this.parentNode&&!event.isSimulated){jQuery.event.simulate("change",this.parentNode,event,true)}});elem._change_attached=true}})},handle:function(event){var elem=event.target;if(this!==elem||event.isSimulated||event.isTrigger||(elem.type!=="radio"&&elem.type!=="checkbox")){return event.handleObj.handler.apply(this,arguments)}},teardown:function(){jQuery.event.remove(this,"._change");return rformElems.test(this.nodeName)}}}if(!jQuery.support.focusinBubbles){jQuery.each({focus:"focusin",blur:"focusout"},function(orig,fix){var attaches=0,handler=function(event){jQuery.event.simulate(fix,event.target,jQuery.event.fix(event),true)};jQuery.event.special[fix]={setup:function(){if(attaches++===0){document.addEventListener(orig,handler,true)}},teardown:function(){if(--attaches===0){document.removeEventListener(orig,handler,true)}}}})}jQuery.fn.extend({on:function(types,selector,data,fn,one){var origFn,type;if(typeof types==="object"){if(typeof selector!=="string"){data=selector;selector=undefined}for(type in types){this.on(type,selector,data,types[type],one)}return this}if(data==null&&fn==null){fn=selector;data=selector=undefined}else{if(fn==null){if(typeof selector==="string"){fn=data;data=undefined}else{fn=data;data=selector;selector=undefined}}}if(fn===false){fn=returnFalse}else{if(!fn){return this}}if(one===1){origFn=fn;fn=function(event){jQuery().off(event);return origFn.apply(this,arguments)};fn.guid=origFn.guid||(origFn.guid=jQuery.guid++)}return this.each(function(){jQuery.event.add(this,types,fn,data,selector)})},one:function(types,selector,data,fn){return this.on.call(this,types,selector,data,fn,1)},off:function(types,selector,fn){if(types&&types.preventDefault&&types.handleObj){var handleObj=types.handleObj;jQuery(types.delegateTarget).off(handleObj.namespace?handleObj.type+"."+handleObj.namespace:handleObj.type,handleObj.selector,handleObj.handler);return this}if(typeof types==="object"){for(var type in types){this.off(type,selector,types[type])}return this}if(selector===false||typeof selector==="function"){fn=selector;selector=undefined}if(fn===false){fn=returnFalse}return this.each(function(){jQuery.event.remove(this,types,fn,selector)})},bind:function(types,data,fn){return this.on(types,null,data,fn)},unbind:function(types,fn){return this.off(types,null,fn)},live:function(types,data,fn){jQuery(this.context).on(types,this.selector,data,fn);return this},die:function(types,fn){jQuery(this.context).off(types,this.selector||"**",fn);return this},delegate:function(selector,types,data,fn){return this.on(types,selector,data,fn)},undelegate:function(selector,types,fn){return arguments.length==1?this.off(selector,"**"):this.off(types,selector,fn)},trigger:function(type,data){return this.each(function(){jQuery.event.trigger(type,data,this)})},triggerHandler:function(type,data){if(this[0]){return jQuery.event.trigger(type,data,this[0],true)}},toggle:function(fn){var args=arguments,guid=fn.guid||jQuery.guid++,i=0,toggler=function(event){var lastToggle=(jQuery._data(this,"lastToggle"+fn.guid)||0)%i;jQuery._data(this,"lastToggle"+fn.guid,lastToggle+1);event.preventDefault();return args[lastToggle].apply(this,arguments)||false};toggler.guid=guid;while(i<args.length){args[i++].guid=guid}return this.click(toggler)},hover:function(fnOver,fnOut){return this.mouseenter(fnOver).mouseleave(fnOut||fnOver)}});jQuery.each(("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu").split(" "),function(i,name){jQuery.fn[name]=function(data,fn){if(fn==null){fn=data;data=null}return arguments.length>0?this.bind(name,data,fn):this.trigger(name)};if(jQuery.attrFn){jQuery.attrFn[name]=true}if(rkeyEvent.test(name)){jQuery.event.fixHooks[name]=jQuery.event.keyHooks}if(rmouseEvent.test(name)){jQuery.event.fixHooks[name]=jQuery.event.mouseHooks}});
/*
 * Sizzle CSS Selector Engine
 *  Copyright 2011, The Dojo Foundation
 *  Released under the MIT, BSD, and GPL Licenses.
 *  More information: http://sizzlejs.com/
 */
(function(){var chunker=/((?:\((?:\([^()]+\)|[^()]+)+\)|\[(?:\[[^\[\]]*\]|['"][^'"]*['"]|[^\[\]'"]+)+\]|\\.|[^ >+~,(\[\\]+)+|[>+~])(\s*,\s*)?((?:.|\r|\n)*)/g,expando="sizcache"+(Math.random()+"").replace(".",""),done=0,toString=Object.prototype.toString,hasDuplicate=false,baseHasDuplicate=true,rBackslash=/\\/g,rReturn=/\r\n/g,rNonWord=/\W/;[0,0].sort(function(){baseHasDuplicate=false;return 0});var Sizzle=function(selector,context,results,seed){results=results||[];context=context||document;var origContext=context;if(context.nodeType!==1&&context.nodeType!==9){return[]}if(!selector||typeof selector!=="string"){return results}var m,set,checkSet,extra,ret,cur,pop,i,prune=true,contextXML=Sizzle.isXML(context),parts=[],soFar=selector;do{chunker.exec("");m=chunker.exec(soFar);if(m){soFar=m[3];parts.push(m[1]);if(m[2]){extra=m[3];break}}}while(m);if(parts.length>1&&origPOS.exec(selector)){if(parts.length===2&&Expr.relative[parts[0]]){set=posProcess(parts[0]+parts[1],context,seed)}else{set=Expr.relative[parts[0]]?[context]:Sizzle(parts.shift(),context);while(parts.length){selector=parts.shift();if(Expr.relative[selector]){selector+=parts.shift()}set=posProcess(selector,set,seed)}}}else{if(!seed&&parts.length>1&&context.nodeType===9&&!contextXML&&Expr.match.ID.test(parts[0])&&!Expr.match.ID.test(parts[parts.length-1])){ret=Sizzle.find(parts.shift(),context,contextXML);context=ret.expr?Sizzle.filter(ret.expr,ret.set)[0]:ret.set[0]}if(context){ret=seed?{expr:parts.pop(),set:makeArray(seed)}:Sizzle.find(parts.pop(),parts.length===1&&(parts[0]==="~"||parts[0]==="+")&&context.parentNode?context.parentNode:context,contextXML);set=ret.expr?Sizzle.filter(ret.expr,ret.set):ret.set;if(parts.length>0){checkSet=makeArray(set)}else{prune=false}while(parts.length){cur=parts.pop();pop=cur;if(!Expr.relative[cur]){cur=""}else{pop=parts.pop()}if(pop==null){pop=context}Expr.relative[cur](checkSet,pop,contextXML)}}else{checkSet=parts=[]}}if(!checkSet){checkSet=set}if(!checkSet){Sizzle.error(cur||selector)}if(toString.call(checkSet)==="[object Array]"){if(!prune){results.push.apply(results,checkSet)}else{if(context&&context.nodeType===1){for(i=0;checkSet[i]!=null;i++){if(checkSet[i]&&(checkSet[i]===true||checkSet[i].nodeType===1&&Sizzle.contains(context,checkSet[i]))){results.push(set[i])}}}else{for(i=0;checkSet[i]!=null;i++){if(checkSet[i]&&checkSet[i].nodeType===1){results.push(set[i])}}}}}else{makeArray(checkSet,results)}if(extra){Sizzle(extra,origContext,results,seed);Sizzle.uniqueSort(results)}return results};Sizzle.uniqueSort=function(results){if(sortOrder){hasDuplicate=baseHasDuplicate;results.sort(sortOrder);if(hasDuplicate){for(var i=1;i<results.length;i++){if(results[i]===results[i-1]){results.splice(i--,1)}}}}return results};Sizzle.matches=function(expr,set){return Sizzle(expr,null,null,set)};Sizzle.matchesSelector=function(node,expr){return Sizzle(expr,null,null,[node]).length>0};Sizzle.find=function(expr,context,isXML){var set,i,len,match,type,left;if(!expr){return[]}for(i=0,len=Expr.order.length;i<len;i++){type=Expr.order[i];if((match=Expr.leftMatch[type].exec(expr))){left=match[1];match.splice(1,1);if(left.substr(left.length-1)!=="\\"){match[1]=(match[1]||"").replace(rBackslash,"");set=Expr.find[type](match,context,isXML);if(set!=null){expr=expr.replace(Expr.match[type],"");break}}}}if(!set){set=typeof context.getElementsByTagName!=="undefined"?context.getElementsByTagName("*"):[]}return{set:set,expr:expr}};Sizzle.filter=function(expr,set,inplace,not){var match,anyFound,type,found,item,filter,left,i,pass,old=expr,result=[],curLoop=set,isXMLFilter=set&&set[0]&&Sizzle.isXML(set[0]);while(expr&&set.length){for(type in Expr.filter){if((match=Expr.leftMatch[type].exec(expr))!=null&&match[2]){filter=Expr.filter[type];left=match[1];anyFound=false;match.splice(1,1);if(left.substr(left.length-1)==="\\"){continue}if(curLoop===result){result=[]}if(Expr.preFilter[type]){match=Expr.preFilter[type](match,curLoop,inplace,result,not,isXMLFilter);if(!match){anyFound=found=true}else{if(match===true){continue}}}if(match){for(i=0;(item=curLoop[i])!=null;i++){if(item){found=filter(item,match,i,curLoop);pass=not^found;if(inplace&&found!=null){if(pass){anyFound=true}else{curLoop[i]=false}}else{if(pass){result.push(item);anyFound=true}}}}}if(found!==undefined){if(!inplace){curLoop=result}expr=expr.replace(Expr.match[type],"");if(!anyFound){return[]}break}}}if(expr===old){if(anyFound==null){Sizzle.error(expr)}else{break}}old=expr}return curLoop};Sizzle.error=function(msg){throw"Syntax error, unrecognized expression: "+msg};var getText=Sizzle.getText=function(elem){var i,node,nodeType=elem.nodeType,ret="";if(nodeType){if(nodeType===1){if(typeof elem.textContent==="string"){return elem.textContent}else{if(typeof elem.innerText==="string"){return elem.innerText.replace(rReturn,"")}else{for(elem=elem.firstChild;elem;elem=elem.nextSibling){ret+=getText(elem)}}}}else{if(nodeType===3||nodeType===4){return elem.nodeValue}}}else{for(i=0;(node=elem[i]);i++){if(node.nodeType!==8){ret+=getText(node)}}}return ret};var Expr=Sizzle.selectors={order:["ID","NAME","TAG"],match:{ID:/#((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,CLASS:/\.((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,NAME:/\[name=['"]*((?:[\w\u00c0-\uFFFF\-]|\\.)+)['"]*\]/,ATTR:/\[\s*((?:[\w\u00c0-\uFFFF\-]|\\.)+)\s*(?:(\S?=)\s*(?:(['"])(.*?)\3|(#?(?:[\w\u00c0-\uFFFF\-]|\\.)*)|)|)\s*\]/,TAG:/^((?:[\w\u00c0-\uFFFF\*\-]|\\.)+)/,CHILD:/:(only|nth|last|first)-child(?:\(\s*(even|odd|(?:[+\-]?\d+|(?:[+\-]?\d*)?n\s*(?:[+\-]\s*\d+)?))\s*\))?/,POS:/:(nth|eq|gt|lt|first|last|even|odd)(?:\((\d*)\))?(?=[^\-]|$)/,PSEUDO:/:((?:[\w\u00c0-\uFFFF\-]|\\.)+)(?:\((['"]?)((?:\([^\)]+\)|[^\(\)]*)+)\2\))?/},leftMatch:{},attrMap:{"class":"className","for":"htmlFor"},attrHandle:{href:function(elem){return elem.getAttribute("href")},type:function(elem){return elem.getAttribute("type")}},relative:{"+":function(checkSet,part){var isPartStr=typeof part==="string",isTag=isPartStr&&!rNonWord.test(part),isPartStrNotTag=isPartStr&&!isTag;if(isTag){part=part.toLowerCase()}for(var i=0,l=checkSet.length,elem;i<l;i++){if((elem=checkSet[i])){while((elem=elem.previousSibling)&&elem.nodeType!==1){}checkSet[i]=isPartStrNotTag||elem&&elem.nodeName.toLowerCase()===part?elem||false:elem===part}}if(isPartStrNotTag){Sizzle.filter(part,checkSet,true)}},">":function(checkSet,part){var elem,isPartStr=typeof part==="string",i=0,l=checkSet.length;if(isPartStr&&!rNonWord.test(part)){part=part.toLowerCase();for(;i<l;i++){elem=checkSet[i];if(elem){var parent=elem.parentNode;checkSet[i]=parent.nodeName.toLowerCase()===part?parent:false}}}else{for(;i<l;i++){elem=checkSet[i];if(elem){checkSet[i]=isPartStr?elem.parentNode:elem.parentNode===part}}if(isPartStr){Sizzle.filter(part,checkSet,true)}}},"":function(checkSet,part,isXML){var nodeCheck,doneName=done++,checkFn=dirCheck;if(typeof part==="string"&&!rNonWord.test(part)){part=part.toLowerCase();nodeCheck=part;checkFn=dirNodeCheck}checkFn("parentNode",part,doneName,checkSet,nodeCheck,isXML)},"~":function(checkSet,part,isXML){var nodeCheck,doneName=done++,checkFn=dirCheck;if(typeof part==="string"&&!rNonWord.test(part)){part=part.toLowerCase();nodeCheck=part;checkFn=dirNodeCheck}checkFn("previousSibling",part,doneName,checkSet,nodeCheck,isXML)}},find:{ID:function(match,context,isXML){if(typeof context.getElementById!=="undefined"&&!isXML){var m=context.getElementById(match[1]);return m&&m.parentNode?[m]:[]}},NAME:function(match,context){if(typeof context.getElementsByName!=="undefined"){var ret=[],results=context.getElementsByName(match[1]);for(var i=0,l=results.length;i<l;i++){if(results[i].getAttribute("name")===match[1]){ret.push(results[i])}}return ret.length===0?null:ret}},TAG:function(match,context){if(typeof context.getElementsByTagName!=="undefined"){return context.getElementsByTagName(match[1])}}},preFilter:{CLASS:function(match,curLoop,inplace,result,not,isXML){match=" "+match[1].replace(rBackslash,"")+" ";if(isXML){return match}for(var i=0,elem;(elem=curLoop[i])!=null;i++){if(elem){if(not^(elem.className&&(" "+elem.className+" ").replace(/[\t\n\r]/g," ").indexOf(match)>=0)){if(!inplace){result.push(elem)}}else{if(inplace){curLoop[i]=false}}}}return false},ID:function(match){return match[1].replace(rBackslash,"")},TAG:function(match,curLoop){return match[1].replace(rBackslash,"").toLowerCase()},CHILD:function(match){if(match[1]==="nth"){if(!match[2]){Sizzle.error(match[0])}match[2]=match[2].replace(/^\+|\s*/g,"");var test=/(-?)(\d*)(?:n([+\-]?\d*))?/.exec(match[2]==="even"&&"2n"||match[2]==="odd"&&"2n+1"||!/\D/.test(match[2])&&"0n+"+match[2]||match[2]);match[2]=(test[1]+(test[2]||1))-0;match[3]=test[3]-0}else{if(match[2]){Sizzle.error(match[0])}}match[0]=done++;return match},ATTR:function(match,curLoop,inplace,result,not,isXML){var name=match[1]=match[1].replace(rBackslash,"");if(!isXML&&Expr.attrMap[name]){match[1]=Expr.attrMap[name]}match[4]=(match[4]||match[5]||"").replace(rBackslash,"");if(match[2]==="~="){match[4]=" "+match[4]+" "}return match},PSEUDO:function(match,curLoop,inplace,result,not){if(match[1]==="not"){if((chunker.exec(match[3])||"").length>1||/^\w/.test(match[3])){match[3]=Sizzle(match[3],null,null,curLoop)}else{var ret=Sizzle.filter(match[3],curLoop,inplace,true^not);if(!inplace){result.push.apply(result,ret)}return false}}else{if(Expr.match.POS.test(match[0])||Expr.match.CHILD.test(match[0])){return true}}return match},POS:function(match){match.unshift(true);return match}},filters:{enabled:function(elem){return elem.disabled===false&&elem.type!=="hidden"},disabled:function(elem){return elem.disabled===true},checked:function(elem){return elem.checked===true},selected:function(elem){if(elem.parentNode){elem.parentNode.selectedIndex}return elem.selected===true},parent:function(elem){return !!elem.firstChild},empty:function(elem){return !elem.firstChild},has:function(elem,i,match){return !!Sizzle(match[3],elem).length},header:function(elem){return(/h\d/i).test(elem.nodeName)},text:function(elem){var attr=elem.getAttribute("type"),type=elem.type;return elem.nodeName.toLowerCase()==="input"&&"text"===type&&(attr===type||attr===null)},radio:function(elem){return elem.nodeName.toLowerCase()==="input"&&"radio"===elem.type},checkbox:function(elem){return elem.nodeName.toLowerCase()==="input"&&"checkbox"===elem.type},file:function(elem){return elem.nodeName.toLowerCase()==="input"&&"file"===elem.type},password:function(elem){return elem.nodeName.toLowerCase()==="input"&&"password"===elem.type},submit:function(elem){var name=elem.nodeName.toLowerCase();return(name==="input"||name==="button")&&"submit"===elem.type},image:function(elem){return elem.nodeName.toLowerCase()==="input"&&"image"===elem.type},reset:function(elem){var name=elem.nodeName.toLowerCase();return(name==="input"||name==="button")&&"reset"===elem.type},button:function(elem){var name=elem.nodeName.toLowerCase();return name==="input"&&"button"===elem.type||name==="button"},input:function(elem){return(/input|select|textarea|button/i).test(elem.nodeName)},focus:function(elem){return elem===elem.ownerDocument.activeElement}},setFilters:{first:function(elem,i){return i===0},last:function(elem,i,match,array){return i===array.length-1},even:function(elem,i){return i%2===0},odd:function(elem,i){return i%2===1},lt:function(elem,i,match){return i<match[3]-0},gt:function(elem,i,match){return i>match[3]-0},nth:function(elem,i,match){return match[3]-0===i},eq:function(elem,i,match){return match[3]-0===i}},filter:{PSEUDO:function(elem,match,i,array){var name=match[1],filter=Expr.filters[name];if(filter){return filter(elem,i,match,array)}else{if(name==="contains"){return(elem.textContent||elem.innerText||getText([elem])||"").indexOf(match[3])>=0}else{if(name==="not"){var not=match[3];for(var j=0,l=not.length;j<l;j++){if(not[j]===elem){return false}}return true}else{Sizzle.error(name)}}}},CHILD:function(elem,match){var first,last,doneName,parent,cache,count,diff,type=match[1],node=elem;switch(type){case"only":case"first":while((node=node.previousSibling)){if(node.nodeType===1){return false}}if(type==="first"){return true}node=elem;case"last":while((node=node.nextSibling)){if(node.nodeType===1){return false}}return true;case"nth":first=match[2];last=match[3];if(first===1&&last===0){return true}doneName=match[0];parent=elem.parentNode;if(parent&&(parent[expando]!==doneName||!elem.nodeIndex)){count=0;for(node=parent.firstChild;node;node=node.nextSibling){if(node.nodeType===1){node.nodeIndex=++count}}parent[expando]=doneName}diff=elem.nodeIndex-last;if(first===0){return diff===0}else{return(diff%first===0&&diff/first>=0)}}},ID:function(elem,match){return elem.nodeType===1&&elem.getAttribute("id")===match},TAG:function(elem,match){return(match==="*"&&elem.nodeType===1)||!!elem.nodeName&&elem.nodeName.toLowerCase()===match},CLASS:function(elem,match){return(" "+(elem.className||elem.getAttribute("class"))+" ").indexOf(match)>-1},ATTR:function(elem,match){var name=match[1],result=Sizzle.attr?Sizzle.attr(elem,name):Expr.attrHandle[name]?Expr.attrHandle[name](elem):elem[name]!=null?elem[name]:elem.getAttribute(name),value=result+"",type=match[2],check=match[4];return result==null?type==="!=":!type&&Sizzle.attr?result!=null:type==="="?value===check:type==="*="?value.indexOf(check)>=0:type==="~="?(" "+value+" ").indexOf(check)>=0:!check?value&&result!==false:type==="!="?value!==check:type==="^="?value.indexOf(check)===0:type==="$="?value.substr(value.length-check.length)===check:type==="|="?value===check||value.substr(0,check.length+1)===check+"-":false},POS:function(elem,match,i,array){var name=match[2],filter=Expr.setFilters[name];if(filter){return filter(elem,i,match,array)}}}};var origPOS=Expr.match.POS,fescape=function(all,num){return"\\"+(num-0+1)};for(var type in Expr.match){Expr.match[type]=new RegExp(Expr.match[type].source+(/(?![^\[]*\])(?![^\(]*\))/.source));Expr.leftMatch[type]=new RegExp(/(^(?:.|\r|\n)*?)/.source+Expr.match[type].source.replace(/\\(\d+)/g,fescape))}var makeArray=function(array,results){array=Array.prototype.slice.call(array,0);if(results){results.push.apply(results,array);return results}return array};try{Array.prototype.slice.call(document.documentElement.childNodes,0)[0].nodeType}catch(e){makeArray=function(array,results){var i=0,ret=results||[];if(toString.call(array)==="[object Array]"){Array.prototype.push.apply(ret,array)}else{if(typeof array.length==="number"){for(var l=array.length;i<l;i++){ret.push(array[i])}}else{for(;array[i];i++){ret.push(array[i])}}}return ret}}var sortOrder,siblingCheck;if(document.documentElement.compareDocumentPosition){sortOrder=function(a,b){if(a===b){hasDuplicate=true;return 0}if(!a.compareDocumentPosition||!b.compareDocumentPosition){return a.compareDocumentPosition?-1:1}return a.compareDocumentPosition(b)&4?-1:1}}else{sortOrder=function(a,b){if(a===b){hasDuplicate=true;return 0}else{if(a.sourceIndex&&b.sourceIndex){return a.sourceIndex-b.sourceIndex}}var al,bl,ap=[],bp=[],aup=a.parentNode,bup=b.parentNode,cur=aup;if(aup===bup){return siblingCheck(a,b)}else{if(!aup){return -1}else{if(!bup){return 1}}}while(cur){ap.unshift(cur);cur=cur.parentNode}cur=bup;while(cur){bp.unshift(cur);cur=cur.parentNode}al=ap.length;bl=bp.length;for(var i=0;i<al&&i<bl;i++){if(ap[i]!==bp[i]){return siblingCheck(ap[i],bp[i])}}return i===al?siblingCheck(a,bp[i],-1):siblingCheck(ap[i],b,1)};siblingCheck=function(a,b,ret){if(a===b){return ret}var cur=a.nextSibling;while(cur){if(cur===b){return -1}cur=cur.nextSibling}return 1}}(function(){var form=document.createElement("div"),id="script"+(new Date()).getTime(),root=document.documentElement;form.innerHTML="<a name='"+id+"'/>";root.insertBefore(form,root.firstChild);if(document.getElementById(id)){Expr.find.ID=function(match,context,isXML){if(typeof context.getElementById!=="undefined"&&!isXML){var m=context.getElementById(match[1]);return m?m.id===match[1]||typeof m.getAttributeNode!=="undefined"&&m.getAttributeNode("id").nodeValue===match[1]?[m]:undefined:[]}};Expr.filter.ID=function(elem,match){var node=typeof elem.getAttributeNode!=="undefined"&&elem.getAttributeNode("id");return elem.nodeType===1&&node&&node.nodeValue===match}}root.removeChild(form);root=form=null})();(function(){var div=document.createElement("div");div.appendChild(document.createComment(""));if(div.getElementsByTagName("*").length>0){Expr.find.TAG=function(match,context){var results=context.getElementsByTagName(match[1]);if(match[1]==="*"){var tmp=[];for(var i=0;results[i];i++){if(results[i].nodeType===1){tmp.push(results[i])}}results=tmp}return results}}div.innerHTML="<a href='#'></a>";if(div.firstChild&&typeof div.firstChild.getAttribute!=="undefined"&&div.firstChild.getAttribute("href")!=="#"){Expr.attrHandle.href=function(elem){return elem.getAttribute("href",2)}}div=null})();if(document.querySelectorAll){(function(){var oldSizzle=Sizzle,div=document.createElement("div"),id="__sizzle__";div.innerHTML="<p class='TEST'></p>";if(div.querySelectorAll&&div.querySelectorAll(".TEST").length===0){return }Sizzle=function(query,context,extra,seed){context=context||document;if(!seed&&!Sizzle.isXML(context)){var match=/^(\w+$)|^\.([\w\-]+$)|^#([\w\-]+$)/.exec(query);if(match&&(context.nodeType===1||context.nodeType===9)){if(match[1]){return makeArray(context.getElementsByTagName(query),extra)}else{if(match[2]&&Expr.find.CLASS&&context.getElementsByClassName){return makeArray(context.getElementsByClassName(match[2]),extra)}}}if(context.nodeType===9){if(query==="body"&&context.body){return makeArray([context.body],extra)}else{if(match&&match[3]){var elem=context.getElementById(match[3]);if(elem&&elem.parentNode){if(elem.id===match[3]){return makeArray([elem],extra)}}else{return makeArray([],extra)}}}try{return makeArray(context.querySelectorAll(query),extra)}catch(qsaError){}}else{if(context.nodeType===1&&context.nodeName.toLowerCase()!=="object"){var oldContext=context,old=context.getAttribute("id"),nid=old||id,hasParent=context.parentNode,relativeHierarchySelector=/^\s*[+~]/.test(query);if(!old){context.setAttribute("id",nid)}else{nid=nid.replace(/'/g,"\\$&")}if(relativeHierarchySelector&&hasParent){context=context.parentNode}try{if(!relativeHierarchySelector||hasParent){return makeArray(context.querySelectorAll("[id='"+nid+"'] "+query),extra)}}catch(pseudoError){}finally{if(!old){oldContext.removeAttribute("id")}}}}}return oldSizzle(query,context,extra,seed)};for(var prop in oldSizzle){Sizzle[prop]=oldSizzle[prop]}div=null})()}(function(){var html=document.documentElement,matches=html.matchesSelector||html.mozMatchesSelector||html.webkitMatchesSelector||html.msMatchesSelector;if(matches){var disconnectedMatch=!matches.call(document.createElement("div"),"div"),pseudoWorks=false;try{matches.call(document.documentElement,"[test!='']:sizzle")}catch(pseudoError){pseudoWorks=true}Sizzle.matchesSelector=function(node,expr){expr=expr.replace(/\=\s*([^'"\]]*)\s*\]/g,"='$1']");if(!Sizzle.isXML(node)){try{if(pseudoWorks||!Expr.match.PSEUDO.test(expr)&&!/!=/.test(expr)){var ret=matches.call(node,expr);if(ret||!disconnectedMatch||node.document&&node.document.nodeType!==11){return ret}}}catch(e){}}return Sizzle(expr,null,null,[node]).length>0}}})();(function(){var div=document.createElement("div");div.innerHTML="<div class='test e'></div><div class='test'></div>";if(!div.getElementsByClassName||div.getElementsByClassName("e").length===0){return }div.lastChild.className="e";if(div.getElementsByClassName("e").length===1){return }Expr.order.splice(1,0,"CLASS");Expr.find.CLASS=function(match,context,isXML){if(typeof context.getElementsByClassName!=="undefined"&&!isXML){return context.getElementsByClassName(match[1])}};div=null})();function dirNodeCheck(dir,cur,doneName,checkSet,nodeCheck,isXML){for(var i=0,l=checkSet.length;i<l;i++){var elem=checkSet[i];if(elem){var match=false;elem=elem[dir];while(elem){if(elem[expando]===doneName){match=checkSet[elem.sizset];break}if(elem.nodeType===1&&!isXML){elem[expando]=doneName;elem.sizset=i}if(elem.nodeName.toLowerCase()===cur){match=elem;break}elem=elem[dir]}checkSet[i]=match}}}function dirCheck(dir,cur,doneName,checkSet,nodeCheck,isXML){for(var i=0,l=checkSet.length;i<l;i++){var elem=checkSet[i];if(elem){var match=false;elem=elem[dir];while(elem){if(elem[expando]===doneName){match=checkSet[elem.sizset];break}if(elem.nodeType===1){if(!isXML){elem[expando]=doneName;elem.sizset=i}if(typeof cur!=="string"){if(elem===cur){match=true;break}}else{if(Sizzle.filter(cur,[elem]).length>0){match=elem;break}}}elem=elem[dir]}checkSet[i]=match}}}if(document.documentElement.contains){Sizzle.contains=function(a,b){return a!==b&&(a.contains?a.contains(b):true)}}else{if(document.documentElement.compareDocumentPosition){Sizzle.contains=function(a,b){return !!(a.compareDocumentPosition(b)&16)}}else{Sizzle.contains=function(){return false}}}Sizzle.isXML=function(elem){var documentElement=(elem?elem.ownerDocument||elem:0).documentElement;return documentElement?documentElement.nodeName!=="HTML":false};var posProcess=function(selector,context,seed){var match,tmpSet=[],later="",root=context.nodeType?[context]:context;while((match=Expr.match.PSEUDO.exec(selector))){later+=match[0];selector=selector.replace(Expr.match.PSEUDO,"")}selector=Expr.relative[selector]?selector+"*":selector;for(var i=0,l=root.length;i<l;i++){Sizzle(selector,root[i],tmpSet,seed)}return Sizzle.filter(later,tmpSet)};Sizzle.attr=jQuery.attr;Sizzle.selectors.attrMap={};jQuery.find=Sizzle;jQuery.expr=Sizzle.selectors;jQuery.expr[":"]=jQuery.expr.filters;jQuery.unique=Sizzle.uniqueSort;jQuery.text=Sizzle.getText;jQuery.isXMLDoc=Sizzle.isXML;jQuery.contains=Sizzle.contains})();var runtil=/Until$/,rparentsprev=/^(?:parents|prevUntil|prevAll)/,rmultiselector=/,/,isSimple=/^.[^:#\[\.,]*$/,slice=Array.prototype.slice,POS=jQuery.expr.match.POS,guaranteedUnique={children:true,contents:true,next:true,prev:true};jQuery.fn.extend({find:function(selector){var self=this,i,l;if(typeof selector!=="string"){return jQuery(selector).filter(function(){for(i=0,l=self.length;i<l;i++){if(jQuery.contains(self[i],this)){return true}}})}var ret=this.pushStack("","find",selector),length,n,r;for(i=0,l=this.length;i<l;i++){length=ret.length;jQuery.find(selector,this[i],ret);if(i>0){for(n=length;n<ret.length;n++){for(r=0;r<length;r++){if(ret[r]===ret[n]){ret.splice(n--,1);break}}}}}return ret},has:function(target){var targets=jQuery(target);return this.filter(function(){for(var i=0,l=targets.length;i<l;i++){if(jQuery.contains(this,targets[i])){return true}}})},not:function(selector){return this.pushStack(winnow(this,selector,false),"not",selector)},filter:function(selector){return this.pushStack(winnow(this,selector,true),"filter",selector)},is:function(selector){return !!selector&&(typeof selector==="string"?POS.test(selector)?jQuery(selector,this.context).index(this[0])>=0:jQuery.filter(selector,this).length>0:this.filter(selector).length>0)},closest:function(selectors,context){var ret=[],i,l,cur=this[0];if(jQuery.isArray(selectors)){var level=1;while(cur&&cur.ownerDocument&&cur!==context){for(i=0;i<selectors.length;i++){if(jQuery(cur).is(selectors[i])){ret.push({selector:selectors[i],elem:cur,level:level})}}cur=cur.parentNode;level++}return ret}var pos=POS.test(selectors)||typeof selectors!=="string"?jQuery(selectors,context||this.context):0;for(i=0,l=this.length;i<l;i++){cur=this[i];while(cur){if(pos?pos.index(cur)>-1:jQuery.find.matchesSelector(cur,selectors)){ret.push(cur);break}else{cur=cur.parentNode;if(!cur||!cur.ownerDocument||cur===context||cur.nodeType===11){break}}}}ret=ret.length>1?jQuery.unique(ret):ret;return this.pushStack(ret,"closest",selectors)},index:function(elem){if(!elem){return(this[0]&&this[0].parentNode)?this.prevAll().length:-1}if(typeof elem==="string"){return jQuery.inArray(this[0],jQuery(elem))}return jQuery.inArray(elem.jquery?elem[0]:elem,this)},add:function(selector,context){var set=typeof selector==="string"?jQuery(selector,context):jQuery.makeArray(selector&&selector.nodeType?[selector]:selector),all=jQuery.merge(this.get(),set);return this.pushStack(isDisconnected(set[0])||isDisconnected(all[0])?all:jQuery.unique(all))},andSelf:function(){return this.add(this.prevObject)}});function isDisconnected(node){return !node||!node.parentNode||node.parentNode.nodeType===11}jQuery.each({parent:function(elem){var parent=elem.parentNode;return parent&&parent.nodeType!==11?parent:null},parents:function(elem){return jQuery.dir(elem,"parentNode")},parentsUntil:function(elem,i,until){return jQuery.dir(elem,"parentNode",until)},next:function(elem){return jQuery.nth(elem,2,"nextSibling")},prev:function(elem){return jQuery.nth(elem,2,"previousSibling")},nextAll:function(elem){return jQuery.dir(elem,"nextSibling")},prevAll:function(elem){return jQuery.dir(elem,"previousSibling")},nextUntil:function(elem,i,until){return jQuery.dir(elem,"nextSibling",until)},prevUntil:function(elem,i,until){return jQuery.dir(elem,"previousSibling",until)},siblings:function(elem){return jQuery.sibling(elem.parentNode.firstChild,elem)},children:function(elem){return jQuery.sibling(elem.firstChild)},contents:function(elem){return jQuery.nodeName(elem,"iframe")?elem.contentDocument||elem.contentWindow.document:jQuery.makeArray(elem.childNodes)}},function(name,fn){jQuery.fn[name]=function(until,selector){var ret=jQuery.map(this,fn,until),args=slice.call(arguments);if(!runtil.test(name)){selector=until}if(selector&&typeof selector==="string"){ret=jQuery.filter(selector,ret)}ret=this.length>1&&!guaranteedUnique[name]?jQuery.unique(ret):ret;if((this.length>1||rmultiselector.test(selector))&&rparentsprev.test(name)){ret=ret.reverse()}return this.pushStack(ret,name,args.join(","))}});jQuery.extend({filter:function(expr,elems,not){if(not){expr=":not("+expr+")"}return elems.length===1?jQuery.find.matchesSelector(elems[0],expr)?[elems[0]]:[]:jQuery.find.matches(expr,elems)},dir:function(elem,dir,until){var matched=[],cur=elem[dir];while(cur&&cur.nodeType!==9&&(until===undefined||cur.nodeType!==1||!jQuery(cur).is(until))){if(cur.nodeType===1){matched.push(cur)}cur=cur[dir]}return matched},nth:function(cur,result,dir,elem){result=result||1;var num=0;for(;cur;cur=cur[dir]){if(cur.nodeType===1&&++num===result){break}}return cur},sibling:function(n,elem){var r=[];for(;n;n=n.nextSibling){if(n.nodeType===1&&n!==elem){r.push(n)}}return r}});function winnow(elements,qualifier,keep){qualifier=qualifier||0;if(jQuery.isFunction(qualifier)){return jQuery.grep(elements,function(elem,i){var retVal=!!qualifier.call(elem,i,elem);return retVal===keep})}else{if(qualifier.nodeType){return jQuery.grep(elements,function(elem,i){return(elem===qualifier)===keep})}else{if(typeof qualifier==="string"){var filtered=jQuery.grep(elements,function(elem){return elem.nodeType===1});if(isSimple.test(qualifier)){return jQuery.filter(qualifier,filtered,!keep)}else{qualifier=jQuery.filter(qualifier,filtered)}}}}return jQuery.grep(elements,function(elem,i){return(jQuery.inArray(elem,qualifier)>=0)===keep})}function createSafeFragment(document){var list=nodeNames.split(" "),safeFrag=document.createDocumentFragment();if(safeFrag.createElement){while(list.length){safeFrag.createElement(list.pop())}}return safeFrag}var nodeNames="abbr article aside audio canvas datalist details figcaption figure footer header hgroup mark meter nav output progress section summary time video",rinlinejQuery=/ jQuery\d+="(?:\d+|null)"/g,rleadingWhitespace=/^\s+/,rxhtmlTag=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/ig,rtagName=/<([\w:]+)/,rtbody=/<tbody/i,rhtml=/<|&#?\w+;/,rnoInnerhtml=/<(?:script|style)/i,rnocache=/<(?:script|object|embed|option|style)/i,rnoshimcache=new RegExp("<(?:"+nodeNames.replace(" ","|")+")","i"),rchecked=/checked\s*(?:[^=]|=\s*.checked.)/i,rscriptType=/\/(java|ecma)script/i,rcleanScript=/^\s*<!(?:\[CDATA\[|\-\-)/,wrapMap={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]},safeFragment=createSafeFragment(document);wrapMap.optgroup=wrapMap.option;wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead;wrapMap.th=wrapMap.td;if(!jQuery.support.htmlSerialize){wrapMap._default=[1,"div<div>","</div>"]}jQuery.fn.extend({text:function(text){if(jQuery.isFunction(text)){return this.each(function(i){var self=jQuery(this);self.text(text.call(this,i,self.text()))})}if(typeof text!=="object"&&text!==undefined){return this.empty().append((this[0]&&this[0].ownerDocument||document).createTextNode(text))}return jQuery.text(this)},wrapAll:function(html){if(jQuery.isFunction(html)){return this.each(function(i){jQuery(this).wrapAll(html.call(this,i))})}if(this[0]){var wrap=jQuery(html,this[0].ownerDocument).eq(0).clone(true);if(this[0].parentNode){wrap.insertBefore(this[0])}wrap.map(function(){var elem=this;while(elem.firstChild&&elem.firstChild.nodeType===1){elem=elem.firstChild}return elem}).append(this)}return this},wrapInner:function(html){if(jQuery.isFunction(html)){return this.each(function(i){jQuery(this).wrapInner(html.call(this,i))})}return this.each(function(){var self=jQuery(this),contents=self.contents();if(contents.length){contents.wrapAll(html)}else{self.append(html)}})},wrap:function(html){return this.each(function(){jQuery(this).wrapAll(html)})},unwrap:function(){return this.parent().each(function(){if(!jQuery.nodeName(this,"body")){jQuery(this).replaceWith(this.childNodes)}}).end()},append:function(){return this.domManip(arguments,true,function(elem){if(this.nodeType===1){this.appendChild(elem)}})},prepend:function(){return this.domManip(arguments,true,function(elem){if(this.nodeType===1){this.insertBefore(elem,this.firstChild)}})},before:function(){if(this[0]&&this[0].parentNode){return this.domManip(arguments,false,function(elem){this.parentNode.insertBefore(elem,this)})}else{if(arguments.length){var set=jQuery(arguments[0]);set.push.apply(set,this.toArray());return this.pushStack(set,"before",arguments)}}},after:function(){if(this[0]&&this[0].parentNode){return this.domManip(arguments,false,function(elem){this.parentNode.insertBefore(elem,this.nextSibling)})}else{if(arguments.length){var set=this.pushStack(this,"after",arguments);set.push.apply(set,jQuery(arguments[0]).toArray());return set}}},remove:function(selector,keepData){for(var i=0,elem;(elem=this[i])!=null;i++){if(!selector||jQuery.filter(selector,[elem]).length){if(!keepData&&elem.nodeType===1){jQuery.cleanData(elem.getElementsByTagName("*"));jQuery.cleanData([elem])}if(elem.parentNode){elem.parentNode.removeChild(elem)}}}return this},empty:function(){for(var i=0,elem;(elem=this[i])!=null;i++){if(elem.nodeType===1){jQuery.cleanData(elem.getElementsByTagName("*"))}while(elem.firstChild){elem.removeChild(elem.firstChild)}}return this},clone:function(dataAndEvents,deepDataAndEvents){dataAndEvents=dataAndEvents==null?false:dataAndEvents;deepDataAndEvents=deepDataAndEvents==null?dataAndEvents:deepDataAndEvents;return this.map(function(){return jQuery.clone(this,dataAndEvents,deepDataAndEvents)})},html:function(value){if(value===undefined){return this[0]&&this[0].nodeType===1?this[0].innerHTML.replace(rinlinejQuery,""):null}else{if(typeof value==="string"&&!rnoInnerhtml.test(value)&&(jQuery.support.leadingWhitespace||!rleadingWhitespace.test(value))&&!wrapMap[(rtagName.exec(value)||["",""])[1].toLowerCase()]){value=value.replace(rxhtmlTag,"<$1></$2>");try{for(var i=0,l=this.length;i<l;i++){if(this[i].nodeType===1){jQuery.cleanData(this[i].getElementsByTagName("*"));this[i].innerHTML=value}}}catch(e){this.empty().append(value)}}else{if(jQuery.isFunction(value)){this.each(function(i){var self=jQuery(this);self.html(value.call(this,i,self.html()))})}else{this.empty().append(value)}}}return this},replaceWith:function(value){if(this[0]&&this[0].parentNode){if(jQuery.isFunction(value)){return this.each(function(i){var self=jQuery(this),old=self.html();self.replaceWith(value.call(this,i,old))})}if(typeof value!=="string"){value=jQuery(value).detach()}return this.each(function(){var next=this.nextSibling,parent=this.parentNode;jQuery(this).remove();if(next){jQuery(next).before(value)}else{jQuery(parent).append(value)}})}else{return this.length?this.pushStack(jQuery(jQuery.isFunction(value)?value():value),"replaceWith",value):this}},detach:function(selector){return this.remove(selector,true)},domManip:function(args,table,callback){var results,first,fragment,parent,value=args[0],scripts=[];if(!jQuery.support.checkClone&&arguments.length===3&&typeof value==="string"&&rchecked.test(value)){return this.each(function(){jQuery(this).domManip(args,table,callback,true)})}if(jQuery.isFunction(value)){return this.each(function(i){var self=jQuery(this);args[0]=value.call(this,i,table?self.html():undefined);self.domManip(args,table,callback)})}if(this[0]){parent=value&&value.parentNode;if(jQuery.support.parentNode&&parent&&parent.nodeType===11&&parent.childNodes.length===this.length){results={fragment:parent}}else{results=jQuery.buildFragment(args,this,scripts)}fragment=results.fragment;if(fragment.childNodes.length===1){first=fragment=fragment.firstChild}else{first=fragment.firstChild}if(first){table=table&&jQuery.nodeName(first,"tr");for(var i=0,l=this.length,lastIndex=l-1;i<l;i++){callback.call(table?root(this[i],first):this[i],results.cacheable||(l>1&&i<lastIndex)?jQuery.clone(fragment,true,true):fragment)}}if(scripts.length){jQuery.each(scripts,evalScript)}}return this}});function root(elem,cur){return jQuery.nodeName(elem,"table")?(elem.getElementsByTagName("tbody")[0]||elem.appendChild(elem.ownerDocument.createElement("tbody"))):elem}function cloneCopyEvent(src,dest){if(dest.nodeType!==1||!jQuery.hasData(src)){return }var type,i,l,oldData=jQuery._data(src),curData=jQuery._data(dest,oldData),events=oldData.events;if(events){delete curData.handle;curData.events={};for(type in events){for(i=0,l=events[type].length;i<l;i++){jQuery.event.add(dest,type+(events[type][i].namespace?".":"")+events[type][i].namespace,events[type][i],events[type][i].data)}}}if(curData.data){curData.data=jQuery.extend({},curData.data)}}function cloneFixAttributes(src,dest){var nodeName;if(dest.nodeType!==1){return }if(dest.clearAttributes){dest.clearAttributes()}if(dest.mergeAttributes){dest.mergeAttributes(src)}nodeName=dest.nodeName.toLowerCase();if(nodeName==="object"){dest.outerHTML=src.outerHTML}else{if(nodeName==="input"&&(src.type==="checkbox"||src.type==="radio")){if(src.checked){dest.defaultChecked=dest.checked=src.checked}if(dest.value!==src.value){dest.value=src.value}}else{if(nodeName==="option"){dest.selected=src.defaultSelected}else{if(nodeName==="input"||nodeName==="textarea"){dest.defaultValue=src.defaultValue}}}}dest.removeAttribute(jQuery.expando)}jQuery.buildFragment=function(args,nodes,scripts){var fragment,cacheable,cacheresults,doc,first=args[0];if(nodes&&nodes[0]){doc=nodes[0].ownerDocument||nodes[0]}if(!doc.createDocumentFragment){doc=document}if(args.length===1&&typeof first==="string"&&first.length<512&&doc===document&&first.charAt(0)==="<"&&!rnocache.test(first)&&(jQuery.support.checkClone||!rchecked.test(first))&&(!jQuery.support.unknownElems&&rnoshimcache.test(first))){cacheable=true;cacheresults=jQuery.fragments[first];if(cacheresults&&cacheresults!==1){fragment=cacheresults}}if(!fragment){fragment=doc.createDocumentFragment();jQuery.clean(args,doc,fragment,scripts)}if(cacheable){jQuery.fragments[first]=cacheresults?fragment:1}return{fragment:fragment,cacheable:cacheable}};jQuery.fragments={};jQuery.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(name,original){jQuery.fn[name]=function(selector){var ret=[],insert=jQuery(selector),parent=this.length===1&&this[0].parentNode;if(parent&&parent.nodeType===11&&parent.childNodes.length===1&&insert.length===1){insert[original](this[0]);return this}else{for(var i=0,l=insert.length;i<l;i++){var elems=(i>0?this.clone(true):this).get();jQuery(insert[i])[original](elems);ret=ret.concat(elems)}return this.pushStack(ret,name,insert.selector)}}});function getAll(elem){if(typeof elem.getElementsByTagName!=="undefined"){return elem.getElementsByTagName("*")}else{if(typeof elem.querySelectorAll!=="undefined"){return elem.querySelectorAll("*")}else{return[]}}}function fixDefaultChecked(elem){if(elem.type==="checkbox"||elem.type==="radio"){elem.defaultChecked=elem.checked}}function findInputs(elem){var nodeName=(elem.nodeName||"").toLowerCase();if(nodeName==="input"){fixDefaultChecked(elem)}else{if(nodeName!=="script"&&typeof elem.getElementsByTagName!=="undefined"){jQuery.grep(elem.getElementsByTagName("input"),fixDefaultChecked)}}}jQuery.extend({clone:function(elem,dataAndEvents,deepDataAndEvents){var clone=elem.cloneNode(true),srcElements,destElements,i;if((!jQuery.support.noCloneEvent||!jQuery.support.noCloneChecked)&&(elem.nodeType===1||elem.nodeType===11)&&!jQuery.isXMLDoc(elem)){cloneFixAttributes(elem,clone);srcElements=getAll(elem);destElements=getAll(clone);for(i=0;srcElements[i];++i){if(destElements[i]){cloneFixAttributes(srcElements[i],destElements[i])}}}if(dataAndEvents){cloneCopyEvent(elem,clone);if(deepDataAndEvents){srcElements=getAll(elem);destElements=getAll(clone);for(i=0;srcElements[i];++i){cloneCopyEvent(srcElements[i],destElements[i])}}}srcElements=destElements=null;return clone},clean:function(elems,context,fragment,scripts){var checkScriptType;context=context||document;if(typeof context.createElement==="undefined"){context=context.ownerDocument||context[0]&&context[0].ownerDocument||document}var ret=[],j;for(var i=0,elem;(elem=elems[i])!=null;i++){if(typeof elem==="number"){elem+=""}if(!elem){continue}if(typeof elem==="string"){if(!rhtml.test(elem)){elem=context.createTextNode(elem)}else{elem=elem.replace(rxhtmlTag,"<$1></$2>");var tag=(rtagName.exec(elem)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,depth=wrap[0],div=context.createElement("div");if(context===document){safeFragment.appendChild(div)}else{createSafeFragment(context).appendChild(div)}div.innerHTML=wrap[1]+elem+wrap[2];while(depth--){div=div.lastChild}if(!jQuery.support.tbody){var hasBody=rtbody.test(elem),tbody=tag==="table"&&!hasBody?div.firstChild&&div.firstChild.childNodes:wrap[1]==="<table>"&&!hasBody?div.childNodes:[];for(j=tbody.length-1;j>=0;--j){if(jQuery.nodeName(tbody[j],"tbody")&&!tbody[j].childNodes.length){tbody[j].parentNode.removeChild(tbody[j])}}}if(!jQuery.support.leadingWhitespace&&rleadingWhitespace.test(elem)){div.insertBefore(context.createTextNode(rleadingWhitespace.exec(elem)[0]),div.firstChild)}elem=div.childNodes}}var len;if(!jQuery.support.appendChecked){if(elem[0]&&typeof (len=elem.length)==="number"){for(j=0;j<len;j++){findInputs(elem[j])}}else{findInputs(elem)}}if(elem.nodeType){ret.push(elem)}else{ret=jQuery.merge(ret,elem)}}if(fragment){checkScriptType=function(elem){return !elem.type||rscriptType.test(elem.type)};for(i=0;ret[i];i++){if(scripts&&jQuery.nodeName(ret[i],"script")&&(!ret[i].type||ret[i].type.toLowerCase()==="text/javascript")){scripts.push(ret[i].parentNode?ret[i].parentNode.removeChild(ret[i]):ret[i])}else{if(ret[i].nodeType===1){var jsTags=jQuery.grep(ret[i].getElementsByTagName("script"),checkScriptType);ret.splice.apply(ret,[i+1,0].concat(jsTags))}fragment.appendChild(ret[i])}}}return ret},cleanData:function(elems){var data,id,cache=jQuery.cache,special=jQuery.event.special,deleteExpando=jQuery.support.deleteExpando;for(var i=0,elem;(elem=elems[i])!=null;i++){if(elem.nodeName&&jQuery.noData[elem.nodeName.toLowerCase()]){continue}id=elem[jQuery.expando];if(id){data=cache[id];if(data&&data.events){for(var type in data.events){if(special[type]){jQuery.event.remove(elem,type)}else{jQuery.removeEvent(elem,type,data.handle)}}if(data.handle){data.handle.elem=null}}if(deleteExpando){delete elem[jQuery.expando]}else{if(elem.removeAttribute){elem.removeAttribute(jQuery.expando)}}delete cache[id]}}}});function evalScript(i,elem){if(elem.src){jQuery.ajax({url:elem.src,async:false,dataType:"script"})}else{jQuery.globalEval((elem.text||elem.textContent||elem.innerHTML||"").replace(rcleanScript,"/*$0*/"))}if(elem.parentNode){elem.parentNode.removeChild(elem)}}var ralpha=/alpha\([^)]*\)/i,ropacity=/opacity=([^)]*)/,rupper=/([A-Z]|^ms)/g,rnumpx=/^-?\d+(?:px)?$/i,rnum=/^-?\d/,rrelNum=/^([\-+])=([\-+.\de]+)/,cssShow={position:"absolute",visibility:"hidden",display:"block"},cssWidth=["Left","Right"],cssHeight=["Top","Bottom"],curCSS,getComputedStyle,currentStyle;jQuery.fn.css=function(name,value){if(arguments.length===2&&value===undefined){return this}return jQuery.access(this,name,value,true,function(elem,name,value){return value!==undefined?jQuery.style(elem,name,value):jQuery.css(elem,name)})};jQuery.extend({cssHooks:{opacity:{get:function(elem,computed){if(computed){var ret=curCSS(elem,"opacity","opacity");return ret===""?"1":ret}else{return elem.style.opacity}}}},cssNumber:{fillOpacity:true,fontWeight:true,lineHeight:true,opacity:true,orphans:true,widows:true,zIndex:true,zoom:true},cssProps:{"float":jQuery.support.cssFloat?"cssFloat":"styleFloat"},style:function(elem,name,value,extra){if(!elem||elem.nodeType===3||elem.nodeType===8||!elem.style){return }var ret,type,origName=jQuery.camelCase(name),style=elem.style,hooks=jQuery.cssHooks[origName];name=jQuery.cssProps[origName]||origName;if(value!==undefined){type=typeof value;if(type==="string"&&(ret=rrelNum.exec(value))){value=(+(ret[1]+1)*+ret[2])+parseFloat(jQuery.css(elem,name));type="number"}if(value==null||type==="number"&&isNaN(value)){return }if(type==="number"&&!jQuery.cssNumber[origName]){value+="px"}if(!hooks||!("set" in hooks)||(value=hooks.set(elem,value))!==undefined){try{style[name]=value}catch(e){}}}else{if(hooks&&"get" in hooks&&(ret=hooks.get(elem,false,extra))!==undefined){return ret}return style[name]}},css:function(elem,name,extra){var ret,hooks;name=jQuery.camelCase(name);hooks=jQuery.cssHooks[name];name=jQuery.cssProps[name]||name;if(name==="cssFloat"){name="float"}if(hooks&&"get" in hooks&&(ret=hooks.get(elem,true,extra))!==undefined){return ret}else{if(curCSS){return curCSS(elem,name)}}},swap:function(elem,options,callback){var old={};for(var name in options){old[name]=elem.style[name];elem.style[name]=options[name]}callback.call(elem);for(name in options){elem.style[name]=old[name]}}});jQuery.curCSS=jQuery.css;jQuery.each(["height","width"],function(i,name){jQuery.cssHooks[name]={get:function(elem,computed,extra){var val;if(computed){if(elem.offsetWidth!==0){return getWH(elem,name,extra)}else{jQuery.swap(elem,cssShow,function(){val=getWH(elem,name,extra)})}return val}},set:function(elem,value){if(rnumpx.test(value)){value=parseFloat(value);if(value>=0){return value+"px"}}else{return value}}}});if(!jQuery.support.opacity){jQuery.cssHooks.opacity={get:function(elem,computed){return ropacity.test((computed&&elem.currentStyle?elem.currentStyle.filter:elem.style.filter)||"")?(parseFloat(RegExp.$1)/100)+"":computed?"1":""},set:function(elem,value){var style=elem.style,currentStyle=elem.currentStyle,opacity=jQuery.isNumeric(value)?"alpha(opacity="+value*100+")":"",filter=currentStyle&&currentStyle.filter||style.filter||"";style.zoom=1;if(value>=1&&jQuery.trim(filter.replace(ralpha,""))===""){style.removeAttribute("filter");if(currentStyle&&!currentStyle.filter){return }}style.filter=ralpha.test(filter)?filter.replace(ralpha,opacity):filter+" "+opacity}}}jQuery(function(){if(!jQuery.support.reliableMarginRight){jQuery.cssHooks.marginRight={get:function(elem,computed){var ret;jQuery.swap(elem,{display:"inline-block"},function(){if(computed){ret=curCSS(elem,"margin-right","marginRight")}else{ret=elem.style.marginRight}});return ret}}}});if(document.defaultView&&document.defaultView.getComputedStyle){getComputedStyle=function(elem,name){var ret,defaultView,computedStyle;name=name.replace(rupper,"-$1").toLowerCase();if(!(defaultView=elem.ownerDocument.defaultView)){return undefined}if((computedStyle=defaultView.getComputedStyle(elem,null))){ret=computedStyle.getPropertyValue(name);if(ret===""&&!jQuery.contains(elem.ownerDocument.documentElement,elem)){ret=jQuery.style(elem,name)}}return ret}}if(document.documentElement.currentStyle){currentStyle=function(elem,name){var left,rsLeft,uncomputed,ret=elem.currentStyle&&elem.currentStyle[name],style=elem.style;if(ret===null&&style&&(uncomputed=style[name])){ret=uncomputed}if(!rnumpx.test(ret)&&rnum.test(ret)){left=style.left;rsLeft=elem.runtimeStyle&&elem.runtimeStyle.left;if(rsLeft){elem.runtimeStyle.left=elem.currentStyle.left}style.left=name==="fontSize"?"1em":(ret||0);ret=style.pixelLeft+"px";style.left=left;if(rsLeft){elem.runtimeStyle.left=rsLeft}}return ret===""?"auto":ret}}curCSS=getComputedStyle||currentStyle;function getWH(elem,name,extra){var val=name==="width"?elem.offsetWidth:elem.offsetHeight,which=name==="width"?cssWidth:cssHeight;if(val>0){if(extra!=="border"){jQuery.each(which,function(){if(!extra){val-=parseFloat(jQuery.css(elem,"padding"+this))||0}if(extra==="margin"){val+=parseFloat(jQuery.css(elem,extra+this))||0}else{val-=parseFloat(jQuery.css(elem,"border"+this+"Width"))||0}})}return val+"px"}val=curCSS(elem,name,name);if(val<0||val==null){val=elem.style[name]||0}val=parseFloat(val)||0;if(extra){jQuery.each(which,function(){val+=parseFloat(jQuery.css(elem,"padding"+this))||0;if(extra!=="padding"){val+=parseFloat(jQuery.css(elem,"border"+this+"Width"))||0}if(extra==="margin"){val+=parseFloat(jQuery.css(elem,extra+this))||0}})}return val+"px"}if(jQuery.expr&&jQuery.expr.filters){jQuery.expr.filters.hidden=function(elem){var width=elem.offsetWidth,height=elem.offsetHeight;return(width===0&&height===0)||(!jQuery.support.reliableHiddenOffsets&&((elem.style&&elem.style.display)||jQuery.css(elem,"display"))==="none")};jQuery.expr.filters.visible=function(elem){return !jQuery.expr.filters.hidden(elem)}}var r20=/%20/g,rbracket=/\[\]$/,rCRLF=/\r?\n/g,rhash=/#.*$/,rheaders=/^(.*?):[ \t]*([^\r\n]*)\r?$/mg,rinput=/^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,rlocalProtocol=/^(?:about|app|app\-storage|.+\-extension|file|res|widget):$/,rnoContent=/^(?:GET|HEAD)$/,rprotocol=/^\/\//,rquery=/\?/,rscript=/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi,rselectTextarea=/^(?:select|textarea)/i,rspacesAjax=/\s+/,rts=/([?&])_=[^&]*/,rurl=/^([\w\+\.\-]+:)(?:\/\/([^\/?#:]*)(?::(\d+))?)?/,_load=jQuery.fn.load,prefilters={},transports={},ajaxLocation,ajaxLocParts,allTypes=["*/"]+["*"];try{ajaxLocation=location.href}catch(e){ajaxLocation=document.createElement("a");ajaxLocation.href="";ajaxLocation=ajaxLocation.href}ajaxLocParts=rurl.exec(ajaxLocation.toLowerCase())||[];function addToPrefiltersOrTransports(structure){return function(dataTypeExpression,func){if(typeof dataTypeExpression!=="string"){func=dataTypeExpression;dataTypeExpression="*"}if(jQuery.isFunction(func)){var dataTypes=dataTypeExpression.toLowerCase().split(rspacesAjax),i=0,length=dataTypes.length,dataType,list,placeBefore;for(;i<length;i++){dataType=dataTypes[i];placeBefore=/^\+/.test(dataType);if(placeBefore){dataType=dataType.substr(1)||"*"}list=structure[dataType]=structure[dataType]||[];list[placeBefore?"unshift":"push"](func)}}}}function inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR,dataType,inspected){dataType=dataType||options.dataTypes[0];inspected=inspected||{};inspected[dataType]=true;var list=structure[dataType],i=0,length=list?list.length:0,executeOnly=(structure===prefilters),selection;for(;i<length&&(executeOnly||!selection);i++){selection=list[i](options,originalOptions,jqXHR);if(typeof selection==="string"){if(!executeOnly||inspected[selection]){selection=undefined}else{options.dataTypes.unshift(selection);selection=inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR,selection,inspected)}}}if((executeOnly||!selection)&&!inspected["*"]){selection=inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR,"*",inspected)}return selection}function ajaxExtend(target,src){var key,deep,flatOptions=jQuery.ajaxSettings.flatOptions||{};for(key in src){if(src[key]!==undefined){(flatOptions[key]?target:(deep||(deep={})))[key]=src[key]}}if(deep){jQuery.extend(true,target,deep)}}jQuery.fn.extend({load:function(url,params,callback){if(typeof url!=="string"&&_load){return _load.apply(this,arguments)}else{if(!this.length){return this}}var off=url.indexOf(" ");if(off>=0){var selector=url.slice(off,url.length);url=url.slice(0,off)}var type="GET";if(params){if(jQuery.isFunction(params)){callback=params;params=undefined}else{if(typeof params==="object"){params=jQuery.param(params,jQuery.ajaxSettings.traditional);type="POST"}}}var self=this;jQuery.ajax({url:url,type:type,dataType:"html",data:params,complete:function(jqXHR,status,responseText){responseText=jqXHR.responseText;if(jqXHR.isResolved()){jqXHR.done(function(r){responseText=r});self.html(selector?jQuery("<div>").append(responseText.replace(rscript,"")).find(selector):responseText)}if(callback){self.each(callback,[responseText,status,jqXHR])}}});return this},serialize:function(){return jQuery.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?jQuery.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||rselectTextarea.test(this.nodeName)||rinput.test(this.type))}).map(function(i,elem){var val=jQuery(this).val();return val==null?null:jQuery.isArray(val)?jQuery.map(val,function(val,i){return{name:elem.name,value:val.replace(rCRLF,"\r\n")}}):{name:elem.name,value:val.replace(rCRLF,"\r\n")}}).get()}});jQuery.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),function(i,o){jQuery.fn[o]=function(f){return this.bind(o,f)}});jQuery.each(["get","post"],function(i,method){jQuery[method]=function(url,data,callback,type){if(jQuery.isFunction(data)){type=type||callback;callback=data;data=undefined}return jQuery.ajax({type:method,url:url,data:data,success:callback,dataType:type})}});jQuery.extend({getScript:function(url,callback){return jQuery.get(url,undefined,callback,"script")},getJSON:function(url,data,callback){return jQuery.get(url,data,callback,"json")},ajaxSetup:function(target,settings){if(settings){ajaxExtend(target,jQuery.ajaxSettings)}else{settings=target;target=jQuery.ajaxSettings}ajaxExtend(target,settings);return target},ajaxSettings:{url:ajaxLocation,isLocal:rlocalProtocol.test(ajaxLocParts[1]),global:true,type:"GET",contentType:"application/x-www-form-urlencoded",processData:true,async:true,accepts:{xml:"application/xml, text/xml",html:"text/html",text:"text/plain",json:"application/json, text/javascript","*":allTypes},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText"},converters:{"* text":window.String,"text html":true,"text json":jQuery.parseJSON,"text xml":jQuery.parseXML},flatOptions:{context:true,url:true}},ajaxPrefilter:addToPrefiltersOrTransports(prefilters),ajaxTransport:addToPrefiltersOrTransports(transports),ajax:function(url,options){if(typeof url==="object"){options=url;url=undefined}options=options||{};var s=jQuery.ajaxSetup({},options),callbackContext=s.context||s,globalEventContext=callbackContext!==s&&(callbackContext.nodeType||callbackContext instanceof jQuery)?jQuery(callbackContext):jQuery.event,deferred=jQuery.Deferred(),completeDeferred=jQuery.Callbacks("once memory"),statusCode=s.statusCode||{},ifModifiedKey,requestHeaders={},requestHeadersNames={},responseHeadersString,responseHeaders,transport,timeoutTimer,parts,state=0,fireGlobals,i,jqXHR={readyState:0,setRequestHeader:function(name,value){if(!state){var lname=name.toLowerCase();name=requestHeadersNames[lname]=requestHeadersNames[lname]||name;requestHeaders[name]=value}return this},getAllResponseHeaders:function(){return state===2?responseHeadersString:null},getResponseHeader:function(key){var match;if(state===2){if(!responseHeaders){responseHeaders={};while((match=rheaders.exec(responseHeadersString))){responseHeaders[match[1].toLowerCase()]=match[2]}}match=responseHeaders[key.toLowerCase()]}return match===undefined?null:match},overrideMimeType:function(type){if(!state){s.mimeType=type}return this},abort:function(statusText){statusText=statusText||"abort";if(transport){transport.abort(statusText)}done(0,statusText);return this}};function done(status,nativeStatusText,responses,headers){if(state===2){return }state=2;if(timeoutTimer){clearTimeout(timeoutTimer)}transport=undefined;responseHeadersString=headers||"";jqXHR.readyState=status>0?4:0;var isSuccess,success,error,statusText=nativeStatusText,response=responses?ajaxHandleResponses(s,jqXHR,responses):undefined,lastModified,etag;if(status>=200&&status<300||status===304){if(s.ifModified){if((lastModified=jqXHR.getResponseHeader("Last-Modified"))){jQuery.lastModified[ifModifiedKey]=lastModified}if((etag=jqXHR.getResponseHeader("Etag"))){jQuery.etag[ifModifiedKey]=etag}}if(status===304){statusText="notmodified";isSuccess=true}else{try{success=ajaxConvert(s,response);statusText="success";isSuccess=true}catch(e){statusText="parsererror";error=e}}}else{error=statusText;if(!statusText||status){statusText="error";if(status<0){status=0}}}jqXHR.status=status;jqXHR.statusText=""+(nativeStatusText||statusText);if(isSuccess){deferred.resolveWith(callbackContext,[success,statusText,jqXHR])}else{deferred.rejectWith(callbackContext,[jqXHR,statusText,error])}jqXHR.statusCode(statusCode);statusCode=undefined;if(fireGlobals){globalEventContext.trigger("ajax"+(isSuccess?"Success":"Error"),[jqXHR,s,isSuccess?success:error])}completeDeferred.fireWith(callbackContext,[jqXHR,statusText]);if(fireGlobals){globalEventContext.trigger("ajaxComplete",[jqXHR,s]);if(!(--jQuery.active)){jQuery.event.trigger("ajaxStop")}}}deferred.promise(jqXHR);jqXHR.success=jqXHR.done;jqXHR.error=jqXHR.fail;jqXHR.complete=completeDeferred.add;jqXHR.statusCode=function(map){if(map){var tmp;if(state<2){for(tmp in map){statusCode[tmp]=[statusCode[tmp],map[tmp]]}}else{tmp=map[jqXHR.status];jqXHR.then(tmp,tmp)}}return this};s.url=((url||s.url)+"").replace(rhash,"").replace(rprotocol,ajaxLocParts[1]+"//");s.dataTypes=jQuery.trim(s.dataType||"*").toLowerCase().split(rspacesAjax);if(s.crossDomain==null){parts=rurl.exec(s.url.toLowerCase());s.crossDomain=!!(parts&&(parts[1]!=ajaxLocParts[1]||parts[2]!=ajaxLocParts[2]||(parts[3]||(parts[1]==="http:"?80:443))!=(ajaxLocParts[3]||(ajaxLocParts[1]==="http:"?80:443))))}if(s.data&&s.processData&&typeof s.data!=="string"){s.data=jQuery.param(s.data,s.traditional)}inspectPrefiltersOrTransports(prefilters,s,options,jqXHR);if(state===2){return false}fireGlobals=s.global;s.type=s.type.toUpperCase();s.hasContent=!rnoContent.test(s.type);if(fireGlobals&&jQuery.active++===0){jQuery.event.trigger("ajaxStart")}if(!s.hasContent){if(s.data){s.url+=(rquery.test(s.url)?"&":"?")+s.data;delete s.data}ifModifiedKey=s.url;if(s.cache===false){var ts=jQuery.now(),ret=s.url.replace(rts,"$1_="+ts);s.url=ret+((ret===s.url)?(rquery.test(s.url)?"&":"?")+"_="+ts:"")}}if(s.data&&s.hasContent&&s.contentType!==false||options.contentType){jqXHR.setRequestHeader("Content-Type",s.contentType)}if(s.ifModified){ifModifiedKey=ifModifiedKey||s.url;if(jQuery.lastModified[ifModifiedKey]){jqXHR.setRequestHeader("If-Modified-Since",jQuery.lastModified[ifModifiedKey])}if(jQuery.etag[ifModifiedKey]){jqXHR.setRequestHeader("If-None-Match",jQuery.etag[ifModifiedKey])}}jqXHR.setRequestHeader("Accept",s.dataTypes[0]&&s.accepts[s.dataTypes[0]]?s.accepts[s.dataTypes[0]]+(s.dataTypes[0]!=="*"?", "+allTypes+"; q=0.01":""):s.accepts["*"]);for(i in s.headers){jqXHR.setRequestHeader(i,s.headers[i])}if(s.beforeSend&&(s.beforeSend.call(callbackContext,jqXHR,s)===false||state===2)){jqXHR.abort();return false}for(i in {success:1,error:1,complete:1}){jqXHR[i](s[i])}transport=inspectPrefiltersOrTransports(transports,s,options,jqXHR);if(!transport){done(-1,"No Transport")}else{jqXHR.readyState=1;if(fireGlobals){globalEventContext.trigger("ajaxSend",[jqXHR,s])}if(s.async&&s.timeout>0){timeoutTimer=setTimeout(function(){jqXHR.abort("timeout")},s.timeout)}try{state=1;transport.send(requestHeaders,done)}catch(e){if(state<2){done(-1,e)}else{jQuery.error(e)}}}return jqXHR},param:function(a,traditional){var s=[],add=function(key,value){value=jQuery.isFunction(value)?value():value;s[s.length]=encodeURIComponent(key)+"="+encodeURIComponent(value)};if(traditional===undefined){traditional=jQuery.ajaxSettings.traditional}if(jQuery.isArray(a)||(a.jquery&&!jQuery.isPlainObject(a))){jQuery.each(a,function(){add(this.name,this.value)})}else{for(var prefix in a){buildParams(prefix,a[prefix],traditional,add)}}return s.join("&").replace(r20,"+")}});function buildParams(prefix,obj,traditional,add){if(jQuery.isArray(obj)){jQuery.each(obj,function(i,v){if(traditional||rbracket.test(prefix)){add(prefix,v)}else{buildParams(prefix+"["+(typeof v==="object"||jQuery.isArray(v)?i:"")+"]",v,traditional,add)}})}else{if(!traditional&&obj!=null&&typeof obj==="object"){for(var name in obj){buildParams(prefix+"["+name+"]",obj[name],traditional,add)}}else{add(prefix,obj)}}}jQuery.extend({active:0,lastModified:{},etag:{}});function ajaxHandleResponses(s,jqXHR,responses){var contents=s.contents,dataTypes=s.dataTypes,responseFields=s.responseFields,ct,type,finalDataType,firstDataType;for(type in responseFields){if(type in responses){jqXHR[responseFields[type]]=responses[type]}}while(dataTypes[0]==="*"){dataTypes.shift();if(ct===undefined){ct=s.mimeType||jqXHR.getResponseHeader("content-type")}}if(ct){for(type in contents){if(contents[type]&&contents[type].test(ct)){dataTypes.unshift(type);break}}}if(dataTypes[0] in responses){finalDataType=dataTypes[0]}else{for(type in responses){if(!dataTypes[0]||s.converters[type+" "+dataTypes[0]]){finalDataType=type;break}if(!firstDataType){firstDataType=type}}finalDataType=finalDataType||firstDataType}if(finalDataType){if(finalDataType!==dataTypes[0]){dataTypes.unshift(finalDataType)}return responses[finalDataType]}}function ajaxConvert(s,response){if(s.dataFilter){response=s.dataFilter(response,s.dataType)}var dataTypes=s.dataTypes,converters={},i,key,length=dataTypes.length,tmp,current=dataTypes[0],prev,conversion,conv,conv1,conv2;for(i=1;i<length;i++){if(i===1){for(key in s.converters){if(typeof key==="string"){converters[key.toLowerCase()]=s.converters[key]}}}prev=current;current=dataTypes[i];if(current==="*"){current=prev}else{if(prev!=="*"&&prev!==current){conversion=prev+" "+current;conv=converters[conversion]||converters["* "+current];if(!conv){conv2=undefined;for(conv1 in converters){tmp=conv1.split(" ");if(tmp[0]===prev||tmp[0]==="*"){conv2=converters[tmp[1]+" "+current];if(conv2){conv1=converters[conv1];if(conv1===true){conv=conv2}else{if(conv2===true){conv=conv1}}break}}}}if(!(conv||conv2)){jQuery.error("No conversion from "+conversion.replace(" "," to "))}if(conv!==true){response=conv?conv(response):conv2(conv1(response))}}}}return response}var jsc=jQuery.now(),jsre=/(\=)\?(&|$)|\?\?/i;jQuery.ajaxSetup({jsonp:"callback",jsonpCallback:function(){return jQuery.expando+"_"+(jsc++)}});jQuery.ajaxPrefilter("json jsonp",function(s,originalSettings,jqXHR){var inspectData=s.contentType==="application/x-www-form-urlencoded"&&(typeof s.data==="string");if(s.dataTypes[0]==="jsonp"||s.jsonp!==false&&(jsre.test(s.url)||inspectData&&jsre.test(s.data))){var responseContainer,jsonpCallback=s.jsonpCallback=jQuery.isFunction(s.jsonpCallback)?s.jsonpCallback():s.jsonpCallback,previous=window[jsonpCallback],url=s.url,data=s.data,replace="$1"+jsonpCallback+"$2";if(s.jsonp!==false){url=url.replace(jsre,replace);if(s.url===url){if(inspectData){data=data.replace(jsre,replace)}if(s.data===data){url+=(/\?/.test(url)?"&":"?")+s.jsonp+"="+jsonpCallback}}}s.url=url;s.data=data;window[jsonpCallback]=function(response){responseContainer=[response]};jqXHR.always(function(){window[jsonpCallback]=previous;if(responseContainer&&jQuery.isFunction(previous)){window[jsonpCallback](responseContainer[0])}});s.converters["script json"]=function(){if(!responseContainer){jQuery.error(jsonpCallback+" was not called")}return responseContainer[0]};s.dataTypes[0]="json";return"script"}});jQuery.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/javascript|ecmascript/},converters:{"text script":function(text){jQuery.globalEval(text);return text}}});jQuery.ajaxPrefilter("script",function(s){if(s.cache===undefined){s.cache=false}if(s.crossDomain){s.type="GET";s.global=false}});jQuery.ajaxTransport("script",function(s){if(s.crossDomain){var script,head=document.head||document.getElementsByTagName("head")[0]||document.documentElement;return{send:function(_,callback){script=document.createElement("script");script.async="async";if(s.scriptCharset){script.charset=s.scriptCharset}script.src=s.url;script.onload=script.onreadystatechange=function(_,isAbort){if(isAbort||!script.readyState||/loaded|complete/.test(script.readyState)){script.onload=script.onreadystatechange=null;if(head&&script.parentNode){head.removeChild(script)}script=undefined;if(!isAbort){callback(200,"success")}}};head.insertBefore(script,head.firstChild)},abort:function(){if(script){script.onload(0,1)}}}}});var xhrOnUnloadAbort=window.ActiveXObject?function(){for(var key in xhrCallbacks){xhrCallbacks[key](0,1)}}:false,xhrId=0,xhrCallbacks;function createStandardXHR(){try{return new window.XMLHttpRequest()}catch(e){}}function createActiveXHR(){try{return new window.ActiveXObject("Microsoft.XMLHTTP")}catch(e){}}jQuery.ajaxSettings.xhr=window.ActiveXObject?function(){return !this.isLocal&&createStandardXHR()||createActiveXHR()}:createStandardXHR;(function(xhr){jQuery.extend(jQuery.support,{ajax:!!xhr,cors:!!xhr&&("withCredentials" in xhr)})})(jQuery.ajaxSettings.xhr());if(jQuery.support.ajax){jQuery.ajaxTransport(function(s){if(!s.crossDomain||jQuery.support.cors){var callback;return{send:function(headers,complete){var xhr=s.xhr(),handle,i;if(s.username){xhr.open(s.type,s.url,s.async,s.username,s.password)}else{xhr.open(s.type,s.url,s.async)}if(s.xhrFields){for(i in s.xhrFields){xhr[i]=s.xhrFields[i]}}if(s.mimeType&&xhr.overrideMimeType){xhr.overrideMimeType(s.mimeType)}if(!s.crossDomain&&!headers["X-Requested-With"]){headers["X-Requested-With"]="XMLHttpRequest"}try{for(i in headers){xhr.setRequestHeader(i,headers[i])}}catch(_){}xhr.send((s.hasContent&&s.data)||null);callback=function(_,isAbort){var status,statusText,responseHeaders,responses,xml;try{if(callback&&(isAbort||xhr.readyState===4)){callback=undefined;if(handle){xhr.onreadystatechange=jQuery.noop;if(xhrOnUnloadAbort){delete xhrCallbacks[handle]}}if(isAbort){if(xhr.readyState!==4){xhr.abort()}}else{status=xhr.status;responseHeaders=xhr.getAllResponseHeaders();responses={};xml=xhr.responseXML;if(xml&&xml.documentElement){responses.xml=xml}responses.text=xhr.responseText;try{statusText=xhr.statusText}catch(e){statusText=""}if(!status&&s.isLocal&&!s.crossDomain){status=responses.text?200:404}else{if(status===1223){status=204}}}}}catch(firefoxAccessException){if(!isAbort){complete(-1,firefoxAccessException)}}if(responses){complete(status,statusText,responses,responseHeaders)}};if(!s.async||xhr.readyState===4){callback()}else{handle=++xhrId;if(xhrOnUnloadAbort){if(!xhrCallbacks){xhrCallbacks={};jQuery(window).unload(xhrOnUnloadAbort)}xhrCallbacks[handle]=callback}xhr.onreadystatechange=callback}},abort:function(){if(callback){callback(0,1)}}}}})}var elemdisplay={},iframe,iframeDoc,rfxtypes=/^(?:toggle|show|hide)$/,rfxnum=/^([+\-]=)?([\d+.\-]+)([a-z%]*)$/i,timerId,fxAttrs=[["height","marginTop","marginBottom","paddingTop","paddingBottom"],["width","marginLeft","marginRight","paddingLeft","paddingRight"],["opacity"]],fxNow;jQuery.fn.extend({show:function(speed,easing,callback){var elem,display;if(speed||speed===0){return this.animate(genFx("show",3),speed,easing,callback)}else{for(var i=0,j=this.length;i<j;i++){elem=this[i];if(elem.style){display=elem.style.display;if(!jQuery._data(elem,"olddisplay")&&display==="none"){display=elem.style.display=""}if(display===""&&jQuery.css(elem,"display")==="none"){jQuery._data(elem,"olddisplay",defaultDisplay(elem.nodeName))}}}for(i=0;i<j;i++){elem=this[i];if(elem.style){display=elem.style.display;if(display===""||display==="none"){elem.style.display=jQuery._data(elem,"olddisplay")||""}}}return this}},hide:function(speed,easing,callback){if(speed||speed===0){return this.animate(genFx("hide",3),speed,easing,callback)}else{var elem,display,i=0,j=this.length;for(;i<j;i++){elem=this[i];if(elem.style){display=jQuery.css(elem,"display");if(display!=="none"&&!jQuery._data(elem,"olddisplay")){jQuery._data(elem,"olddisplay",display)}}}for(i=0;i<j;i++){if(this[i].style){this[i].style.display="none"}}return this}},_toggle:jQuery.fn.toggle,toggle:function(fn,fn2,callback){var bool=typeof fn==="boolean";if(jQuery.isFunction(fn)&&jQuery.isFunction(fn2)){this._toggle.apply(this,arguments)}else{if(fn==null||bool){this.each(function(){var state=bool?fn:jQuery(this).is(":hidden");jQuery(this)[state?"show":"hide"]()})}else{this.animate(genFx("toggle",3),fn,fn2,callback)}}return this},fadeTo:function(speed,to,easing,callback){return this.filter(":hidden").css("opacity",0).show().end().animate({opacity:to},speed,easing,callback)},animate:function(prop,speed,easing,callback){var optall=jQuery.speed(speed,easing,callback);if(jQuery.isEmptyObject(prop)){return this.each(optall.complete,[false])}prop=jQuery.extend({},prop);function doAnimation(){if(optall.queue===false){jQuery._mark(this)}var opt=jQuery.extend({},optall),isElement=this.nodeType===1,hidden=isElement&&jQuery(this).is(":hidden"),name,val,p,e,parts,start,end,unit,method;opt.animatedProperties={};for(p in prop){name=jQuery.camelCase(p);if(p!==name){prop[name]=prop[p];delete prop[p]}val=prop[name];if(jQuery.isArray(val)){opt.animatedProperties[name]=val[1];val=prop[name]=val[0]}else{opt.animatedProperties[name]=opt.specialEasing&&opt.specialEasing[name]||opt.easing||"swing"}if(val==="hide"&&hidden||val==="show"&&!hidden){return opt.complete.call(this)}if(isElement&&(name==="height"||name==="width")){opt.overflow=[this.style.overflow,this.style.overflowX,this.style.overflowY];if(jQuery.css(this,"display")==="inline"&&jQuery.css(this,"float")==="none"){if(!jQuery.support.inlineBlockNeedsLayout||defaultDisplay(this.nodeName)==="inline"){this.style.display="inline-block"}else{this.style.zoom=1}}}}if(opt.overflow!=null){this.style.overflow="hidden"}for(p in prop){e=new jQuery.fx(this,opt,p);val=prop[p];if(rfxtypes.test(val)){method=jQuery._data(this,"toggle"+p)||(val==="toggle"?hidden?"show":"hide":0);if(method){jQuery._data(this,"toggle"+p,method==="show"?"hide":"show");e[method]()}else{e[val]()}}else{parts=rfxnum.exec(val);start=e.cur();if(parts){end=parseFloat(parts[2]);unit=parts[3]||(jQuery.cssNumber[p]?"":"px");if(unit!=="px"){jQuery.style(this,p,(end||1)+unit);start=((end||1)/e.cur())*start;jQuery.style(this,p,start+unit)}if(parts[1]){end=((parts[1]==="-="?-1:1)*end)+start}e.custom(start,end,unit)}else{e.custom(start,val,"")}}}return true}return optall.queue===false?this.each(doAnimation):this.queue(optall.queue,doAnimation)},stop:function(type,clearQueue,gotoEnd){if(typeof type!=="string"){gotoEnd=clearQueue;clearQueue=type;type=undefined}if(clearQueue&&type!==false){this.queue(type||"fx",[])}return this.each(function(){var i,hadTimers=false,timers=jQuery.timers,data=jQuery._data(this);if(!gotoEnd){jQuery._unmark(true,this)}function stopQueue(elem,data,i){var hooks=data[i];jQuery.removeData(elem,i,true);hooks.stop(gotoEnd)}if(type==null){for(i in data){if(data[i].stop&&i.indexOf(".run")===i.length-4){stopQueue(this,data,i)}}}else{if(data[i=type+".run"]&&data[i].stop){stopQueue(this,data,i)}}for(i=timers.length;i--;){if(timers[i].elem===this&&(type==null||timers[i].queue===type)){if(gotoEnd){timers[i](true)}else{timers[i].saveState()}hadTimers=true;timers.splice(i,1)}}if(!(gotoEnd&&hadTimers)){jQuery.dequeue(this,type)}})}});function createFxNow(){setTimeout(clearFxNow,0);return(fxNow=jQuery.now())}function clearFxNow(){fxNow=undefined}function genFx(type,num){var obj={};jQuery.each(fxAttrs.concat.apply([],fxAttrs.slice(0,num)),function(){obj[this]=type});return obj}jQuery.each({slideDown:genFx("show",1),slideUp:genFx("hide",1),slideToggle:genFx("toggle",1),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(name,props){jQuery.fn[name]=function(speed,easing,callback){return this.animate(props,speed,easing,callback)}});jQuery.extend({speed:function(speed,easing,fn){var opt=speed&&typeof speed==="object"?jQuery.extend({},speed):{complete:fn||!fn&&easing||jQuery.isFunction(speed)&&speed,duration:speed,easing:fn&&easing||easing&&!jQuery.isFunction(easing)&&easing};opt.duration=jQuery.fx.off?0:typeof opt.duration==="number"?opt.duration:opt.duration in jQuery.fx.speeds?jQuery.fx.speeds[opt.duration]:jQuery.fx.speeds._default;if(opt.queue==null||opt.queue===true){opt.queue="fx"}opt.old=opt.complete;opt.complete=function(noUnmark){if(jQuery.isFunction(opt.old)){opt.old.call(this)}if(opt.queue){jQuery.dequeue(this,opt.queue)}else{if(noUnmark!==false){jQuery._unmark(this)}}};return opt},easing:{linear:function(p,n,firstNum,diff){return firstNum+diff*p},swing:function(p,n,firstNum,diff){return((-Math.cos(p*Math.PI)/2)+0.5)*diff+firstNum}},timers:[],fx:function(elem,options,prop){this.options=options;this.elem=elem;this.prop=prop;options.orig=options.orig||{}}});jQuery.fx.prototype={update:function(){if(this.options.step){this.options.step.call(this.elem,this.now,this)}(jQuery.fx.step[this.prop]||jQuery.fx.step._default)(this)},cur:function(){if(this.elem[this.prop]!=null&&(!this.elem.style||this.elem.style[this.prop]==null)){return this.elem[this.prop]}var parsed,r=jQuery.css(this.elem,this.prop);return isNaN(parsed=parseFloat(r))?!r||r==="auto"?0:r:parsed},custom:function(from,to,unit){var self=this,fx=jQuery.fx;this.startTime=fxNow||createFxNow();this.end=to;this.now=this.start=from;this.pos=this.state=0;this.unit=unit||this.unit||(jQuery.cssNumber[this.prop]?"":"px");function t(gotoEnd){return self.step(gotoEnd)}t.queue=this.options.queue;t.elem=this.elem;t.saveState=function(){if(self.options.hide&&jQuery._data(self.elem,"fxshow"+self.prop)===undefined){jQuery._data(self.elem,"fxshow"+self.prop,self.start)}};if(t()&&jQuery.timers.push(t)&&!timerId){timerId=setInterval(fx.tick,fx.interval)}},show:function(){var dataShow=jQuery._data(this.elem,"fxshow"+this.prop);this.options.orig[this.prop]=dataShow||jQuery.style(this.elem,this.prop);this.options.show=true;if(dataShow!==undefined){this.custom(this.cur(),dataShow)}else{this.custom(this.prop==="width"||this.prop==="height"?1:0,this.cur())}jQuery(this.elem).show()},hide:function(){this.options.orig[this.prop]=jQuery._data(this.elem,"fxshow"+this.prop)||jQuery.style(this.elem,this.prop);this.options.hide=true;this.custom(this.cur(),0)},step:function(gotoEnd){var p,n,complete,t=fxNow||createFxNow(),done=true,elem=this.elem,options=this.options;if(gotoEnd||t>=options.duration+this.startTime){this.now=this.end;this.pos=this.state=1;this.update();options.animatedProperties[this.prop]=true;for(p in options.animatedProperties){if(options.animatedProperties[p]!==true){done=false}}if(done){if(options.overflow!=null&&!jQuery.support.shrinkWrapBlocks){jQuery.each(["","X","Y"],function(index,value){elem.style["overflow"+value]=options.overflow[index]})}if(options.hide){jQuery(elem).hide()}if(options.hide||options.show){for(p in options.animatedProperties){jQuery.style(elem,p,options.orig[p]);jQuery.removeData(elem,"fxshow"+p,true);jQuery.removeData(elem,"toggle"+p,true)}}complete=options.complete;if(complete){options.complete=false;complete.call(elem)}}return false}else{if(options.duration==Infinity){this.now=t}else{n=t-this.startTime;this.state=n/options.duration;this.pos=jQuery.easing[options.animatedProperties[this.prop]](this.state,n,0,1,options.duration);this.now=this.start+((this.end-this.start)*this.pos)}this.update()}return true}};jQuery.extend(jQuery.fx,{tick:function(){var timer,timers=jQuery.timers,i=0;for(;i<timers.length;i++){timer=timers[i];if(!timer()&&timers[i]===timer){timers.splice(i--,1)}}if(!timers.length){jQuery.fx.stop()}},interval:13,stop:function(){clearInterval(timerId);timerId=null},speeds:{slow:600,fast:200,_default:400},step:{opacity:function(fx){jQuery.style(fx.elem,"opacity",fx.now)},_default:function(fx){if(fx.elem.style&&fx.elem.style[fx.prop]!=null){fx.elem.style[fx.prop]=fx.now+fx.unit}else{fx.elem[fx.prop]=fx.now}}}});jQuery.each(["width","height"],function(i,prop){jQuery.fx.step[prop]=function(fx){jQuery.style(fx.elem,prop,Math.max(0,fx.now))}});if(jQuery.expr&&jQuery.expr.filters){jQuery.expr.filters.animated=function(elem){return jQuery.grep(jQuery.timers,function(fn){return elem===fn.elem}).length}}function defaultDisplay(nodeName){if(!elemdisplay[nodeName]){var body=document.body,elem=jQuery("<"+nodeName+">").appendTo(body),display=elem.css("display");elem.remove();if(display==="none"||display===""){if(!iframe){iframe=document.createElement("iframe");iframe.frameBorder=iframe.width=iframe.height=0}body.appendChild(iframe);if(!iframeDoc||!iframe.createElement){iframeDoc=(iframe.contentWindow||iframe.contentDocument).document;iframeDoc.write((document.compatMode==="CSS1Compat"?"<!doctype html>":"")+"<html><body>");iframeDoc.close()}elem=iframeDoc.createElement(nodeName);iframeDoc.body.appendChild(elem);display=jQuery.css(elem,"display");body.removeChild(iframe)}elemdisplay[nodeName]=display}return elemdisplay[nodeName]}var rtable=/^t(?:able|d|h)$/i,rroot=/^(?:body|html)$/i;if("getBoundingClientRect" in document.documentElement){jQuery.fn.offset=function(options){var elem=this[0],box;if(options){return this.each(function(i){jQuery.offset.setOffset(this,options,i)})}if(!elem||!elem.ownerDocument){return null}if(elem===elem.ownerDocument.body){return jQuery.offset.bodyOffset(elem)}try{box=elem.getBoundingClientRect()}catch(e){}var doc=elem.ownerDocument,docElem=doc.documentElement;if(!box||!jQuery.contains(docElem,elem)){return box?{top:box.top,left:box.left}:{top:0,left:0}}var body=doc.body,win=getWindow(doc),clientTop=docElem.clientTop||body.clientTop||0,clientLeft=docElem.clientLeft||body.clientLeft||0,scrollTop=win.pageYOffset||jQuery.support.boxModel&&docElem.scrollTop||body.scrollTop,scrollLeft=win.pageXOffset||jQuery.support.boxModel&&docElem.scrollLeft||body.scrollLeft,top=box.top+scrollTop-clientTop,left=box.left+scrollLeft-clientLeft;return{top:top,left:left}}}else{jQuery.fn.offset=function(options){var elem=this[0];if(options){return this.each(function(i){jQuery.offset.setOffset(this,options,i)})}if(!elem||!elem.ownerDocument){return null}if(elem===elem.ownerDocument.body){return jQuery.offset.bodyOffset(elem)}var computedStyle,offsetParent=elem.offsetParent,prevOffsetParent=elem,doc=elem.ownerDocument,docElem=doc.documentElement,body=doc.body,defaultView=doc.defaultView,prevComputedStyle=defaultView?defaultView.getComputedStyle(elem,null):elem.currentStyle,top=elem.offsetTop,left=elem.offsetLeft;while((elem=elem.parentNode)&&elem!==body&&elem!==docElem){if(jQuery.support.fixedPosition&&prevComputedStyle.position==="fixed"){break}computedStyle=defaultView?defaultView.getComputedStyle(elem,null):elem.currentStyle;top-=elem.scrollTop;left-=elem.scrollLeft;if(elem===offsetParent){top+=elem.offsetTop;left+=elem.offsetLeft;if(jQuery.support.doesNotAddBorder&&!(jQuery.support.doesAddBorderForTableAndCells&&rtable.test(elem.nodeName))){top+=parseFloat(computedStyle.borderTopWidth)||0;left+=parseFloat(computedStyle.borderLeftWidth)||0}prevOffsetParent=offsetParent;offsetParent=elem.offsetParent}if(jQuery.support.subtractsBorderForOverflowNotVisible&&computedStyle.overflow!=="visible"){top+=parseFloat(computedStyle.borderTopWidth)||0;left+=parseFloat(computedStyle.borderLeftWidth)||0}prevComputedStyle=computedStyle}if(prevComputedStyle.position==="relative"||prevComputedStyle.position==="static"){top+=body.offsetTop;left+=body.offsetLeft}if(jQuery.support.fixedPosition&&prevComputedStyle.position==="fixed"){top+=Math.max(docElem.scrollTop,body.scrollTop);left+=Math.max(docElem.scrollLeft,body.scrollLeft)}return{top:top,left:left}}}jQuery.offset={bodyOffset:function(body){var top=body.offsetTop,left=body.offsetLeft;if(jQuery.support.doesNotIncludeMarginInBodyOffset){top+=parseFloat(jQuery.css(body,"marginTop"))||0;left+=parseFloat(jQuery.css(body,"marginLeft"))||0}return{top:top,left:left}},setOffset:function(elem,options,i){var position=jQuery.css(elem,"position");if(position==="static"){elem.style.position="relative"}var curElem=jQuery(elem),curOffset=curElem.offset(),curCSSTop=jQuery.css(elem,"top"),curCSSLeft=jQuery.css(elem,"left"),calculatePosition=(position==="absolute"||position==="fixed")&&jQuery.inArray("auto",[curCSSTop,curCSSLeft])>-1,props={},curPosition={},curTop,curLeft;if(calculatePosition){curPosition=curElem.position();curTop=curPosition.top;curLeft=curPosition.left}else{curTop=parseFloat(curCSSTop)||0;curLeft=parseFloat(curCSSLeft)||0}if(jQuery.isFunction(options)){options=options.call(elem,i,curOffset)}if(options.top!=null){props.top=(options.top-curOffset.top)+curTop}if(options.left!=null){props.left=(options.left-curOffset.left)+curLeft}if("using" in options){options.using.call(elem,props)}else{curElem.css(props)}}};jQuery.fn.extend({position:function(){if(!this[0]){return null}var elem=this[0],offsetParent=this.offsetParent(),offset=this.offset(),parentOffset=rroot.test(offsetParent[0].nodeName)?{top:0,left:0}:offsetParent.offset();offset.top-=parseFloat(jQuery.css(elem,"marginTop"))||0;offset.left-=parseFloat(jQuery.css(elem,"marginLeft"))||0;parentOffset.top+=parseFloat(jQuery.css(offsetParent[0],"borderTopWidth"))||0;parentOffset.left+=parseFloat(jQuery.css(offsetParent[0],"borderLeftWidth"))||0;return{top:offset.top-parentOffset.top,left:offset.left-parentOffset.left}},offsetParent:function(){return this.map(function(){var offsetParent=this.offsetParent||document.body;while(offsetParent&&(!rroot.test(offsetParent.nodeName)&&jQuery.css(offsetParent,"position")==="static")){offsetParent=offsetParent.offsetParent}return offsetParent})}});jQuery.each(["Left","Top"],function(i,name){var method="scroll"+name;jQuery.fn[method]=function(val){var elem,win;if(val===undefined){elem=this[0];if(!elem){return null}win=getWindow(elem);return win?("pageXOffset" in win)?win[i?"pageYOffset":"pageXOffset"]:jQuery.support.boxModel&&win.document.documentElement[method]||win.document.body[method]:elem[method]}return this.each(function(){win=getWindow(this);if(win){win.scrollTo(!i?val:jQuery(win).scrollLeft(),i?val:jQuery(win).scrollTop())}else{this[method]=val}})}});function getWindow(elem){return jQuery.isWindow(elem)?elem:elem.nodeType===9?elem.defaultView||elem.parentWindow:false}jQuery.each(["Height","Width"],function(i,name){var type=name.toLowerCase();jQuery.fn["inner"+name]=function(){var elem=this[0];return elem?elem.style?parseFloat(jQuery.css(elem,type,"padding")):this[type]():null};jQuery.fn["outer"+name]=function(margin){var elem=this[0];return elem?elem.style?parseFloat(jQuery.css(elem,type,margin?"margin":"border")):this[type]():null};jQuery.fn[type]=function(size){var elem=this[0];if(!elem){return size==null?null:this}if(jQuery.isFunction(size)){return this.each(function(i){var self=jQuery(this);self[type](size.call(this,i,self[type]()))})}if(jQuery.isWindow(elem)){var docElemProp=elem.document.documentElement["client"+name],body=elem.document.body;return elem.document.compatMode==="CSS1Compat"&&docElemProp||body&&body["client"+name]||docElemProp}else{if(elem.nodeType===9){return Math.max(elem.documentElement["client"+name],elem.body["scroll"+name],elem.documentElement["scroll"+name],elem.body["offset"+name],elem.documentElement["offset"+name])}else{if(size===undefined){var orig=jQuery.css(elem,type),ret=parseFloat(orig);return jQuery.isNumeric(ret)?ret:orig}else{return this.css(type,typeof size==="string"?size:size+"px")}}}}});window.jQuery=window.$=jQuery})(window);
/*
 * jQuery UI 1.8.13
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI
 */
(function(D,C){function B(F,E){var G=F.nodeName.toLowerCase();if("area"===G){E=F.parentNode;G=E.name;if(!F.href||!G||E.nodeName.toLowerCase()!=="map"){return false}F=D("img[usemap=#"+G+"]")[0];return !!F&&A(F)}return(/input|select|textarea|button|object/.test(G)?!F.disabled:"a"==G?F.href||E:E)&&A(F)}function A(E){return !D(E).parents().andSelf().filter(function(){return D.curCSS(this,"visibility")==="hidden"||D.expr.filters.hidden(this)}).length}D.ui=D.ui||{};if(!D.ui.version){D.extend(D.ui,{version:"1.8.13",keyCode:{ALT:18,BACKSPACE:8,CAPS_LOCK:20,COMMA:188,COMMAND:91,COMMAND_LEFT:91,COMMAND_RIGHT:93,CONTROL:17,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,INSERT:45,LEFT:37,MENU:93,NUMPAD_ADD:107,NUMPAD_DECIMAL:110,NUMPAD_DIVIDE:111,NUMPAD_ENTER:108,NUMPAD_MULTIPLY:106,NUMPAD_SUBTRACT:109,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SHIFT:16,SPACE:32,TAB:9,UP:38,WINDOWS:91}});D.fn.extend({_focus:D.fn.focus,focus:function(F,E){return typeof F==="number"?this.each(function(){var G=this;setTimeout(function(){D(G).focus();E&&E.call(G)},F)}):this._focus.apply(this,arguments)},scrollParent:function(){var E;E=D.browser.msie&&/(static|relative)/.test(this.css("position"))||/absolute/.test(this.css("position"))?this.parents().filter(function(){return/(relative|absolute|fixed)/.test(D.curCSS(this,"position",1))&&/(auto|scroll)/.test(D.curCSS(this,"overflow",1)+D.curCSS(this,"overflow-y",1)+D.curCSS(this,"overflow-x",1))}).eq(0):this.parents().filter(function(){return/(auto|scroll)/.test(D.curCSS(this,"overflow",1)+D.curCSS(this,"overflow-y",1)+D.curCSS(this,"overflow-x",1))}).eq(0);return/fixed/.test(this.css("position"))||!E.length?D(document):E},zIndex:function(F){if(F!==C){return this.css("zIndex",F)}if(this.length){F=D(this[0]);for(var E;F.length&&F[0]!==document;){E=F.css("position");if(E==="absolute"||E==="relative"||E==="fixed"){E=parseInt(F.css("zIndex"),10);if(!isNaN(E)&&E!==0){return E}}F=F.parent()}}return 0},disableSelection:function(){return this.bind((D.support.selectstart?"selectstart":"mousedown")+".ui-disableSelection",function(E){E.preventDefault()})},enableSelection:function(){return this.unbind(".ui-disableSelection")}});D.each(["Width","Height"],function(F,E){function J(M,L,K,N){D.each(I,function(){L-=parseFloat(D.curCSS(M,"padding"+this,true))||0;if(K){L-=parseFloat(D.curCSS(M,"border"+this+"Width",true))||0}if(N){L-=parseFloat(D.curCSS(M,"margin"+this,true))||0}});return L}var I=E==="Width"?["Left","Right"]:["Top","Bottom"],H=E.toLowerCase(),G={innerWidth:D.fn.innerWidth,innerHeight:D.fn.innerHeight,outerWidth:D.fn.outerWidth,outerHeight:D.fn.outerHeight};D.fn["inner"+E]=function(K){if(K===C){return G["inner"+E].call(this)}return this.each(function(){D(this).css(H,J(this,K)+"px")})};D.fn["outer"+E]=function(L,K){if(typeof L!=="number"){return G["outer"+E].call(this,L)}return this.each(function(){D(this).css(H,J(this,L,true,K)+"px")})}});D.extend(D.expr[":"],{data:function(F,E,G){return !!D.data(F,G[3])},focusable:function(E){return B(E,!isNaN(D.attr(E,"tabindex")))},tabbable:function(F){var E=D.attr(F,"tabindex"),G=isNaN(E);return(G||E>=0)&&B(F,!G)}});D(function(){var F=document.body,E=F.appendChild(E=document.createElement("div"));D.extend(E.style,{minHeight:"100px",height:"auto",padding:0,borderWidth:0});D.support.minHeight=E.offsetHeight===100;D.support.selectstart="onselectstart" in E;F.removeChild(E).style.display="none"});D.extend(D.ui,{plugin:{add:function(F,E,H){F=D.ui[F].prototype;for(var G in H){F.plugins[G]=F.plugins[G]||[];F.plugins[G].push([E,H[G]])}},call:function(F,E,H){if((E=F.plugins[E])&&F.element[0].parentNode){for(var G=0;G<E.length;G++){F.options[E[G][0]]&&E[G][1].apply(F.element,H)}}}},contains:function(F,E){return document.compareDocumentPosition?F.compareDocumentPosition(E)&16:F!==E&&F.contains(E)},hasScroll:function(F,E){if(D(F).css("overflow")==="hidden"){return false}E=E&&E==="left"?"scrollLeft":"scrollTop";var G=false;if(F[E]>0){return true}F[E]=1;G=F[E]>0;F[E]=0;return G},isOverAxis:function(F,E,G){return F>E&&F<E+G},isOver:function(F,E,J,I,H,G){return D.ui.isOverAxis(F,J,H)&&D.ui.isOverAxis(E,I,G)}})}})(jQuery);
/*
 * jQuery UI Widget 1.8.13
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Widget
 */
(function(A,D){if(A.cleanData){var C=A.cleanData;A.cleanData=function(E){for(var G=0,F;(F=E[G])!=null;G++){A(F).triggerHandler("remove")}C(E)}}else{var B=A.fn.remove;A.fn.remove=function(E,F){return this.each(function(){if(!F){if(!E||A.filter(E,[this]).length){A("*",this).add([this]).each(function(){A(this).triggerHandler("remove")})}}return B.call(A(this),E,F)})}}A.widget=function(E,I,H){var G=E.split(".")[0],F;E=E.split(".")[1];F=G+"-"+E;if(!H){H=I;I=A.Widget}A.expr[":"][F]=function(J){return !!A.data(J,E)};A[G]=A[G]||{};A[G][E]=function(J,K){arguments.length&&this._createWidget(J,K)};I=new I;I.options=A.extend(true,{},I.options);A[G][E].prototype=A.extend(true,I,{namespace:G,widgetName:E,widgetEventPrefix:A[G][E].prototype.widgetEventPrefix||E,widgetBaseClass:F},H);A.widget.bridge(E,A[G][E])};A.widget.bridge=function(E,F){A.fn[E]=function(J){var I=typeof J==="string",H=Array.prototype.slice.call(arguments,1),G=this;J=!I&&H.length?A.extend.apply(null,[true,J].concat(H)):J;if(I&&J.charAt(0)==="_"){return G}I?this.each(function(){var L=A.data(this,E),K=L&&A.isFunction(L[J])?L[J].apply(L,H):L;if(K!==L&&K!==D){G=K;return false}}):this.each(function(){var K=A.data(this,E);K?K.option(J||{})._init():A.data(this,E,new F(J,this))});return G}};A.Widget=function(E,F){arguments.length&&this._createWidget(E,F)};A.Widget.prototype={widgetName:"widget",widgetEventPrefix:"",options:{disabled:false},_createWidget:function(E,G){A.data(G,this.widgetName,this);this.element=A(G);this.options=A.extend(true,{},this.options,this._getCreateOptions(),E);var F=this;this.element.bind("remove."+this.widgetName,function(){F.destroy()});this._create();this._trigger("create");this._init()},_getCreateOptions:function(){return A.metadata&&A.metadata.get(this.element[0])[this.widgetName]},_create:function(){},_init:function(){},destroy:function(){this.element.unbind("."+this.widgetName).removeData(this.widgetName);this.widget().unbind("."+this.widgetName).removeAttr("aria-disabled").removeClass(this.widgetBaseClass+"-disabled ui-state-disabled")},widget:function(){return this.element},option:function(E,G){var F=E;if(arguments.length===0){return A.extend({},this.options)}if(typeof E==="string"){if(G===D){return this.options[E]}F={};F[E]=G}this._setOptions(F);return this},_setOptions:function(E){var F=this;A.each(E,function(H,G){F._setOption(H,G)});return this},_setOption:function(E,F){this.options[E]=F;if(E==="disabled"){this.widget()[F?"addClass":"removeClass"](this.widgetBaseClass+"-disabled ui-state-disabled").attr("aria-disabled",F)}return this},enable:function(){return this._setOption("disabled",false)},disable:function(){return this._setOption("disabled",true)},_trigger:function(E,I,H){var G=this.options[E];I=A.Event(I);I.type=(E===this.widgetEventPrefix?E:this.widgetEventPrefix+E).toLowerCase();H=H||{};if(I.originalEvent){E=A.event.props.length;for(var F;E;){F=A.event.props[--E];I[F]=I.originalEvent[F]}}this.element.trigger(I,H);return !(A.isFunction(G)&&G.call(this.element[0],I,H)===false||I.isDefaultPrevented())}}})(jQuery);
/*
 * jQuery UI Mouse 1.8.13
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Mouse
 *
 * Depends:
 *	jquery.ui.widget.js
 */
(function(B,C){var A=false;B(document).mousedown(function(D){A=false});B.widget("ui.mouse",{options:{cancel:":input,option",distance:1,delay:0},_mouseInit:function(){var D=this;this.element.bind("mousedown."+this.widgetName,function(E){return D._mouseDown(E)}).bind("click."+this.widgetName,function(E){if(true===B.data(E.target,D.widgetName+".preventClickEvent")){B.removeData(E.target,D.widgetName+".preventClickEvent");E.stopImmediatePropagation();return false}});this.started=false},_mouseDestroy:function(){this.element.unbind("."+this.widgetName)},_mouseDown:function(F){B(this.document||document).mousedown(function(H){A=false});if(A){return }(this._mouseStarted&&this._mouseUp(F));this._mouseDownEvent=F;var E=this,G=(F.which==1),D=(typeof this.options.cancel=="string"?B(F.target).parents().add(F.target).filter(this.options.cancel).length:false);if(!G||D||!this._mouseCapture(F)){return true}this.mouseDelayMet=!this.options.delay;if(!this.mouseDelayMet){this._mouseDelayTimer=setTimeout(function(){E.mouseDelayMet=true},this.options.delay)}if(this._mouseDistanceMet(F)&&this._mouseDelayMet(F)){this._mouseStarted=(this._mouseStart(F)!==false);if(!this._mouseStarted){F.preventDefault();return true}}if(true===B.data(F.target,this.widgetName+".preventClickEvent")){B.removeData(F.target,this.widgetName+".preventClickEvent")}this._mouseMoveDelegate=function(H){return E._mouseMove(H)};this._mouseUpDelegate=function(H){return E._mouseUp(H)};B(this.document||document).bind("mousemove."+this.widgetName,this._mouseMoveDelegate).bind("mouseup."+this.widgetName,this._mouseUpDelegate);F.preventDefault();A=true;return true},_mouseMove:function(D){if(B.browser.msie&&!((this.document||document).documentMode>=9)&&!D.button){return this._mouseUp(D)}if(this._mouseStarted){this._mouseDrag(D);return D.preventDefault()}if(this._mouseDistanceMet(D)&&this._mouseDelayMet(D)){this._mouseStarted=(this._mouseStart(this._mouseDownEvent,D)!==false);(this._mouseStarted?this._mouseDrag(D):this._mouseUp(D))}return !this._mouseStarted},_mouseUp:function(D){B(this.document||document).unbind("mousemove."+this.widgetName,this._mouseMoveDelegate).unbind("mouseup."+this.widgetName,this._mouseUpDelegate);if(this._mouseStarted){this._mouseStarted=false;if(D.target==this._mouseDownEvent.target){B.data(D.target,this.widgetName+".preventClickEvent",true)}this._mouseStop(D)}return false},_mouseDistanceMet:function(D){return(Math.max(Math.abs(this._mouseDownEvent.pageX-D.pageX),Math.abs(this._mouseDownEvent.pageY-D.pageY))>=this.options.distance)},_mouseDelayMet:function(D){return this.mouseDelayMet},_mouseStart:function(D){},_mouseDrag:function(D){},_mouseStop:function(D){},_mouseCapture:function(D){return true}})})(jQuery);(function(A){A.widget("ui.draggable",A.ui.mouse,{widgetEventPrefix:"drag",options:{addClasses:true,appendTo:"parent",axis:false,connectToSortable:false,containment:false,cursor:"auto",cursorAt:false,grid:false,handle:false,helper:"original",iframeFix:false,opacity:false,refreshPositions:false,revert:false,revertDuration:500,scope:"default",scroll:true,scrollSensitivity:20,scrollSpeed:20,snap:false,snapMode:"both",snapTolerance:20,stack:false,zIndex:false},_create:function(){if(this.options.helper=="original"&&!/^(?:r|a|f)/.test(this.element.css("position"))){this.element[0].style.position="relative"}this.options.addClasses&&this.element.addClass("ui-draggable");this.options.disabled&&this.element.addClass("ui-draggable-disabled");this._mouseInit()},destroy:function(){if(this.element.data("draggable")){this.element.removeData("draggable").unbind(".draggable").removeClass("ui-draggable ui-draggable-dragging ui-draggable-disabled");this._mouseDestroy();return this}},_mouseCapture:function(C){var B=this.options;if(this.helper||B.disabled||A(C.target).is(".ui-resizable-handle")){return false}this.handle=this._getHandle(C);if(!this.handle){return false}A(B.iframeFix===true?"iframe":B.iframeFix).each(function(){A('<div class="ui-draggable-iframeFix" style="background: #fff;"></div>').css({width:this.offsetWidth+"px",height:this.offsetHeight+"px",position:"absolute",opacity:"0.001",zIndex:1000}).css(A(this).offset()).appendTo("body")});return true},_mouseStart:function(C){var B=this.options;this.helper=this._createHelper(C);this._cacheHelperProportions();if(A.ui.ddmanager){A.ui.ddmanager.current=this}this._cacheMargins();this.cssPosition=this.helper.css("position");this.scrollParent=this.helper.scrollParent();this.offset=this.positionAbs=this.element.offset();this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left};A.extend(this.offset,{click:{left:C.pageX-this.offset.left,top:C.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()});this.originalPosition=this.position=this._generatePosition(C);this.originalPageX=C.pageX;this.originalPageY=C.pageY;B.cursorAt&&this._adjustOffsetFromHelper(B.cursorAt);B.containment&&this._setContainment();if(this._trigger("start",C)===false){this._clear();return false}this._cacheHelperProportions();A.ui.ddmanager&&!B.dropBehaviour&&A.ui.ddmanager.prepareOffsets(this,C);this.helper.addClass("ui-draggable-dragging");this._mouseDrag(C,true);return true},_mouseDrag:function(C,B){this.position=this._generatePosition(C);this.positionAbs=this._convertPositionTo("absolute");if(!B){B=this._uiHash();if(this._trigger("drag",C,B)===false){this._mouseUp({});return false}this.position=B.position}if(!this.options.axis||this.options.axis!="y"){this.helper[0].style.left=this.position.left+"px"}if(!this.options.axis||this.options.axis!="x"){this.helper[0].style.top=this.position.top+"px"}A.ui.ddmanager&&A.ui.ddmanager.drag(this,C);return false},_mouseStop:function(C){var B=false;if(A.ui.ddmanager&&!this.options.dropBehaviour){B=A.ui.ddmanager.drop(this,C)}if(this.dropped){B=this.dropped;this.dropped=false}if((!this.element[0]||!this.element[0].parentNode)&&this.options.helper=="original"){return false}if(this.options.revert=="invalid"&&!B||this.options.revert=="valid"&&B||this.options.revert===true||A.isFunction(this.options.revert)&&this.options.revert.call(this.element,B)){var D=this;A(this.helper).animate(this.originalPosition,parseInt(this.options.revertDuration,10),function(){D._trigger("stop",C)!==false&&D._clear()})}else{this._trigger("stop",C)!==false&&this._clear()}return false},_mouseUp:function(B){this.options.iframeFix===true&&A("div.ui-draggable-iframeFix").each(function(){this.parentNode.removeChild(this)});return A.ui.mouse.prototype._mouseUp.call(this,B)},cancel:function(){this.helper.is(".ui-draggable-dragging")?this._mouseUp({}):this._clear();return this},_getHandle:function(C){var B=!this.options.handle||!A(this.options.handle,this.element).length?true:false;A(this.options.handle,this.element).find("*").andSelf().each(function(){if(this==C.target){B=true}});return B},_createHelper:function(C){var B=this.options;C=A.isFunction(B.helper)?A(B.helper.apply(this.element[0],[C])):B.helper=="clone"?this.element.clone().removeAttr("id"):this.element;C.parents("body").length||C.appendTo(B.appendTo=="parent"?this.element[0].parentNode:B.appendTo);C[0]!=this.element[0]&&!/(fixed|absolute)/.test(C.css("position"))&&C.css("position","absolute");return C},_adjustOffsetFromHelper:function(B){if(typeof B=="string"){B=B.split(" ")}if(A.isArray(B)){B={left:+B[0],top:+B[1]||0}}if("left" in B){this.offset.click.left=B.left+this.margins.left}if("right" in B){this.offset.click.left=this.helperProportions.width-B.right+this.margins.left}if("top" in B){this.offset.click.top=B.top+this.margins.top}if("bottom" in B){this.offset.click.top=this.helperProportions.height-B.bottom+this.margins.top}},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var B=this.offsetParent.offset();if(this.cssPosition=="absolute"&&this.scrollParent[0]!=document&&A.ui.contains(this.scrollParent[0],this.offsetParent[0])){B.left+=this.scrollParent.scrollLeft();B.top+=this.scrollParent.scrollTop()}if(this.offsetParent[0]==document.body||this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&A.browser.msie){B={top:0,left:0}}return{top:B.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:B.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var B=this.element.position();return{top:B.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:B.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}else{return{top:0,left:0}}},_cacheMargins:function(){this.margins={left:parseInt(this.element.css("marginLeft"),10)||0,top:parseInt(this.element.css("marginTop"),10)||0,right:parseInt(this.element.css("marginRight"),10)||0,bottom:parseInt(this.element.css("marginBottom"),10)||0}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var C=this.options;if(C.containment=="parent"){C.containment=this.helper[0].parentNode}if(C.containment=="document"||C.containment=="window"){this.containment=[(C.containment=="document"?0:A(window).scrollLeft())-this.offset.relative.left-this.offset.parent.left,(C.containment=="document"?0:A(window).scrollTop())-this.offset.relative.top-this.offset.parent.top,(C.containment=="document"?0:A(window).scrollLeft())+A(C.containment=="document"?document:window).width()-this.helperProportions.width-this.margins.left,(C.containment=="document"?0:A(window).scrollTop())+(A(C.containment=="document"?document:window).height()||document.body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top]}if(!/^(document|window|parent)$/.test(C.containment)&&C.containment.constructor!=Array){C=A(C.containment);var B=C[0];if(B){C.offset();var D=A(B).css("overflow")!="hidden";this.containment=[(parseInt(A(B).css("borderLeftWidth"),10)||0)+(parseInt(A(B).css("paddingLeft"),10)||0),(parseInt(A(B).css("borderTopWidth"),10)||0)+(parseInt(A(B).css("paddingTop"),10)||0),(D?Math.max(B.scrollWidth,B.offsetWidth):B.offsetWidth)-(parseInt(A(B).css("borderLeftWidth"),10)||0)-(parseInt(A(B).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left-this.margins.right,(D?Math.max(B.scrollHeight,B.offsetHeight):B.offsetHeight)-(parseInt(A(B).css("borderTopWidth"),10)||0)-(parseInt(A(B).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top-this.margins.bottom];this.relative_container=C}}else{if(C.containment.constructor==Array){this.containment=C.containment}}},_convertPositionTo:function(C,B){if(!B){B=this.position}C=C=="absolute"?1:-1;var E=this.cssPosition=="absolute"&&!(this.scrollParent[0]!=document&&A.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,D=/(html|body)/i.test(E[0].tagName);return{top:B.top+this.offset.relative.top*C+this.offset.parent.top*C-(A.browser.safari&&A.browser.version<526&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():D?0:E.scrollTop())*C),left:B.left+this.offset.relative.left*C+this.offset.parent.left*C-(A.browser.safari&&A.browser.version<526&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():D?0:E.scrollLeft())*C)}},_generatePosition:function(C){var B=this.options,H=this.cssPosition=="absolute"&&!(this.scrollParent[0]!=document&&A.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,F=/(html|body)/i.test(H[0].tagName),G=C.pageX,D=C.pageY;if(this.originalPosition){var E;if(this.containment){if(this.relative_container){E=this.relative_container.offset();E=[this.containment[0]+E.left,this.containment[1]+E.top,this.containment[2]+E.left,this.containment[3]+E.top]}else{E=this.containment}if(C.pageX-this.offset.click.left<E[0]){G=E[0]+this.offset.click.left}if(C.pageY-this.offset.click.top<E[1]){D=E[1]+this.offset.click.top}if(C.pageX-this.offset.click.left>E[2]){G=E[2]+this.offset.click.left}if(C.pageY-this.offset.click.top>E[3]){D=E[3]+this.offset.click.top}}if(B.grid){D=this.originalPageY+Math.round((D-this.originalPageY)/B.grid[1])*B.grid[1];D=E?!(D-this.offset.click.top<E[1]||D-this.offset.click.top>E[3])?D:!(D-this.offset.click.top<E[1])?D-B.grid[1]:D+B.grid[1]:D;G=this.originalPageX+Math.round((G-this.originalPageX)/B.grid[0])*B.grid[0];G=E?!(G-this.offset.click.left<E[0]||G-this.offset.click.left>E[2])?G:!(G-this.offset.click.left<E[0])?G-B.grid[0]:G+B.grid[0]:G}}return{top:D-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(A.browser.safari&&A.browser.version<526&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollTop():F?0:H.scrollTop()),left:G-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(A.browser.safari&&A.browser.version<526&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():F?0:H.scrollLeft())}},_clear:function(){this.helper.removeClass("ui-draggable-dragging");this.helper[0]!=this.element[0]&&!this.cancelHelperRemoval&&this.helper.remove();this.helper=null;this.cancelHelperRemoval=false},_trigger:function(C,B,D){D=D||this._uiHash();A.ui.plugin.call(this,C,[B,D]);if(C=="drag"){this.positionAbs=this._convertPositionTo("absolute")}return A.Widget.prototype._trigger.call(this,C,B,D)},plugins:{},_uiHash:function(){return{helper:this.helper,position:this.position,originalPosition:this.originalPosition,offset:this.positionAbs}}});A.extend(A.ui.draggable,{version:"1.8.13"});A.ui.plugin.add("draggable","connectToSortable",{start:function(C,B){var F=A(this).data("draggable"),D=F.options,E=A.extend({},B,{item:F.element});F.sortables=[];A(D.connectToSortable).each(function(){var G=A.data(this,"sortable");if(G&&!G.options.disabled){F.sortables.push({instance:G,shouldRevert:G.options.revert});G.refreshPositions();G._trigger("activate",C,E)}})},stop:function(C,B){var E=A(this).data("draggable"),D=A.extend({},B,{item:E.element});A.each(E.sortables,function(){if(this.instance.isOver){this.instance.isOver=0;E.cancelHelperRemoval=true;this.instance.cancelHelperRemoval=false;if(this.shouldRevert){this.instance.options.revert=true}this.instance._mouseStop(C);this.instance.options.helper=this.instance.options._helper;E.options.helper=="original"&&this.instance.currentItem.css({top:"auto",left:"auto"})}else{this.instance.cancelHelperRemoval=false;this.instance._trigger("deactivate",C,D)}})},drag:function(C,B){var E=A(this).data("draggable"),D=this;A.each(E.sortables,function(){this.instance.positionAbs=E.positionAbs;this.instance.helperProportions=E.helperProportions;this.instance.offset.click=E.offset.click;if(this.instance._intersectsWith(this.instance.containerCache)){if(!this.instance.isOver){this.instance.isOver=1;this.instance.currentItem=A(D).clone().removeAttr("id").appendTo(this.instance.element).data("sortable-item",true);this.instance.options._helper=this.instance.options.helper;this.instance.options.helper=function(){return B.helper[0]};C.target=this.instance.currentItem[0];this.instance._mouseCapture(C,true);this.instance._mouseStart(C,true,true);this.instance.offset.click.top=E.offset.click.top;this.instance.offset.click.left=E.offset.click.left;this.instance.offset.parent.left-=E.offset.parent.left-this.instance.offset.parent.left;this.instance.offset.parent.top-=E.offset.parent.top-this.instance.offset.parent.top;E._trigger("toSortable",C);E.dropped=this.instance.element;E.currentItem=E.element;this.instance.fromOutside=E}this.instance.currentItem&&this.instance._mouseDrag(C)}else{if(this.instance.isOver){this.instance.isOver=0;this.instance.cancelHelperRemoval=true;this.instance.options.revert=false;this.instance._trigger("out",C,this.instance._uiHash(this.instance));this.instance._mouseStop(C,true);this.instance.options.helper=this.instance.options._helper;this.instance.currentItem.remove();this.instance.placeholder&&this.instance.placeholder.remove();E._trigger("fromSortable",C);E.dropped=false}}})}});A.ui.plugin.add("draggable","cursor",{start:function(){var C=A("body"),B=A(this).data("draggable").options;if(C.css("cursor")){B._cursor=C.css("cursor")}C.css("cursor",B.cursor)},stop:function(){var B=A(this).data("draggable").options;B._cursor&&A("body").css("cursor",B._cursor)}});A.ui.plugin.add("draggable","opacity",{start:function(C,B){C=A(B.helper);B=A(this).data("draggable").options;if(C.css("opacity")){B._opacity=C.css("opacity")}C.css("opacity",B.opacity)},stop:function(C,B){C=A(this).data("draggable").options;C._opacity&&A(B.helper).css("opacity",C._opacity)}});A.ui.plugin.add("draggable","scroll",{start:function(){var B=A(this).data("draggable");if(B.scrollParent[0]!=document&&B.scrollParent[0].tagName!="HTML"){B.overflowOffset=B.scrollParent.offset()}},drag:function(C){var B=A(this).data("draggable"),E=B.options,D=false;if(B.scrollParent[0]!=document&&B.scrollParent[0].tagName!="HTML"){if(!E.axis||E.axis!="x"){if(B.overflowOffset.top+B.scrollParent[0].offsetHeight-C.pageY<E.scrollSensitivity){B.scrollParent[0].scrollTop=D=B.scrollParent[0].scrollTop+E.scrollSpeed}else{if(C.pageY-B.overflowOffset.top<E.scrollSensitivity){B.scrollParent[0].scrollTop=D=B.scrollParent[0].scrollTop-E.scrollSpeed}}}if(!E.axis||E.axis!="y"){if(B.overflowOffset.left+B.scrollParent[0].offsetWidth-C.pageX<E.scrollSensitivity){B.scrollParent[0].scrollLeft=D=B.scrollParent[0].scrollLeft+E.scrollSpeed}else{if(C.pageX-B.overflowOffset.left<E.scrollSensitivity){B.scrollParent[0].scrollLeft=D=B.scrollParent[0].scrollLeft-E.scrollSpeed}}}}else{if(!E.axis||E.axis!="x"){if(C.pageY-A(document).scrollTop()<E.scrollSensitivity){D=A(document).scrollTop(A(document).scrollTop()-E.scrollSpeed)}else{if(A(window).height()-(C.pageY-A(document).scrollTop())<E.scrollSensitivity){D=A(document).scrollTop(A(document).scrollTop()+E.scrollSpeed)}}}if(!E.axis||E.axis!="y"){if(C.pageX-A(document).scrollLeft()<E.scrollSensitivity){D=A(document).scrollLeft(A(document).scrollLeft()-E.scrollSpeed)}else{if(A(window).width()-(C.pageX-A(document).scrollLeft())<E.scrollSensitivity){D=A(document).scrollLeft(A(document).scrollLeft()+E.scrollSpeed)}}}}D!==false&&A.ui.ddmanager&&!E.dropBehaviour&&A.ui.ddmanager.prepareOffsets(B,C)}});A.ui.plugin.add("draggable","snap",{start:function(){var C=A(this).data("draggable"),B=C.options;C.snapElements=[];A(B.snap.constructor!=String?B.snap.items||":data(draggable)":B.snap).each(function(){var E=A(this),D=E.offset();this!=C.element[0]&&C.snapElements.push({item:this,width:E.outerWidth(),height:E.outerHeight(),top:D.top,left:D.left})})},drag:function(T,S){for(var R=A(this).data("draggable"),P=R.options,Q=P.snapTolerance,N=S.offset.left,O=N+R.helperProportions.width,H=S.offset.top,G=H+R.helperProportions.height,M=R.snapElements.length-1;M>=0;M--){var L=R.snapElements[M].left,J=L+R.snapElements[M].width,K=R.snapElements[M].top,I=K+R.snapElements[M].height;if(L-Q<N&&N<J+Q&&K-Q<H&&H<I+Q||L-Q<N&&N<J+Q&&K-Q<G&&G<I+Q||L-Q<O&&O<J+Q&&K-Q<H&&H<I+Q||L-Q<O&&O<J+Q&&K-Q<G&&G<I+Q){if(P.snapMode!="inner"){var F=Math.abs(K-G)<=Q,E=Math.abs(I-H)<=Q,D=Math.abs(L-O)<=Q,C=Math.abs(J-N)<=Q;if(F){S.position.top=R._convertPositionTo("relative",{top:K-R.helperProportions.height,left:0}).top-R.margins.top}if(E){S.position.top=R._convertPositionTo("relative",{top:I,left:0}).top-R.margins.top}if(D){S.position.left=R._convertPositionTo("relative",{top:0,left:L-R.helperProportions.width}).left-R.margins.left}if(C){S.position.left=R._convertPositionTo("relative",{top:0,left:J}).left-R.margins.left}}var B=F||E||D||C;if(P.snapMode!="outer"){F=Math.abs(K-H)<=Q;E=Math.abs(I-G)<=Q;D=Math.abs(L-N)<=Q;C=Math.abs(J-O)<=Q;if(F){S.position.top=R._convertPositionTo("relative",{top:K,left:0}).top-R.margins.top}if(E){S.position.top=R._convertPositionTo("relative",{top:I-R.helperProportions.height,left:0}).top-R.margins.top}if(D){S.position.left=R._convertPositionTo("relative",{top:0,left:L}).left-R.margins.left}if(C){S.position.left=R._convertPositionTo("relative",{top:0,left:J-R.helperProportions.width}).left-R.margins.left}}if(!R.snapElements[M].snapping&&(F||E||D||C||B)){R.options.snap.snap&&R.options.snap.snap.call(R.element,T,A.extend(R._uiHash(),{snapItem:R.snapElements[M].item}))}R.snapElements[M].snapping=F||E||D||C||B}else{R.snapElements[M].snapping&&R.options.snap.release&&R.options.snap.release.call(R.element,T,A.extend(R._uiHash(),{snapItem:R.snapElements[M].item}));R.snapElements[M].snapping=false}}}});A.ui.plugin.add("draggable","stack",{start:function(){var C=A(this).data("draggable").options;C=A.makeArray(A(C.stack)).sort(function(E,D){return(parseInt(A(E).css("zIndex"),10)||0)-(parseInt(A(D).css("zIndex"),10)||0)});if(C.length){var B=parseInt(C[0].style.zIndex)||0;A(C).each(function(D){this.style.zIndex=B+D});this[0].style.zIndex=B+C.length}}});A.ui.plugin.add("draggable","zIndex",{start:function(C,B){C=A(B.helper);B=A(this).data("draggable").options;if(C.css("zIndex")){B._zIndex=C.css("zIndex")}C.css("zIndex",B.zIndex)},stop:function(C,B){C=A(this).data("draggable").options;C._zIndex&&A(B.helper).css("zIndex",C._zIndex)}})})(jQuery);(function(A,B){A.widget("ui.sortable",A.ui.mouse,{widgetEventPrefix:"sort",options:{appendTo:"parent",axis:false,connectWith:false,containment:false,cursor:"auto",cursorAt:false,dropOnEmpty:true,forcePlaceholderSize:false,forceHelperSize:false,grid:false,handle:false,helper:"original",items:"> *",opacity:false,placeholder:false,revert:false,scroll:true,scrollSensitivity:20,scrollSpeed:20,scope:"default",tolerance:"intersect",zIndex:1000},_create:function(){var C=this.options;this.document=C.document;this.containerCache={};this.element.addClass("ui-sortable");this.refresh();this.floating=this.items.length?C.axis==="x"||(/left|right/).test(this.items[0].item.css("float"))||(/inline|table-cell/).test(this.items[0].item.css("display")):false;this.offset=this.element.offset();this._mouseInit()},destroy:function(){this.element.removeClass("ui-sortable ui-sortable-disabled").removeData("sortable").unbind(".sortable");this._mouseDestroy();for(var C=this.items.length-1;C>=0;C--){this.items[C].item.removeData("sortable-item")}return this},_setOption:function(C,D){if(C==="disabled"){this.options[C]=D;this.widget()[D?"addClass":"removeClass"]("ui-sortable-disabled")}else{A.Widget.prototype._setOption.apply(this,arguments)}},_mouseCapture:function(F,G){if(this.reverting){return false}if(this.options.disabled||this.options.type=="static"){return false}this._refreshItems(F);var E=null,D=this,C=A(F.target).parents().each(function(){if(A.data(this,"sortable-item")==D){E=A(this);return false}});if(A.data(F.target,"sortable-item")==D){E=A(F.target)}if(!E){return false}if(this.options.handle&&!G){var H=false;A(this.options.handle,E).find("*").andSelf().each(function(){if(this==F.target){H=true}});if(!H){return false}}this.currentItem=E;this._removeCurrentsFromItems();return true},_mouseStart:function(F,G,C){var H=this.options,D=this;this.currentContainer=this;this.refreshPositions();this.helper=this._createHelper(F);this._cacheHelperProportions();this._cacheMargins();this.scrollParent=this.helper.scrollParent();this.offset=this.currentItem.offset();this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left};this.helper.css("position","absolute");this.cssPosition=this.helper.css("position");A.extend(this.offset,{click:{left:F.pageX-this.offset.left,top:F.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()});this.originalPosition=this._generatePosition(F);this.originalPageX=F.pageX;this.originalPageY=F.pageY;(H.cursorAt&&this._adjustOffsetFromHelper(H.cursorAt));this.domPosition={prev:this.currentItem.prev()[0],parent:this.currentItem.parent()[0]};if(this.helper[0]!=this.currentItem[0]){this.currentItem.hide()}this._createPlaceholder();if(H.containment){this._setContainment()}if(H.cursor){if(A("body").css("cursor")){this._storedCursor=A("body").css("cursor")}A("body").css("cursor",H.cursor)}if(H.opacity){if(this.helper.css("opacity")){this._storedOpacity=this.helper.css("opacity")}this.helper.css("opacity",H.opacity)}if(H.zIndex){if(this.helper.css("zIndex")){this._storedZIndex=this.helper.css("zIndex")}this.helper.css("zIndex",H.zIndex)}if(this.scrollParent[0]!=(this.document||document)&&this.scrollParent[0].tagName!="HTML"){this.overflowOffset=this.scrollParent.offset()}this._trigger("start",F,this._uiHash());if(!this._preserveHelperProportions){this._cacheHelperProportions()}if(!C){for(var E=this.containers.length-1;E>=0;E--){this.containers[E]._trigger("activate",F,D._uiHash(this))}}if(A.ui.ddmanager){A.ui.ddmanager.current=this}if(A.ui.ddmanager&&!H.dropBehaviour){A.ui.ddmanager.prepareOffsets(this,F)}this.dragging=true;this.helper.addClass("ui-sortable-helper");this._mouseDrag(F);return true},_mouseDrag:function(G){this.position=this._generatePosition(G);this.positionAbs=this._convertPositionTo("absolute");if(!this.lastPositionAbs){this.lastPositionAbs=this.positionAbs}if(this.options.scroll){var H=this.options,C=false;if(this.scrollParent[0]!=(this.document||document)&&this.scrollParent[0].tagName!="HTML"){if((this.overflowOffset.top+this.scrollParent[0].offsetHeight)-G.pageY<H.scrollSensitivity){this.scrollParent[0].scrollTop=C=this.scrollParent[0].scrollTop+H.scrollSpeed}else{if(G.pageY-this.overflowOffset.top<H.scrollSensitivity){this.scrollParent[0].scrollTop=C=this.scrollParent[0].scrollTop-H.scrollSpeed}}if((this.overflowOffset.left+this.scrollParent[0].offsetWidth)-G.pageX<H.scrollSensitivity){this.scrollParent[0].scrollLeft=C=this.scrollParent[0].scrollLeft+H.scrollSpeed}else{if(G.pageX-this.overflowOffset.left<H.scrollSensitivity){this.scrollParent[0].scrollLeft=C=this.scrollParent[0].scrollLeft-H.scrollSpeed}}}else{if(G.pageY-A((this.document||document)).scrollTop()<H.scrollSensitivity){C=A((this.document||document)).scrollTop(A((this.document||document)).scrollTop()-H.scrollSpeed)}else{if(A(window).height()-(G.pageY-A((this.document||document)).scrollTop())<H.scrollSensitivity){C=A((this.document||document)).scrollTop(A((this.document||document)).scrollTop()+H.scrollSpeed)}}if(G.pageX-A((this.document||document)).scrollLeft()<H.scrollSensitivity){C=A((this.document||document)).scrollLeft(A((this.document||document)).scrollLeft()-H.scrollSpeed)}else{if(A(window).width()-(G.pageX-A((this.document||document)).scrollLeft())<H.scrollSensitivity){C=A((this.document||document)).scrollLeft(A((this.document||document)).scrollLeft()+H.scrollSpeed)}}}if(C!==false&&A.ui.ddmanager&&!H.dropBehaviour){A.ui.ddmanager.prepareOffsets(this,G)}}this.positionAbs=this._convertPositionTo("absolute");if(!this.options.axis||this.options.axis!="y"){this.helper[0].style.left=this.position.left+"px"}if(!this.options.axis||this.options.axis!="x"){this.helper[0].style.top=this.position.top+"px"}for(var E=this.items.length-1;E>=0;E--){var F=this.items[E],D=F.item[0],I=this._intersectsWithPointer(F);if(!I){continue}if(D!=this.currentItem[0]&&this.placeholder[I==1?"next":"prev"]()[0]!=D&&!A.ui.contains(this.placeholder[0],D)&&(this.options.type=="semi-dynamic"?!A.ui.contains(this.element[0],D):true)){this.direction=I==1?"down":"up";if(this.options.tolerance=="pointer"||this._intersectsWithSides(F)){this._rearrange(G,F)}else{break}this._trigger("change",G,this._uiHash());break}}this._contactContainers(G);if(A.ui.ddmanager){A.ui.ddmanager.drag(this,G)}this._trigger("sort",G,this._uiHash());this.lastPositionAbs=this.positionAbs;return false},_mouseStop:function(D,E){if(!D){return }if(A.ui.ddmanager&&!this.options.dropBehaviour){A.ui.ddmanager.drop(this,D)}if(this.options.revert){var C=this;var F=C.placeholder.offset();C.reverting=true;A(this.helper).animate({left:F.left-this.offset.parent.left-C.margins.left+(this.offsetParent[0]==(this.document||document).body?0:this.offsetParent[0].scrollLeft),top:F.top-this.offset.parent.top-C.margins.top+(this.offsetParent[0]==(this.document||document).body?0:this.offsetParent[0].scrollTop)},parseInt(this.options.revert,10)||500,function(){C._clear(D)})}else{this._clear(D,E)}return false},cancel:function(){var C=this;if(this.dragging){this._mouseUp({target:null});if(this.options.helper=="original"){this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper")}else{this.currentItem.show()}for(var D=this.containers.length-1;D>=0;D--){this.containers[D]._trigger("deactivate",null,C._uiHash(this));if(this.containers[D].containerCache.over){this.containers[D]._trigger("out",null,C._uiHash(this));this.containers[D].containerCache.over=0}}}if(this.placeholder){if(this.placeholder[0].parentNode){this.placeholder[0].parentNode.removeChild(this.placeholder[0])}if(this.options.helper!="original"&&this.helper&&this.helper[0].parentNode){this.helper.remove()}A.extend(this,{helper:null,dragging:false,reverting:false,_noFinalSort:null});if(this.domPosition.prev){A(this.domPosition.prev).after(this.currentItem)}else{A(this.domPosition.parent).prepend(this.currentItem)}}return this},serialize:function(E){var C=this._getItemsAsjQuery(E&&E.connected);var D=[];E=E||{};A(C).each(function(){var F=(A(E.item||this).attr(E.attribute||"id")||"").match(E.expression||(/(.+)[-=_](.+)/));if(F){D.push((E.key||F[1]+"[]")+"="+(E.key&&E.expression?F[1]:F[2]))}});if(!D.length&&E.key){D.push(E.key+"=")}return D.join("&")},toArray:function(E){var C=this._getItemsAsjQuery(E&&E.connected);var D=[];E=E||{};C.each(function(){D.push(A(E.item||this).attr(E.attribute||"id")||"")});return D},_intersectsWith:function(L){var E=this.positionAbs.left,D=E+this.helperProportions.width,K=this.positionAbs.top,J=K+this.helperProportions.height;var F=L.left,C=F+L.width,M=L.top,I=M+L.height;var N=this.offset.click.top,H=this.offset.click.left;var G=(K+N)>M&&(K+N)<I&&(E+H)>F&&(E+H)<C;if(this.options.tolerance=="pointer"||this.options.forcePointerForContainers||(this.options.tolerance!="pointer"&&this.helperProportions[this.floating?"width":"height"]>L[this.floating?"width":"height"])){return G}else{return(F<E+(this.helperProportions.width/2)&&D-(this.helperProportions.width/2)<C&&M<K+(this.helperProportions.height/2)&&J-(this.helperProportions.height/2)<I)}},_intersectsWithPointer:function(E){var F=A.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,E.top,E.height),D=A.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,E.left,E.width),H=F&&D,C=this._getDragVerticalDirection(),G=this._getDragHorizontalDirection();if(!H){return false}return this.floating?(((G&&G=="right")||C=="down")?2:1):(C&&(C=="down"?2:1))},_intersectsWithSides:function(F){var D=A.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,F.top+(F.height/2),F.height),E=A.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,F.left+(F.width/2),F.width),C=this._getDragVerticalDirection(),G=this._getDragHorizontalDirection();if(this.floating&&G){return((G=="right"&&E)||(G=="left"&&!E))}else{return C&&((C=="down"&&D)||(C=="up"&&!D))}},_getDragVerticalDirection:function(){var C=this.positionAbs.top-this.lastPositionAbs.top;return C!=0&&(C>0?"down":"up")},_getDragHorizontalDirection:function(){var C=this.positionAbs.left-this.lastPositionAbs.left;return C!=0&&(C>0?"right":"left")},refresh:function(C){this._refreshItems(C);this.refreshPositions();return this},_connectWith:function(){var C=this.options;return C.connectWith.constructor==String?[C.connectWith]:C.connectWith},_getItemsAsjQuery:function(C){var K=this;var H=[];var F=[];var I=this._connectWith();if(I&&C){for(var E=I.length-1;E>=0;E--){var J=A(I[E]);for(var D=J.length-1;D>=0;D--){var G=A.data(J[D],"sortable");if(G&&G!=this&&!G.options.disabled){F.push([A.isFunction(G.options.items)?G.options.items.call(G.element):A(G.options.items,G.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),G])}}}}F.push([A.isFunction(this.options.items)?this.options.items.call(this.element,null,{options:this.options,item:this.currentItem}):A(this.options.items,this.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),this]);for(var E=F.length-1;E>=0;E--){F[E][0].each(function(){H.push(this)})}return A(H)},_removeCurrentsFromItems:function(){var E=this.currentItem.find(":data(sortable-item)");for(var D=0;D<this.items.length;D++){for(var C=0;C<E.length;C++){if(E[C]==this.items[D].item[0]){this.items.splice(D,1)}}}},_refreshItems:function(C){this.items=[];this.containers=[this];var I=this.items;var O=this;var G=[[A.isFunction(this.options.items)?this.options.items.call(this.element[0],C,{item:this.currentItem}):A(this.options.items,this.element),this]];var K=this._connectWith();if(K){for(var F=K.length-1;F>=0;F--){var L=A(K[F]);for(var E=L.length-1;E>=0;E--){var H=A.data(L[E],"sortable");if(H&&H!=this&&!H.options.disabled){G.push([A.isFunction(H.options.items)?H.options.items.call(H.element[0],C,{item:this.currentItem}):A(H.options.items,H.element),H]);this.containers.push(H)}}}}for(var F=G.length-1;F>=0;F--){var J=G[F][1];var D=G[F][0];for(var E=0,M=D.length;E<M;E++){var N=A(D[E]);N.data("sortable-item",J);I.push({item:N,instance:J,width:0,height:0,left:0,top:0})}}},refreshPositions:function(C){if(this.offsetParent&&this.helper){this.offset.parent=this._getParentOffset()}for(var E=this.items.length-1;E>=0;E--){var F=this.items[E];if(F.instance!=this.currentContainer&&this.currentContainer&&F.item[0]!=this.currentItem[0]){continue}var D=this.options.toleranceElement?A(this.options.toleranceElement,F.item):F.item;if(!C){F.width=D.outerWidth();F.height=D.outerHeight()}var G=D.offset();F.left=G.left;F.top=G.top}if(this.options.custom&&this.options.custom.refreshContainers){this.options.custom.refreshContainers.call(this)}else{for(var E=this.containers.length-1;E>=0;E--){var G=this.containers[E].element.offset();this.containers[E].containerCache.left=G.left;this.containers[E].containerCache.top=G.top;this.containers[E].containerCache.width=this.containers[E].element.outerWidth();this.containers[E].containerCache.height=this.containers[E].element.outerHeight()}}return this},_createPlaceholder:function(E){var C=E||this,F=C.options;if(!F.placeholder||F.placeholder.constructor==String){var D=F.placeholder;F.placeholder={element:function(){var G=A((this.document||document).createElement(C.currentItem[0].nodeName)).addClass(D||C.currentItem[0].className+" ui-sortable-placeholder").removeClass("ui-sortable-helper")[0];if(!D){G.style.visibility="hidden"}return G},update:function(G,H){if(D&&!F.forcePlaceholderSize){return }if(!H.height()){H.height(C.currentItem.innerHeight()-parseInt(C.currentItem.css("paddingTop")||0,10)-parseInt(C.currentItem.css("paddingBottom")||0,10))}if(!H.width()){H.width(C.currentItem.innerWidth()-parseInt(C.currentItem.css("paddingLeft")||0,10)-parseInt(C.currentItem.css("paddingRight")||0,10))}}}}C.placeholder=A(F.placeholder.element.call(C.element,C.currentItem));C.currentItem.after(C.placeholder);F.placeholder.update(C,C.placeholder)},_contactContainers:function(C){var E=null,J=null;for(var G=this.containers.length-1;G>=0;G--){if(A.ui.contains(this.currentItem[0],this.containers[G].element[0])){continue}if(this._intersectsWith(this.containers[G].containerCache)){if(E&&A.ui.contains(this.containers[G].element[0],E.element[0])){continue}E=this.containers[G];J=G}else{if(this.containers[G].containerCache.over){this.containers[G]._trigger("out",C,this._uiHash(this));this.containers[G].containerCache.over=0}}}if(!E){return }if(this.containers.length===1){this.containers[J]._trigger("over",C,this._uiHash(this));this.containers[J].containerCache.over=1}else{if(this.currentContainer!=this.containers[J]){var I=10000;var H=null;var D=this.positionAbs[this.containers[J].floating?"left":"top"];for(var F=this.items.length-1;F>=0;F--){if(!A.ui.contains(this.containers[J].element[0],this.items[F].item[0])){continue}var K=this.items[F][this.containers[J].floating?"left":"top"];if(Math.abs(K-D)<I){I=Math.abs(K-D);H=this.items[F]}}if(!H&&!this.options.dropOnEmpty){return }this.currentContainer=this.containers[J];H?this._rearrange(C,H,null,true):this._rearrange(C,null,this.containers[J].element,true);this._trigger("change",C,this._uiHash());this.containers[J]._trigger("change",C,this._uiHash(this));this.options.placeholder.update(this.currentContainer,this.placeholder);this.containers[J]._trigger("over",C,this._uiHash(this));this.containers[J].containerCache.over=1}}},_createHelper:function(D){var E=this.options;var C=A.isFunction(E.helper)?A(E.helper.apply(this.element[0],[D,this.currentItem])):(E.helper=="clone"?this.currentItem.clone():this.currentItem);if(!C.parents("body").length){A(E.appendTo!="parent"?E.appendTo:this.currentItem[0].parentNode)[0].appendChild(C[0])}if(C[0]==this.currentItem[0]){this._storedCSS={width:this.currentItem[0].style.width,height:this.currentItem[0].style.height,position:this.currentItem.css("position"),top:this.currentItem.css("top"),left:this.currentItem.css("left")}}if(C[0].style.width==""||E.forceHelperSize){C.width(this.currentItem.width())}if(C[0].style.height==""||E.forceHelperSize){C.height(this.currentItem.height())}return C},_adjustOffsetFromHelper:function(C){if(typeof C=="string"){C=C.split(" ")}if(A.isArray(C)){C={left:+C[0],top:+C[1]||0}}if("left" in C){this.offset.click.left=C.left+this.margins.left}if("right" in C){this.offset.click.left=this.helperProportions.width-C.right+this.margins.left}if("top" in C){this.offset.click.top=C.top+this.margins.top}if("bottom" in C){this.offset.click.top=this.helperProportions.height-C.bottom+this.margins.top}},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var C=this.offsetParent.offset();if(this.cssPosition=="absolute"&&this.scrollParent[0]!=(this.document||document)&&A.ui.contains(this.scrollParent[0],this.offsetParent[0])){C.left+=this.scrollParent.scrollLeft();C.top+=this.scrollParent.scrollTop()}if((this.offsetParent[0]==(this.document||document).body)||(this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&A.browser.msie)){C={top:0,left:0}}return{top:C.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:C.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var C=this.currentItem.position();return{top:C.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:C.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}else{return{top:0,left:0}}},_cacheMargins:function(){this.margins={left:(parseInt(this.currentItem.css("marginLeft"),10)||0),top:(parseInt(this.currentItem.css("marginTop"),10)||0)}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var F=this.options;if(F.containment=="parent"){F.containment=this.helper[0].parentNode}if(F.containment=="document"||F.containment=="window"){this.containment=[0-this.offset.relative.left-this.offset.parent.left,0-this.offset.relative.top-this.offset.parent.top,A(F.containment=="document"?(this.document||document):window).width()-this.helperProportions.width-this.margins.left,(A(F.containment=="document"?(this.document||document):window).height()||(this.document||document).body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top]}if(!(/^(document|window|parent)$/).test(F.containment)){var D=A(F.containment)[0];var E=A(F.containment).offset();var C=(A(D).css("overflow")!="hidden");this.containment=[E.left+(parseInt(A(D).css("borderLeftWidth"),10)||0)+(parseInt(A(D).css("paddingLeft"),10)||0)-this.margins.left,E.top+(parseInt(A(D).css("borderTopWidth"),10)||0)+(parseInt(A(D).css("paddingTop"),10)||0)-this.margins.top,E.left+(C?Math.max(D.scrollWidth,D.offsetWidth):D.offsetWidth)-(parseInt(A(D).css("borderLeftWidth"),10)||0)-(parseInt(A(D).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left,E.top+(C?Math.max(D.scrollHeight,D.offsetHeight):D.offsetHeight)-(parseInt(A(D).css("borderTopWidth"),10)||0)-(parseInt(A(D).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top]}},_convertPositionTo:function(F,H){if(!H){H=this.position}var D=F=="absolute"?1:-1;var E=this.options,C=this.cssPosition=="absolute"&&!(this.scrollParent[0]!=(this.document||document)&&A.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,G=(/(html|body)/i).test(C[0].tagName);return{top:(H.top+this.offset.relative.top*D+this.offset.parent.top*D-(A.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():(G?0:C.scrollTop()))*D)),left:(H.left+this.offset.relative.left*D+this.offset.parent.left*D-(A.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():G?0:C.scrollLeft())*D))}},_generatePosition:function(F){var I=this.options,C=this.cssPosition=="absolute"&&!(this.scrollParent[0]!=(this.document||document)&&A.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,J=(/(html|body)/i).test(C[0].tagName);if(this.cssPosition=="relative"&&!(this.scrollParent[0]!=(this.document||document)&&this.scrollParent[0]!=this.offsetParent[0])){this.offset.relative=this._getRelativeOffset()}var E=F.pageX;var D=F.pageY;if(this.originalPosition){if(this.containment){if(F.pageX-this.offset.click.left<this.containment[0]){E=this.containment[0]+this.offset.click.left}if(F.pageY-this.offset.click.top<this.containment[1]){D=this.containment[1]+this.offset.click.top}if(F.pageX-this.offset.click.left>this.containment[2]){E=this.containment[2]+this.offset.click.left}if(F.pageY-this.offset.click.top>this.containment[3]){D=this.containment[3]+this.offset.click.top}}if(I.grid){var H=this.originalPageY+Math.round((D-this.originalPageY)/I.grid[1])*I.grid[1];D=this.containment?(!(H-this.offset.click.top<this.containment[1]||H-this.offset.click.top>this.containment[3])?H:(!(H-this.offset.click.top<this.containment[1])?H-I.grid[1]:H+I.grid[1])):H;var G=this.originalPageX+Math.round((E-this.originalPageX)/I.grid[0])*I.grid[0];E=this.containment?(!(G-this.offset.click.left<this.containment[0]||G-this.offset.click.left>this.containment[2])?G:(!(G-this.offset.click.left<this.containment[0])?G-I.grid[0]:G+I.grid[0])):G}}return{top:(D-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(A.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():(J?0:C.scrollTop())))),left:(E-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(A.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():J?0:C.scrollLeft())))}},_rearrange:function(H,G,D,F){D?D[0].appendChild(this.placeholder[0]):G.item[0].parentNode.insertBefore(this.placeholder[0],(this.direction=="down"?G.item[0]:G.item[0].nextSibling));this.counter=this.counter?++this.counter:1;var E=this,C=this.counter;window.setTimeout(function(){if(C==E.counter){E.refreshPositions(!F)}},0)},_clear:function(E,F){this.reverting=false;var G=[],C=this;if(!this._noFinalSort&&this.currentItem[0].parentNode){this.placeholder.before(this.currentItem)}this._noFinalSort=null;if(this.helper[0]==this.currentItem[0]){for(var D in this._storedCSS){if(this._storedCSS[D]=="auto"||this._storedCSS[D]=="static"){this._storedCSS[D]=""}}this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper")}else{this.currentItem.show()}if(this.fromOutside&&!F){G.push(function(H){this._trigger("receive",H,this._uiHash(this.fromOutside))})}if((this.fromOutside||this.domPosition.prev!=this.currentItem.prev().not(".ui-sortable-helper")[0]||this.domPosition.parent!=this.currentItem.parent()[0])&&!F){G.push(function(H){this._trigger("update",H,this._uiHash())})}if(!A.ui.contains(this.element[0],this.currentItem[0])){if(!F){G.push(function(H){this._trigger("remove",H,this._uiHash())})}for(var D=this.containers.length-1;D>=0;D--){if(A.ui.contains(this.containers[D].element[0],this.currentItem[0])&&!F){G.push((function(H){return function(I){H._trigger("receive",I,this._uiHash(this))}}).call(this,this.containers[D]));G.push((function(H){return function(I){H._trigger("update",I,this._uiHash(this))}}).call(this,this.containers[D]))}}}for(var D=this.containers.length-1;D>=0;D--){if(!F){G.push((function(H){return function(I){H._trigger("deactivate",I,this._uiHash(this))}}).call(this,this.containers[D]))}if(this.containers[D].containerCache.over){G.push((function(H){return function(I){H._trigger("out",I,this._uiHash(this))}}).call(this,this.containers[D]));this.containers[D].containerCache.over=0}}if(this._storedCursor){A("body").css("cursor",this._storedCursor)}if(this._storedOpacity){this.helper.css("opacity",this._storedOpacity)}if(this._storedZIndex){this.helper.css("zIndex",this._storedZIndex=="auto"?"":this._storedZIndex)}this.dragging=false;if(this.cancelHelperRemoval){if(!F){this._trigger("beforeStop",E,this._uiHash());for(var D=0;D<G.length;D++){G[D].call(this,E)}this._trigger("stop",E,this._uiHash())}return false}if(!F){this._trigger("beforeStop",E,this._uiHash())}this.placeholder[0].parentNode.removeChild(this.placeholder[0]);if(this.helper[0]!=this.currentItem[0]){this.helper.remove()}this.helper=null;if(!F){for(var D=0;D<G.length;D++){G[D].call(this,E)}this._trigger("stop",E,this._uiHash())}this.fromOutside=false;return true},_trigger:function(){if(A.Widget.prototype._trigger.apply(this,arguments)===false){this.cancel()}},_uiHash:function(D){var C=D||this;return{helper:C.helper,placeholder:C.placeholder||A([]),position:C.position,originalPosition:C.originalPosition,offset:C.positionAbs,item:C.currentItem,sender:D?D.element:null}}});A.extend(A.ui.sortable,{version:"1.8.13"})})(jQuery);(function(A){A.fn.serializeObject=function(){var C={};var B=this.serializeArray();jQuery.each(B,function(){if(C[this.name]!==undefined){if(!C[this.name].push){C[this.name]=[C[this.name]]}C[this.name].push(this.value||"")}else{C[this.name]=this.value||""}});return C}})(jQuery);jQuery.extend(jQuery.easing,{easeInSine:function(B,C,A,E,D){return -E*Math.cos(C/D*(Math.PI/2))+E+A},easeOutSine:function(B,C,A,E,D){return E*Math.sin(C/D*(Math.PI/2))+A},easeInOutSine:function(B,C,A,E,D){return -E/2*(Math.cos(Math.PI*C/D)-1)+A}});(function(C){C.toJSON=function(F){if(typeof (JSON)=="object"&&JSON.stringify){return JSON.stringify(F)}var N=typeof (F);if(F===null){return"null"}if(N=="undefined"){return undefined}if(N=="number"||N=="boolean"){return F+""}if(N=="string"){return C.quoteString(F)}if(N=="object"){if(typeof (F.toJSON)=="function"){return C.toJSON(F.toJSON())}if(F.constructor===Date){var O=F.getUTCFullYear();var M=F.getUTCMonth()+1;if(M<10){M="0"+M}var P=F.getUTCDate();if(P<10){P="0"+P}var Q=F.getUTCHours();if(Q<10){Q="0"+Q}var I=F.getUTCMinutes();if(I<10){I="0"+I}var R=F.getUTCSeconds();if(R<10){R="0"+R}var K=F.getUTCMilliseconds();if(K<100){K="0"+K}if(K<10){K="0"+K}return'"'+O+"-"+M+"-"+P+"T"+Q+":"+I+":"+R+"."+K+'Z"'}if(F.constructor===Array){var L=[];for(var J=0;J<F.length;J++){L.push(C.toJSON(F[J])||"null")}return"["+L.join(",")+"]"}var E=[];for(var H in F){var D;N=typeof (H);if(N=="number"){D='"'+H+'"'}else{if(N=="string"){D=C.quoteString(H)}else{continue}}if(typeof F[H]=="function"){continue}var G=C.toJSON(F[H]);E.push(D+":"+G)}return"{"+E.join(", ")+"}"}};C.quoteString=function(D){if(D.match(A)){return'"'+D.replace(A,function(E){var F=B[E];if(typeof F==="string"){return F}F=E.charCodeAt();return"\\u00"+Math.floor(F/16).toString(16)+(F%16).toString(16)})+'"'}return'"'+D+'"'};var A=/["\\\x00-\x1f\x7f-\x9f]/g;var B={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"}})(jQuery);(function(A){A.fn.localize=function(B){this.find("*").contents().each(function(){var D=false;var C="";if(typeof (this.data)=="string"){C=A.trim(this.data);if(C&&(D=(B.sub[C]||B.top[C]))){this.data=D}}if(this.nodeName=="IMG"&&this.attributes.src){C=this.attributes.src.nodeValue;if(C&&(D=(B.sub[C]||B.top[C]))){A(this).attr("src",D)}}if(this.nodeName=="A"&&this.attributes.href){C=A.trim(this.attributes.href.nodeValue);if(C&&(D=(B.sub[C]||B.top[C]))){A(this).attr("href",D)}}if(this.nodeName=="INPUT"&&this.attributes.type){if(this.attributes.value&&["submit","reset","button"].indexOf(this.attributes.type.nodeValue.toLowerCase())>-1){C=A.trim(this.attributes.value.nodeValue);if(C&&(D=(B.sub[C]||B.top[C]))){A(this).attr("value",D)}}}return this})}})(jQuery);(function(D){D.fn.htmlClean=function(X){return this.each(function(){if(this.value){this.value=D.htmlClean(this.value,X)}else{this.innerHTML=D.htmlClean(this.innerHTML,X)}})};D.htmlClean=function(d,Z){Z=D.extend({},D.htmlClean.defaults,Z);var e=/<(\/)?(\w+:)?([\w]+)([^>]*)>/gi;var k=/(\w+)=(".*?"|'.*?'|[^\s>]*)/gi;var r;var l=new Q();var c=[l];var f=l;if(Z.bodyOnly){if(r=/<body[^>]*>((\n|.)*)<\/body>/i.exec(d)){d=r[1]}}d=d.concat("<xxx>");var o;while(r=e.exec(d)){var t=new I(r[3],r[1],r[4],Z);var g=d.substring(o,r.index);if(g.length>0){var b=f.children[f.children.length-1];if(f.children.length>0&&M(b=f.children[f.children.length-1])){f.children[f.children.length-1]=b.concat(g)}else{f.children.push(g)}}o=e.lastIndex;if(t.isClosing){if(J(c,[t.name])){c.pop();f=c[c.length-1]}}else{var X=new Q(t);var a;while(a=k.exec(t.rawAttributes)){if(a[1].toLowerCase()=="style"&&Z.replaceStyles){var h=!t.isInline;for(var n=0;n<Z.replaceStyles.length;n++){if(Z.replaceStyles[n][0].test(a[2])){if(!h){t.render=false;h=true}f.children.push(X);c.push(X);f=X;t=new I(Z.replaceStyles[n][1],"","",Z);X=new Q(t)}}}if(t.allowedAttributes!=null&&(t.allowedAttributes.length==0||D.inArray(a[1],t.allowedAttributes)>-1)){X.attributes.push(new A(a[1],a[2]))}}D.each(t.requiredAttributes,function(){var i=this.toString();if(!X.hasAttribute(i)){X.attributes.push(new A(i,""))}});for(var m=0;m<Z.replace.length;m++){for(var q=0;q<Z.replace[m][0].length;q++){var p=typeof (Z.replace[m][0][q])=="string";if((p&&Z.replace[m][0][q]==t.name)||(!p&&Z.replace[m][0][q].test(r))){t.render=false;f.children.push(X);c.push(X);f=X;t=new I(Z.replace[m][1],r[1],r[4],Z);X=new Q(t);X.attributes=f.attributes;m=Z.replace.length;break}}}var j=true;if(!f.isRoot){if(f.tag.isInline&&!t.isInline){j=false}else{if(f.tag.disallowNest&&t.disallowNest&&!t.requiredParent){j=false}else{if(t.requiredParent){if(j=J(c,t.requiredParent)){f=c[c.length-1]}}}}}if(j){f.children.push(X);if(t.toProtect){var Y=null;while(Y=e.exec(d)){var s=new I(Y[3],Y[1],Y[4],Z);if(s.isClosing&&s.name==t.name){X.children.push(RegExp.leftContext.substring(o));o=e.lastIndex;break}}}else{if(!t.isSelfClosing&&!t.isNonClosing){c.push(X);f=X}}}}}return V(l,Z).join("")};D.htmlClean.defaults={bodyOnly:true,allowedTags:[],removeTags:["basefont","center","dir","font","frame","frameset","iframe","isindex","menu","noframes","s","strike","u"],removeAttrs:[],allowedClasses:[],notRenderedTags:[],format:false,formatIndent:0,replace:[[["b","big"],"strong"],[["i"],"em"]],replaceStyles:[[/font-weight:\s*bold/i,"strong"],[/font-style:\s*italic/i,"em"],[/vertical-align:\s*super/i,"sup"],[/vertical-align:\s*sub/i,"sub"]]};function H(b,Z,Y,X){if(!b.tag.isInline&&Y.length>0){Y.push("\n");for(var a=0;a<X;a++){Y.push("\t")}}}function V(a,g){var Y=[],d=a.attributes.length==0,Z=0,c=null;var f=a.tag.render&&(g.allowedTags.length==0||D.inArray(a.tag.name,g.allowedTags)>-1)&&(g.removeTags.length==0||D.inArray(a.tag.name,g.removeTags)==-1);if(!a.isRoot&&f){Y.push("<");Y.push(a.tag.name);D.each(a.attributes,function(){if(D.inArray(this.name,g.removeAttrs)==-1){var h=new RegExp(/^(['"]?)(.*?)['"]?$/).exec(this.value);var i=h[2];var j=h[1]||"'";if(this.name=="class"){i=D.grep(i.split(" "),function(k){return D.grep(g.allowedClasses,function(l){return l[0]==k&&(l.length==1||D.inArray(a.tag.name,l[1])>-1)}).length>0}).join(" ");j="'"}if(i!=null&&(i.length>0||D.inArray(this.name,a.tag.requiredAttributes)>-1)){Y.push(" ");Y.push(this.name);Y.push("=");Y.push(j);Y.push(i);Y.push(j)}}})}if(a.tag.isSelfClosing){if(f){Y.push(" />")}d=false}else{if(a.tag.isNonClosing){d=false}else{if(!a.isRoot&&f){Y.push(">")}Z=g.formatIndent++;if(a.tag.toProtect){c=D.htmlClean.trim(a.children.join("")).replace(/<br>/ig,"\n");Y.push(c);d=c.length==0;g.formatIndent--}else{c=[];for(var b=0;b<a.children.length;b++){var X=a.children[b];var e=D.htmlClean.trim(C(M(X)?X:X.childrenToString()));if(P(X)){if(b>0&&e.length>0&&(U(X)||E(a.children[b-1]))){c.push(" ")}}if(M(X)){if(e.length>0){c.push(e)}}else{if(b!=a.children.length-1||X.tag.name!="br"){if(g.format){H(X,g,c,Z)}c=c.concat(V(X,g))}}}g.formatIndent--;if(c.length>0){if(g.format&&c[0]!="\n"){H(a,g,Y,Z)}Y=Y.concat(c);d=false}}if(!a.isRoot&&f){if(g.format){H(a,g,Y,Z-1)}Y.push("</");Y.push(a.tag.name);Y.push(">")}}}if(!a.tag.allowEmpty&&d){return[]}return Y}function J(X,Z,Y){Y=Y||1;if(D.inArray(X[X.length-Y].tag.name,Z)>-1){return true}else{if(X.length-(Y+1)>0&&J(X,Z,Y+1)){X.pop();return true}}return false}function Q(X){if(X){this.tag=X;this.isRoot=false}else{this.tag=new I("root");this.isRoot=true}this.attributes=[];this.children=[];this.hasAttribute=function(Y){for(var Z=0;Z<this.attributes.length;Z++){if(this.attributes[Z].name==Y){return true}}return false};this.childrenToString=function(){return this.children.join("")};return this}function A(X,Y){this.name=X;this.value=Y;return this}function I(Y,a,Z,X){this.name=Y.toLowerCase();this.isSelfClosing=D.inArray(this.name,K)>-1;this.isNonClosing=D.inArray(this.name,R)>-1;this.isClosing=(a!=undefined&&a.length>0);this.isInline=D.inArray(this.name,S)>-1;this.disallowNest=D.inArray(this.name,O)>-1;this.requiredParent=F[D.inArray(this.name,F)+1];this.allowEmpty=D.inArray(this.name,B)>-1;this.toProtect=D.inArray(this.name,G)>-1;this.rawAttributes=Z;this.allowedAttributes=L[D.inArray(this.name,L)+1];this.requiredAttributes=W[D.inArray(this.name,W)+1];this.render=X&&D.inArray(this.name,X.notRenderedTags)==-1;return this}function U(X){while(N(X)&&X.children.length>0){X=X.children[0]}return M(X)&&X.length>0&&D.htmlClean.isWhitespace(X.charAt(0))}function E(X){while(N(X)&&X.children.length>0){X=X.children[X.children.length-1]}return M(X)&&X.length>0&&D.htmlClean.isWhitespace(X.charAt(X.length-1))}function M(X){return X.constructor==String}function P(X){return M(X)||X.tag.isInline}function N(X){return X.constructor==Q}function C(X){return X.replace(/&nbsp;|\n/g," ").replace(/\s\s+/g," ")}D.htmlClean.trim=function(X){return D.htmlClean.trimStart(D.htmlClean.trimEnd(X))};D.htmlClean.trimStart=function(X){return X.substring(D.htmlClean.trimStartIndex(X))};D.htmlClean.trimStartIndex=function(X){for(var Y=0;Y<X.length-1&&D.htmlClean.isWhitespace(X.charAt(Y));Y++){}return Y};D.htmlClean.trimEnd=function(X){return X.substring(0,D.htmlClean.trimEndIndex(X))};D.htmlClean.trimEndIndex=function(Y){for(var X=Y.length-1;X>=0&&D.htmlClean.isWhitespace(Y.charAt(X));X--){}return X+1};D.htmlClean.isWhitespace=function(X){return D.inArray(X,T)!=-1};var S=["a","abbr","acronym","address","b","big","br","button","caption","cite","code","del","em","font","hr","i","input","img","ins","label","legend","map","q","samp","select","small","span","strong","sub","sup","tt","var"];var O=["h1","h2","h3","h4","h5","h6","p","th","td"];var B=["th","td"];var F=[null,"li",["ul","ol"],"dt",["dl"],"dd",["dl"],"td",["tr"],"th",["tr"],"tr",["table","thead","tbody","tfoot"],"thead",["table"],"tbody",["table"],"tfoot",["table"]];var G=["script","style","pre","code"];var K=["br","hr","img","link","meta"];var R=["!doctype","?xml"];var L=[["class"],"?xml",[],"!doctype",[],"a",["accesskey","class","href","name","title","rel","rev","type","tabindex"],"abbr",["class","title"],"acronym",["class","title"],"blockquote",["cite","class"],"button",["class","disabled","name","type","value"],"del",["cite","class","datetime"],"form",["accept","action","class","enctype","method","name"],"input",["accept","accesskey","alt","checked","class","disabled","ismap","maxlength","name","size","readonly","src","tabindex","type","usemap","value"],"img",["alt","class","height","src","width"],"ins",["cite","class","datetime"],"label",["accesskey","class","for"],"legend",["accesskey","class"],"link",["href","rel","type"],"meta",["content","http-equiv","name","scheme"],"map",["name"],"optgroup",["class","disabled","label"],"option",["class","disabled","label","selected","value"],"q",["class","cite"],"td",["colspan","rowspan"],"th",["colspan","rowspan"],"script",["src","type"],"select",["class","disabled","multiple","name","size","tabindex"],"style",["type"],"table",["class","summary"],"textarea",["accesskey","class","cols","disabled","name","readonly","rows","tabindex"]];var W=[[],"img",["alt"]];var T=[" "," ","\t","\n","\r","\f"]})(jQuery);var LiquidMetal=function(){var C=0;var H=1;var F=0.8;var E=0.9;var A=0.85;return{score:function(I,M){if(M.length==0){return F}if(M.length>I.length){return C}var L=this.buildScoreArray(I,M);var K=0;for(var J=0;J<L.length;J++){K+=L[J]}return(K/L.length)},buildScoreArray:function(N,S){var J=new Array(N.length);var L=N.toLowerCase();var R=S.toLowerCase().split("");var M=-1;var P=false;for(var K=0;K<R.length;K++){var Q=R[K];var O=L.indexOf(Q,M+1);if(O<0){return D(J,C)}if(O==0){P=true}if(G(N,O)){J[O-1]=1;D(J,A,M+1,O-1)}else{if(B(N,O)){D(J,A,M+1,O)}else{D(J,C,M+1,O)}}J[O]=H;M=O}var I=P?E:F;D(J,I,M+1);return J}};function B(J,I){var K=J.charAt(I);return("A"<=K&&K<="Z")}function G(J,I){var K=J.charAt(I-1);return(K==" "||K=="\t")}function D(M,J,L,K){L=Math.max(L||0,0);K=Math.min(K||M.length,M.length);for(var I=L;I<K;I++){M[I]=J}return M}}();var Showdown={};Showdown.converter=function(){var A;var J;var b;var I=0;this.makeHtml=function(i){A=new Array();J=new Array();b=new Array();i=i.replace(/~/g,"~T");i=i.replace(/\$/g,"~D");i=i.replace(/\r\n/g,"\n");i=i.replace(/\r/g,"\n");i="\n\n"+i+"\n\n";i=a(i);i=i.replace(/^[ \t]+$/mg,"");i=N(i);i=D(i);i=h(i);i=R(i);i=i.replace(/~D/g,"$$");i=i.replace(/~T/g,"~");i=i.replace(/https?\:\/\/[^"\s\<\>]*[^.,;'">\:\s\<\>\)\]\!]/g,function(k,j){var n=i.slice(0,j),m=i.slice(j);if(n.match(/<[^>]+$/)&&m.match(/^[^>]*>/)){return k}var l=k.replace(/^http:\/\/github.com\//,"https://github.com/");return"<a href='"+l+"'>"+k+"</a>"});i=i.replace(/[a-z0-9_\-+=.]+@[a-z0-9\-]+(\.[a-z0-9-]+)+/ig,function(j){return"<a href='mailto:"+j+"'>"+j+"</a>"});i=i.replace(/[a-f0-9]{40}/ig,function(k,j){if(typeof (GitHub)=="undefined"||typeof (GitHub.nameWithOwner)=="undefined"){return k}var m=i.slice(0,j),l=i.slice(j);if(m.match(/@$/)||(m.match(/<[^>]+$/)&&l.match(/^[^>]*>/))){return k}return"<a href='http://github.com/"+GitHub.nameWithOwner+"/commit/"+k+"'>"+k.substring(0,7)+"</a>"});i=i.replace(/([a-z0-9_\-+=.]+)@([a-f0-9]{40})/ig,function(k,o,l,j){if(typeof (GitHub)=="undefined"||typeof (GitHub.nameWithOwner)=="undefined"){return k}GitHub.repoName=GitHub.repoName||M();var n=i.slice(0,j),m=i.slice(j);if(n.match(/\/$/)||(n.match(/<[^>]+$/)&&m.match(/^[^>]*>/))){return k}return"<a href='http://github.com/"+o+"/"+GitHub.repoName+"/commit/"+l+"'>"+o+"@"+l.substring(0,7)+"</a>"});i=i.replace(/([a-z0-9_\-+=.]+\/[a-z0-9_\-+=.]+)@([a-f0-9]{40})/ig,function(j,l,k){return"<a href='http://github.com/"+l+"/commit/"+k+"'>"+l+"@"+k.substring(0,7)+"</a>"});i=i.replace(/#([0-9]+)/ig,function(l,k,j){if(typeof (GitHub)=="undefined"||typeof (GitHub.nameWithOwner)=="undefined"){return l}var n=i.slice(0,j),m=i.slice(j);if(n==""||n.match(/[a-z0-9_\-+=.]$/)||(n.match(/<[^>]+$/)&&m.match(/^[^>]*>/))){return l}return"<a href='http://github.com/"+GitHub.nameWithOwner+"/issues/#issue/"+k+"'>"+l+"</a>"});i=i.replace(/([a-z0-9_\-+=.]+)#([0-9]+)/ig,function(l,o,k,j){if(typeof (GitHub)=="undefined"||typeof (GitHub.nameWithOwner)=="undefined"){return l}GitHub.repoName=GitHub.repoName||M();var n=i.slice(0,j),m=i.slice(j);if(n.match(/\/$/)||(n.match(/<[^>]+$/)&&m.match(/^[^>]*>/))){return l}return"<a href='http://github.com/"+o+"/"+GitHub.repoName+"/issues/#issue/"+k+"'>"+l+"</a>"});i=i.replace(/([a-z0-9_\-+=.]+\/[a-z0-9_\-+=.]+)#([0-9]+)/ig,function(k,l,j){return"<a href='http://github.com/"+l+"/issues/#issue/"+j+"'>"+k+"</a>"});return i};var M=function(){return GitHub.nameWithOwner.match(/^.+\/(.+)$/)[1]};var D=function(i){var i=i.replace(/^[ ]{0,3}\[(.+)\]:[ \t]*\n?[ \t]*<?(\S+?)>?[ \t]*\n?[ \t]*(?:(\n*)["(](.+?)[")][ \t]*)?(?:\n+|\Z)/gm,function(l,n,m,k,j){n=n.toLowerCase();A[n]=H(m);if(k){return k+j}else{if(j){J[n]=j.replace(/"/g,"&quot;")}}return""});return i};var N=function(k){k=k.replace(/\n/g,"\n\n");var j="p|div|h[1-6]|blockquote|pre|table|dl|ol|ul|script|noscript|form|fieldset|iframe|math|ins|del";var i="p|div|h[1-6]|blockquote|pre|table|dl|ol|ul|script|noscript|form|fieldset|iframe|math";k=k.replace(/^(<(p|div|h[1-6]|blockquote|pre|table|dl|ol|ul|script|noscript|form|fieldset|iframe|math|ins|del)\b[^\r]*?\n<\/\2>[ \t]*(?=\n+))/gm,Y);k=k.replace(/^(<(p|div|h[1-6]|blockquote|pre|table|dl|ol|ul|script|noscript|form|fieldset|iframe|math)\b[^\r]*?.*<\/\2>[ \t]*(?=\n+)\n)/gm,Y);k=k.replace(/(\n[ ]{0,3}(<(hr)\b([^<>])*?\/?>)[ \t]*(?=\n{2,}))/g,Y);k=k.replace(/(\n\n[ ]{0,3}<!(--[^\r]*?--\s*)+>[ \t]*(?=\n{2,}))/g,Y);k=k.replace(/(?:\n\n)([ ]{0,3}(?:<([?%])[^\r]*?\2>)[ \t]*(?=\n{2,}))/g,Y);k=k.replace(/\n\n/g,"\n");return k};var Y=function(i,j){var k=j;k=k.replace(/\n\n/g,"\n");k=k.replace(/^\n/,"");k=k.replace(/\n+$/g,"");k="\n\n~K"+(b.push(k)-1)+"K\n\n";return k};var h=function(j){j=F(j);var i=P("<hr />");j=j.replace(/^[ ]{0,2}([ ]?\*[ ]?){3,}[ \t]*$/gm,i);j=j.replace(/^[ ]{0,2}([ ]?\-[ ]?){3,}[ \t]*$/gm,i);j=j.replace(/^[ ]{0,2}([ ]?\_[ ]?){3,}[ \t]*$/gm,i);j=f(j);j=B(j);j=V(j);j=N(j);j=G(j);return j};var S=function(i){i=d(i);i=L(i);i=E(i);i=g(i);i=Z(i);i=O(i);i=H(i);i=C(i);i=i.replace(/  +\n/g," <br />\n");return i};var L=function(j){var i=/(<[a-z\/!$]("[^"]*"|'[^']*'|[^'">])*>|<!(--.*?--\s*)+>)/gi;j=j.replace(i,function(l){var k=l.replace(/(.)<\/?code>(?=.)/g,"$1`");k=X(k,"\\`*_");return k});return j};var Z=function(i){i=i.replace(/(\[((?:\[[^\]]*\]|[^\[\]])*)\][ ]?(?:\n[ ]*)?\[(.*?)\])()()()()/g,e);i=i.replace(/(\[((?:\[[^\]]*\]|[^\[\]])*)\]\([ \t]*()<?(.*?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g,e);i=i.replace(/(\[([^\[\]]+)\])()()()()()/g,e);return i};var e=function(o,u,t,s,r,q,n,m){if(m==undefined){m=""}var l=u;var j=t;var k=s.toLowerCase();var i=r;var p=m;if(i==""){if(k==""){k=j.toLowerCase().replace(/ ?\n/g," ")}i="#"+k;if(A[k]!=undefined){i=A[k];if(J[k]!=undefined){p=J[k]}}else{if(l.search(/\(\s*\)$/m)>-1){i=""}else{return l}}}i=X(i,"*_");var v='<a href="'+i+'"';if(p!=""){p=p.replace(/"/g,"&quot;");p=X(p,"*_");v+=' title="'+p+'"'}v+=">"+j+"</a>";return v};var g=function(i){i=i.replace(/(!\[(.*?)\][ ]?(?:\n[ ]*)?\[(.*?)\])()()()()/g,U);i=i.replace(/(!\[(.*?)\]\s?\([ \t]*()<?(\S+?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g,U);return i};var U=function(o,u,t,s,r,q,n,m){var l=u;var k=t;var j=s.toLowerCase();var i=r;var p=m;if(!p){p=""}if(i==""){if(j==""){j=k.toLowerCase().replace(/ ?\n/g," ")}i="#"+j;if(A[j]!=undefined){i=A[j];if(J[j]!=undefined){p=J[j]}}else{return l}}k=k.replace(/"/g,"&quot;");i=X(i,"*_");var v='<img src="'+i+'" alt="'+k+'"';p=p.replace(/"/g,"&quot;");p=X(p,"*_");v+=' title="'+p+'"';v+=" />";return v};var F=function(i){i=i.replace(/^(.+)[ \t]*\n=+[ \t]*\n+/gm,function(j,k){return P("<h1>"+S(k)+"</h1>")});i=i.replace(/^(.+)[ \t]*\n-+[ \t]*\n+/gm,function(k,j){return P("<h2>"+S(j)+"</h2>")});i=i.replace(/^(\#{1,6})[ \t]*(.+?)[ \t]*\#*\n+/gm,function(j,m,l){var k=m.length;return P("<h"+k+">"+S(l)+"</h"+k+">")});return i};var Q;var f=function(j){j+="~0";var i=/^(([ ]{0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(~0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/gm;if(I){j=j.replace(i,function(l,o,n){var p=o;var m=(n.search(/[*+-]/g)>-1)?"ul":"ol";p=p.replace(/\n{2,}/g,"\n\n\n");var k=Q(p);k=k.replace(/\s+$/,"");k="<"+m+">"+k+"</"+m+">\n";return k})}else{i=/(\n\n|^\n?)(([ ]{0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(~0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/g;j=j.replace(i,function(m,q,o,l){var p=q;var r=o;var n=(l.search(/[*+-]/g)>-1)?"ul":"ol";var r=r.replace(/\n{2,}/g,"\n\n\n");var k=Q(r);k=p+"<"+n+">\n"+k+"</"+n+">\n";return k})}j=j.replace(/~0/,"");return j};Q=function(i){I++;i=i.replace(/\n{2,}$/,"\n");i+="~0";i=i.replace(/(\n)?(^[ \t]*)([*+-]|\d+[.])[ \t]+([^\r]+?(\n{1,2}))(?=\n*(~0|\2([*+-]|\d+[.])[ \t]+))/gm,function(l,n,m,k,j){var p=j;var o=n;var q=m;if(o||(p.search(/\n{2,}/)>-1)){p=h(T(p))}else{p=f(T(p));p=p.replace(/\n$/,"");p=S(p)}return"<li>"+p+"</li>\n"});i=i.replace(/~0/g,"");I--;return i};var B=function(i){i+="~0";i=i.replace(/(?:\n\n|^)((?:(?:[ ]{4}|\t).*\n+)+)(\n*[ ]{0,3}[^ \t\n]|(?=~0))/g,function(j,l,k){var m=l;var n=k;m=W(T(m));m=a(m);m=m.replace(/^\n+/g,"");m=m.replace(/\n+$/g,"");m="<pre><code>"+m+"\n</code></pre>";return P(m)+n});i=i.replace(/~0/,"");return i};var P=function(i){i=i.replace(/(^\n+|\n+$)/g,"");return"\n\n~K"+(b.push(i)-1)+"K\n\n"};var d=function(i){i=i.replace(/(^|[^\\])(`+)([^\r]*?[^`])\2(?!`)/gm,function(l,n,m,k,j){var o=k;o=o.replace(/^([ \t]*)/g,"");o=o.replace(/[ \t]*$/g,"");o=W(o);return n+"<code>"+o+"</code>"});return i};var W=function(i){i=i.replace(/&/g,"&amp;");i=i.replace(/</g,"&lt;");i=i.replace(/>/g,"&gt;");i=X(i,"*_{}[]\\",false);return i};var C=function(i){i=i.replace(/(\*\*|__)(?=\S)([^\r]*?\S[*_]*)\1/g,"<strong>$2</strong>");i=i.replace(/(\w)_(\w)/g,"$1~E95E$2");i=i.replace(/(\*|_)(?=\S)([^\r]*?\S)\1/g,"<em>$2</em>");return i};var V=function(i){i=i.replace(/((^[ \t]*>[ \t]?.+\n(.+\n)*\n*)+)/gm,function(j,k){var l=k;l=l.replace(/^[ \t]*>[ \t]?/gm,"~0");l=l.replace(/~0/g,"");l=l.replace(/^[ \t]+$/gm,"");l=h(l);l=l.replace(/(^|\n)/g,"$1  ");l=l.replace(/(\s*<pre>[^\r]+?<\/pre>)/gm,function(m,n){var o=n;o=o.replace(/^  /mg,"~0");o=o.replace(/~0/g,"");return o});return P("<blockquote>\n"+l+"\n</blockquote>")});return i};var G=function(p){p=p.replace(/^\n+/g,"");p=p.replace(/\n+$/g,"");var o=p.split(/\n{2,}/g);var l=new Array();var j=o.length;for(var k=0;k<j;k++){var n=o[k];if(n.search(/~K(\d+)K/g)>=0){l.push(n)}else{if(n.search(/\S/)>=0){n=S(n);n=n.replace(/\n/g,"<br />");n=n.replace(/^([ \t]*)/g,"<p>");n+="</p>";l.push(n)}}}j=l.length;for(var k=0;k<j;k++){while(l[k].search(/~K(\d+)K/)>=0){var m=b[RegExp.$1];m=m.replace(/\$/g,"$$$$");l[k]=l[k].replace(/~K\d+K/,m)}}return l.join("\n\n")};var H=function(i){i=i.replace(/&(?!#?[xX]?(?:[0-9a-fA-F]+|\w+);)/g,"&amp;");i=i.replace(/<(?![a-z\/?\$!])/gi,"&lt;");return i};var E=function(i){i=i.replace(/\\(\\)/g,K);i=i.replace(/\\([`*_{}\[\]()>#+-.!])/g,K);return i};var O=function(i){i=i.replace(/<((https?|ftp|dict):[^'">\s]+)>/gi,'<a href="$1">$1</a>');i=i.replace(/<(?:mailto:)?([-.\w]+\@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)>/gi,function(j,k){return c(R(k))});return i};var c=function(k){function j(m){var l="0123456789ABCDEF";var n=m.charCodeAt(0);return(l.charAt(n>>4)+l.charAt(n&15))}var i=[function(l){return"&#"+l.charCodeAt(0)+";"},function(l){return"&#x"+j(l)+";"},function(l){return l}];k="mailto:"+k;k=k.replace(/./g,function(l){if(l=="@"){l=i[Math.floor(Math.random()*2)](l)}else{if(l!=":"){var m=Math.random();l=(m>0.9?i[2](l):m>0.45?i[1](l):i[0](l))}}return l});k='<a href="'+k+'">'+k+"</a>";k=k.replace(/">.+:/g,'">');return k};var R=function(i){i=i.replace(/~E(\d+)E/g,function(j,l){var k=parseInt(l);return String.fromCharCode(k)});return i};var T=function(i){i=i.replace(/^(\t|[ ]{1,4})/gm,"~0");i=i.replace(/~0/g,"");return i};var a=function(i){i=i.replace(/\t(?=\t)/g,"    ");i=i.replace(/\t/g,"~A~B");i=i.replace(/~B(.+?)~A/g,function(j,m,l){var o=m;var k=4-o.length%4;for(var n=0;n<k;n++){o+=" "}return o});i=i.replace(/~A/g,"    ");i=i.replace(/~B/g,"");return i};var X=function(m,j,k){var i="(["+j.replace(/([\[\]\\])/g,"\\$1")+"])";if(k){i="\\\\"+i}var l=new RegExp(i,"g");m=m.replace(l,K);return m};var K=function(i,k){var j=k.charCodeAt(0);return"~E"+j+"E"}};(function(){var A=Array.prototype.slice;this.Mercury||(this.Mercury={});jQuery.extend(this.Mercury,{version:"0.6.0",Regions:Mercury.Regions||{},modalHandlers:Mercury.modalHandlers||{},lightviewHandlers:Mercury.lightviewHandlers||{},dialogHandlers:Mercury.dialogHandlers||{},preloadedViews:Mercury.preloadedViews||{},ajaxHeaders:function(){var B;B={};B[Mercury.config.csrfHeader]=Mercury.csrfToken;return B},on:function(B,C){return jQuery(window).on("mercury:"+B,C)},off:function(B,C){return jQuery(window).off("mercury:"+B,C)},one:function(B,C){return jQuery(window).one("mercury:"+B,C)},trigger:function(B,C){Mercury.log(B,C);return jQuery(window).trigger("mercury:"+B,C)},notify:function(){var B;B=1<=arguments.length?A.call(arguments,0):[];return window.alert(Mercury.I18n.apply(this,B))},warn:function(C,B){if(B==null){B=0}if(console){try{return console.warn(C)}catch(E){if(B>=1){try{return console.debug(C)}catch(D){}}}}else{if(B>=1){return Mercury.notify(C)}}},deprecated:function(B){if(console&&console.trace){B=""+B+" -- "+(console.trace())}return Mercury.warn("deprecated: "+B,1)},log:function(){if(Mercury.debug&&console){if(arguments[0]==="hide:toolbar"||arguments[0]==="show:toolbar"){return }try{return console.debug(arguments)}catch(B){}}},locale:function(){var B,D,C;if(Mercury.determinedLocale){return Mercury.determinedLocale}if(Mercury.config.localization.enabled){B=[];if(navigator.language&&(B=navigator.language.toString().split("-")).length){C=Mercury.I18n[B[0]]||{};D=B.length>1?C["_"+(B[1].toUpperCase())+"_"]:void 0}if(!Mercury.I18n[B[0]]){B=Mercury.config.localization.preferredLocale.split("-");C=Mercury.I18n[B[0]]||{};D=B.length>1?C["_"+(B[1].toUpperCase())+"_"]:void 0}}return Mercury.determinedLocale={top:C||{},sub:D||{}}},I18n:function(){var C,B,E,D;E=arguments[0],C=2<=arguments.length?A.call(arguments,1):[];B=Mercury.locale();D=(B.sub[E]||B.top[E]||E||"").toString();if(C.length){return D.printf.apply(D,C)}else{return D}}})}).call(this);(function(){String.prototype.titleize=function(){return this[0].toUpperCase()+this.slice(1)};String.prototype.toHex=function(){if(this[0]==="#"){return this}return this.replace(/rgb(a)?\(([0-9|%]+)[\s|,]?\s?([0-9|%]+)[\s|,]?\s?([0-9|%]+)[\s|,]?\s?([0-9|.|%]+\s?)?\)/gi,function(B,F,E,D,A,C){return"#"+(parseInt(E).toHex())+(parseInt(D).toHex())+(parseInt(A).toHex())})};String.prototype.regExpEscape=function(){var B,A;A=["/",".","*","+","?","|","(",")","[","]","{","}","\\"];B=new RegExp("(\\"+A.join("|\\")+")","g");return this.replace(B,"\\$1")};String.prototype.printf=function(){var H,F,C,D,B,A,G,I,E;C=this.split("%");I=C[0];G=/^([sdf])([\s\S%]*)$/;B=0;for(D=0,E=C.length;D<E;D++){F=C[D];A=G.exec(F);if(D===0||!A||arguments[D]===null){if(D>1){B+=2;I+="%"+F}continue}H=arguments[(D-1)-B];switch(A[1]){case"s":I+=H;break;case"d":case"i":I+=parseInt(H.toString(),10);break;case"f":I+=parseFloat(H)}I+=A[2]}return I};Number.prototype.toHex=function(){var A;A=this.toString(16).toUpperCase();if(A[1]){return A}else{return"0"+A}};Number.prototype.toBytes=function(){var A,B;A=parseInt(this);B=0;while(1023<A){A/=1024;B+=1}if(B){return""+(A.toFixed(2))+[""," kb"," Mb"," Gb"," Tb"," Pb"," Eb"][B]}else{return""+A+" bytes"}}}).call(this);(function(){this.Mercury.PageEditor=(function(){function A(D,B){var C;this.saveUrl=D!=null?D:null;this.options=B!=null?B:{};if(window.mercuryInstance){throw Mercury.I18n("Mercury.PageEditor can only be instantiated once.")}if(!(this.options.visible===false||this.options.visible==="false")){this.options.visible=true}this.visible=this.options.visible;if(!(this.options.saveDataType===false||this.options.saveDataType)){this.options.saveDataType="json"}window.mercuryInstance=this;this.regions=[];this.initializeInterface();if(C=jQuery(Mercury.config.csrfSelector).attr("content")){Mercury.csrfToken=C}}A.prototype.initializeInterface=function(){var B,D,C=this;this.focusableElement=jQuery("<input>",{"class":"mercury-focusable",type:"text"}).appendTo((B=this.options.appendTo)!=null?B:"body");this.iframe=jQuery("<iframe>",{id:"mercury_iframe","class":"mercury-iframe",seamless:"true",frameborder:"0",src:"about:blank"});this.iframe.appendTo((D=jQuery(this.options.appendTo).get(0))!=null?D:"body");this.toolbar=new Mercury.Toolbar(this.options);this.statusbar=new Mercury.Statusbar(this.options);this.resize();this.iframe.on("load",function(){return C.initializeFrame()});this.iframe.one("load",function(){return C.bindEvents()});return this.loadIframeSrc(null)};A.prototype.initializeFrame=function(){var C;try{if(this.iframe.data("loaded")){return }this.iframe.data("loaded",true);if(jQuery.browser.opera){Mercury.notify("Opera isn't a fully supported browser, your results may not be optimal.")}this.document=jQuery(this.iframe.get(0).contentWindow.document);jQuery('<style mercury-styles="true">').html(Mercury.config.injectedStyles).appendTo(this.document.find("head"));C=this.iframe.get(0).contentWindow;jQuery.globalEval=function(D){if(D&&/\S/.test(D)){return(C.execScript||function(E){return C["eval"].call(C,E)})(D)}};C.Mercury=Mercury;if(window.History&&History.Adapter){C.History=History}this.bindDocumentEvents();this.resize();this.initializeRegions();this.finalizeInterface();Mercury.trigger("ready");if(C.jQuery){C.jQuery(C).trigger("mercury:ready")}if(C.Event&&C.Event.fire){C.Event.fire(C,"mercury:ready")}if(C.onMercuryReady){C.onMercuryReady()}return this.iframe.css({visibility:"visible"})}catch(B){return Mercury.notify("Mercury.PageEditor failed to load: %s\n\nPlease try refreshing.",B)}};A.prototype.initializeRegions=function(){var H,G,E,D,B,F,I,C;this.regions=[];F=jQuery("["+Mercury.config.regions.attribute+"]",this.document);for(G=0,D=F.length;G<D;G++){H=F[G];this.buildRegion(jQuery(H))}if(!this.visible){return }I=this.regions;C=[];for(E=0,B=I.length;E<B;E++){H=I[E];if(H.focus){H.focus();break}else{C.push(void 0)}}return C};A.prototype.buildRegion=function(D){var C,B;if(D.data("region")){D=D.data("region")}else{C=(D.attr(Mercury.config.regions.attribute)||(typeof (B=Mercury.config.regions).determineType==="function"?B.determineType(D):void 0)||"unknown").titleize();if(C==="Unknown"||!Mercury.Regions[C]){throw Mercury.I18n('Region type is malformed, no data-type provided, or "%s" is unknown for the "%s" region.',C,D.attr("id")||"unknown")}if(!Mercury.Regions[C].supported){Mercury.notify("Mercury.Regions.%s is unsupported in this client. Supported browsers are %s.",C,Mercury.Regions[C].supportedText);return false}D=new Mercury.Regions[C](D,this.iframe.get(0).contentWindow);if(this.previewing){D.togglePreview()}}return this.regions.push(D)};A.prototype.finalizeInterface=function(){var B;this.santizerElement=jQuery("<div>",{id:"mercury_sanitizer",contenteditable:"true",style:"position:fixed;width:100px;height:100px;top:0;left:-100px;opacity:0;overflow:hidden"});this.santizerElement.appendTo((B=this.options.appendTo)!=null?B:this.document.find("body"));if(this.snippetToolbar){this.snippetToolbar.release()}this.snippetToolbar=new Mercury.SnippetToolbar(this.document);this.hijackLinksAndForms();if(!this.visible){return Mercury.trigger("mode",{mode:"preview"})}};A.prototype.bindDocumentEvents=function(){var B=this;this.document.on("mousedown",function(C){Mercury.trigger("hide:dialogs");if(Mercury.region){if(jQuery(C.target).closest("["+Mercury.config.regions.attribute+"]").get(0)!==Mercury.region.element.get(0)){return Mercury.trigger("unfocus:regions")}}});return jQuery(this.document).bind("keydown",function(C){if(!(C.ctrlKey||C.metaKey)){return }if(C.keyCode===83){Mercury.trigger("action",{action:"save"});return C.preventDefault()}})};A.prototype.bindEvents=function(){var B=this;Mercury.on("initialize:frame",function(){return setTimeout(B.initializeFrame,100)});Mercury.on("focus:frame",function(){return B.iframe.focus()});Mercury.on("focus:window",function(){return setTimeout((function(){return B.focusableElement.focus()}),10)});Mercury.on("toggle:interface",function(){return B.toggleInterface()});Mercury.on("reinitialize",function(){return B.initializeRegions()});Mercury.on("mode",function(D,C){if(C.mode==="preview"){return B.previewing=!B.previewing}});Mercury.on("action",function(D,C){var E;E=Mercury.config.globalBehaviors[C.action]||B[C.action];if(typeof E!=="function"){return }C.already_handled=true;return E.call(B,C)});jQuery(window).on("resize",function(){return B.resize()});jQuery(window).bind("keydown",function(C){if(!(C.ctrlKey||C.metaKey)){return }if(C.keyCode===83){Mercury.trigger("action",{action:"save"});return C.preventDefault()}});return window.onbeforeunload=this.beforeUnload};A.prototype.toggleInterface=function(){if(this.visible){this.visible=false;this.toolbar.hide();this.statusbar.hide();if(!this.previewing){Mercury.trigger("mode",{mode:"preview"})}this.previewing=true}else{this.visible=true;this.toolbar.show();this.statusbar.show();Mercury.trigger("mode",{mode:"preview"});this.previewing=false}return this.resize()};A.prototype.resize=function(){var B,D,C;C=jQuery(window).width();B=this.statusbar.top();D=this.toolbar.height();Mercury.displayRect={top:D,left:0,width:C,height:B-D,fullHeight:B};this.iframe.css({top:D,left:0,height:B-D});return Mercury.trigger("resize")};A.prototype.iframeSrc=function(B,E){var C,D;if(B==null){B=null}if(E==null){E=false}B=(B!=null?B:window.location.href).replace((D=(C=Mercury.config).editorUrlRegEx)!=null?D:C.editorUrlRegEx=/([http|https]:\/\/.[^\/]*)\/editor\/?(.*)/i,"$1/$2");B=B.replace(/[\?|\&]mercury_frame=true/gi,"");B=B.replace(/\&_=i\d+/gi,"");if(E){return""+B+(B.indexOf("?")>-1?"&":"?")+"mercury_frame=true&_="+(new Date().getTime())}else{return B}};A.prototype.loadIframeSrc=function(B){if(this.document){this.document.off()}this.iframe.data("loaded",false);return this.iframe.get(0).contentWindow.document.location.href=this.iframeSrc(B,true)};A.prototype.hijackLinksAndForms=function(){var E,J,C,H,G,K,B,I,D,F;I=jQuery("a, form",this.document);F=[];for(H=0,K=I.length;H<K;H++){J=I[H];C=false;D=Mercury.config.nonHijackableClasses||[];for(G=0,B=D.length;G<B;G++){E=D[G];if(jQuery(J).hasClass(E)){C=true;continue}}if(!C&&(J.target===""||J.target==="_self")&&!jQuery(J).closest("["+Mercury.config.regions.attribute+"]").length){F.push(jQuery(J).attr("target","_parent"))}else{F.push(void 0)}}return F};A.prototype.beforeUnload=function(){};A.prototype.getRegionByName=function(F){var E,D,B,C;C=this.regions;for(D=0,B=C.length;D<B;D++){E=C[D];if(E.name===F){return E}}return null};A.prototype.save=function(H){var D,G,B,C,F,E=this;B=(C=(F=this.saveUrl)!=null?F:Mercury.saveUrl)!=null?C:this.iframeSrc();D=this.serialize();Mercury.log("saving",D);if(this.options.saveStyle!=="form"){D=jQuery.toJSON(D)}if(this.options.saveMethod==="PUT"){G="PUT"}return jQuery.ajax(B,{headers:Mercury.ajaxHeaders(),type:G||"POST",dataType:this.options.saveDataType,data:{content:D,_method:G},success:function(){Mercury.changes=false;Mercury.trigger("saved");if(typeof H==="function"){return H()}},error:function(I){Mercury.trigger("save_failed",I);return Mercury.notify("Mercury was unable to save to the url: %s",B)}})};A.prototype.serialize=function(){var F,E,D,B,C;E={};C=this.regions;for(D=0,B=C.length;D<B;D++){F=C[D];E[F.name]=F.serialize()}return E};return A})()}).call(this);(function(){this.Mercury.HistoryBuffer=(function(){function A(B){this.maxLength=B!=null?B:200;this.index=0;this.stack=[];this.markerRegExp=/<em class="mercury-marker"><\/em>/g}A.prototype.push=function(B){if(jQuery.type(B)==="string"){if(this.stack[this.index]&&this.stack[this.index].replace(this.markerRegExp,"")===B.replace(this.markerRegExp,"")){return }}else{if(jQuery.type(B)==="object"&&B.html){if(this.stack[this.index]&&this.stack[this.index].html===B.html){return }}}this.stack=this.stack.slice(0,(this.index+1));this.stack.push(B);if(this.stack.length>this.maxLength){this.stack.shift()}return this.index=this.stack.length-1};A.prototype.undo=function(){if(this.index<1){return null}this.index-=1;return this.stack[this.index]};A.prototype.redo=function(){if(this.index>=this.stack.length-1){return null}this.index+=1;return this.stack[this.index]};return A})()}).call(this);(function(){this.Mercury.tableEditor=function(C,A,B){Mercury.tableEditor.load(C,A,B);return Mercury.tableEditor};jQuery.extend(Mercury.tableEditor,{load:function(C,A,B){this.table=C;this.cell=A;this.cellContent=B!=null?B:"";this.row=this.cell.parent("tr");this.columnCount=this.getColumnCount();return this.rowCount=this.getRowCount()},addColumn:function(F){var E,I,G,A,D,L,H,K,J,C,B;if(F==null){F="after"}K=this.cellSignatureFor(this.cell);C=this.table.find("tr");B=[];for(E=0,J=C.length;E<J;E++){L=C[E];H=1;G=F==="after"?{right:K.right}:{left:K.left};if(A=this.findCellByOptionsFor(L,G)){D=jQuery("<"+(A.cell.get(0).tagName)+">").html(this.cellContent);this.setRowspanFor(D,A.height);if(F==="before"){A.cell.before(D)}else{A.cell.after(D)}B.push(E+=A.height-1)}else{if(I=this.findCellByIntersectionFor(L,K)){B.push(this.setColspanFor(I.cell,I.width+1))}else{B.push(void 0)}}}return B},removeColumn:function(){var D,M,J,K,C,G,N,O,H,F,L,B,A,I,E;O=this.cellSignatureFor(this.cell);if(O.width>1){return }G=[];D=[];I=this.table.find("tr");for(J=0,L=I.length;J<L;J++){N=I[J];if(C=this.findCellByOptionsFor(N,{left:O.left,width:O.width})){G.push(C.cell);J+=C.height-1}else{if(K=this.findCellByIntersectionFor(N,O)){D.push(K.cell)}}}for(H=0,B=G.length;H<B;H++){M=G[H];jQuery(M).remove()}E=[];for(F=0,A=D.length;F<A;F++){M=D[F];E.push(this.setColspanFor(M,this.colspanFor(M)-1))}return E},addRow:function(R){var B,I,G,L,H,M,K,P,E,C,A,N,Q,O,J,F,D;if(R==null){R="after"}H=jQuery("<tr>");if((P=this.rowspanFor(this.cell))>1&&R==="after"){this.row=jQuery(this.row.nextAll("tr")[P-2])}I=0;J=this.row.find("th, td");for(E=0,N=J.length;E<N;E++){B=J[E];G=this.colspanFor(B);L=jQuery("<"+B.tagName+">").html(this.cellContent);this.setColspanFor(L,G);I+=G;if((P=this.rowspanFor(B))>1&&R==="after"){this.setRowspanFor(B,P+1);continue}H.append(L)}if(I<this.columnCount){K=0;F=this.row.prevAll("tr");for(C=0,Q=F.length;C<Q;C++){M=F[C];K+=1;D=jQuery(M).find("td[rowspan], th[rowspan]");for(A=0,O=D.length;A<O;A++){B=D[A];P=this.rowspanFor(B);if(P-1>=K&&R==="before"){this.setRowspanFor(B,P+1)}else{if(P-1>=K&&R==="after"){if(P-1===K){L=jQuery("<"+B.tagName+">").html(this.cellContent);this.setColspanFor(L,this.colspanFor(B));H.append(L)}else{this.setRowspanFor(B,P+1)}}}}}}if(R==="before"){return this.row.before(H)}else{return this.row.after(H)}},removeRow:function(){var M,F,Q,N,P,J,R,V,A,L,I,G,D,B,T,W,U,S,O,K,H,E,C;A=true;J=0;P=0;O=this.row.find("td, th");for(I=0,T=O.length;I<T;I++){F=O[I];V=this.rowspanFor(F);if(J&&V!==J){A=false}if(V<P||!P){P=V}J=V}if(!A&&this.rowspanFor(this.cell)>P){return }if(P>1){for(Q=0,K=P-2;0<=K?Q<=K:Q>=K;0<=K?Q++:Q--){jQuery(this.row.nextAll("tr")[Q]).remove()}}H=this.row.find("td[rowspan], th[rowspan]");for(G=0,W=H.length;G<W;G++){F=H[G];L=this.cellSignatureFor(F);if(L.height===P){continue}if(N=this.findCellByOptionsFor(this.row.nextAll("tr")[P-1],{left:L.left,forceAdjacent:true})){this.setRowspanFor(F,this.rowspanFor(F)-this.rowspanFor(this.cell));if(N.direction==="before"){N.cell.before(jQuery(F).clone())}else{N.cell.after(jQuery(F).clone())}}}if(this.columnsFor(this.row.find("td, th"))<this.columnCount){R=0;E=this.row.prevAll("tr");for(D=0,U=E.length;D<U;D++){M=E[D];R+=1;C=jQuery(M).find("td[rowspan], th[rowspan]");for(B=0,S=C.length;B<S;B++){F=C[B];V=this.rowspanFor(F);if(V>R){this.setRowspanFor(F,V-this.rowspanFor(this.cell))}}}}return this.row.remove()},increaseColspan:function(){var A;A=this.cell.next("td, th");if(!A.length){return }if(this.rowspanFor(A)!==this.rowspanFor(this.cell)){return }if(this.cellIndexFor(A)>this.cellIndexFor(this.cell)+this.colspanFor(this.cell)){return }this.setColspanFor(this.cell,this.colspanFor(this.cell)+this.colspanFor(A));return A.remove()},decreaseColspan:function(){var A;if(this.colspanFor(this.cell)===1){return }this.setColspanFor(this.cell,this.colspanFor(this.cell)-1);A=jQuery("<"+(this.cell.get(0).tagName)+">").html(this.cellContent);this.setRowspanFor(A,this.rowspanFor(this.cell));return this.cell.after(A)},increaseRowspan:function(){var A,B,C;C=this.cellSignatureFor(this.cell);B=this.row.nextAll("tr")[C.height-1];if(B&&(A=this.findCellByOptionsFor(B,{left:C.left,width:C.width}))){this.setRowspanFor(this.cell,C.height+A.height);return A.cell.remove()}},decreaseRowspan:function(){var A,D,B,C;C=this.cellSignatureFor(this.cell);if(C.height===1){return }B=this.row.nextAll("tr")[C.height-2];if(A=this.findCellByOptionsFor(B,{left:C.left,forceAdjacent:true})){D=jQuery("<"+(this.cell.get(0).tagName)+">").html(this.cellContent);this.setColspanFor(D,this.colspanFor(this.cell));this.setRowspanFor(this.cell,C.height-1);if(A.direction==="before"){return A.cell.before(D)}else{return A.cell.after(D)}}},getColumnCount:function(){return this.columnsFor(this.table.find("thead tr:first-child, tbody tr:first-child, tfoot tr:first-child").first().find("td, th"))},getRowCount:function(){return this.table.find("tr").length},cellIndexFor:function(L){var C,B,E,I,M,J,G,F,K,A,H,D;L=jQuery(L);M=L.parent("tr");E=this.columnsFor(M.find("td, th"));I=this.columnsFor(L.prevAll("td, th"));if(E<this.columnCount){J=0;H=M.prevAll("tr");for(G=0,K=H.length;G<K;G++){B=H[G];J+=1;D=jQuery(B).find("td[rowspan], th[rowspan]");for(F=0,A=D.length;F<A;F++){C=D[F];if(this.rowspanFor(C)>J&&this.cellIndexFor(C)<=I){I+=this.colspanFor(C)}}}}return I},cellSignatureFor:function(A){var B;B={cell:jQuery(A)};B.left=this.cellIndexFor(A);B.width=this.colspanFor(A);B.height=this.rowspanFor(A);B.right=B.left+B.width;return B},findCellByOptionsFor:function(H,C){var A,D,G,F,B,E;E=jQuery(H).find("td, th");for(F=0,B=E.length;F<B;F++){A=E[F];G=this.cellSignatureFor(A);if(typeof C.right!=="undefined"){if(G.right===C.right){return G}}if(typeof C.left!=="undefined"){if(C.width){if(G.left===C.left&&G.width===C.width){return G}}else{if(!C.forceAdjacent){if(G.left===C.left){return G}}else{if(C.forceAdjacent){if(G.left>C.left){D=jQuery(A).prev("td, th");if(D.length){G=this.cellSignatureFor(D);G.direction="after"}else{G.direction="before"}return G}}}}}}if(C.forceAdjacent){G.direction="after";return G}return null},findCellByIntersectionFor:function(G,C){var A,F,E,B,D;D=jQuery(G).find("td, th");for(E=0,B=D.length;E<B;E++){A=D[E];F=this.cellSignatureFor(A);if(F.right-C.left>=0&&F.right>C.left){return F}}return null},columnsFor:function(C){var A,D,E,B;D=0;for(E=0,B=C.length;E<B;E++){A=C[E];D+=this.colspanFor(A)}return D},colspanFor:function(A){return parseInt(jQuery(A).attr("colspan"))||1},rowspanFor:function(A){return parseInt(jQuery(A).attr("rowspan"))||1},setColspanFor:function(A,B){return jQuery(A).attr("colspan",B>1?B:null)},setRowspanFor:function(A,B){return jQuery(A).attr("rowspan",B>1?B:null)}})}).call(this);(function(){this.Mercury.Dialog=(function(){function A(D,C,B){this.url=D;this.name=C;this.options=B!=null?B:{};this.button=this.options["for"];this.build();this.bindEvents();this.preload()}A.prototype.build=function(){var B;this.element=jQuery("<div>",{"class":"mercury-dialog mercury-"+this.name+"-dialog loading",style:"display:none"});return this.element.appendTo((B=jQuery(this.options.appendTo).get(0))!=null?B:"body")};A.prototype.bindEvents=function(){return this.element.on("mousedown",function(B){return B.stopPropagation()})};A.prototype.preload=function(){if(this.options.preload){return this.load()}};A.prototype.toggle=function(){if(this.visible){return this.hide()}else{return this.show()}};A.prototype.resize=function(){return this.show()};A.prototype.show=function(){Mercury.trigger("hide:dialogs",this);this.visible=true;if(this.loaded){this.element.css({width:"auto",height:"auto"});this.position(this.visible)}else{this.position()}return this.appear()};A.prototype.position=function(B){};A.prototype.appear=function(){var B=this;this.element.css({display:"block",opacity:0});return this.element.animate({opacity:0.95},200,"easeInOutSine",function(){if(!B.loaded){return B.load(function(){return B.resize()})}})};A.prototype.hide=function(){this.element.hide();return this.visible=false};A.prototype.load=function(C){var B=this;if(!this.url){return }if(Mercury.preloadedViews[this.url]){this.loadContent(Mercury.preloadedViews[this.url]);if(Mercury.dialogHandlers[this.name]){Mercury.dialogHandlers[this.name].call(this)}if(C){return C()}}else{return jQuery.ajax(this.url,{success:function(D){B.loadContent(D);if(Mercury.dialogHandlers[B.name]){Mercury.dialogHandlers[B.name].call(B)}if(C){return C()}},error:function(){B.hide();if(B.button){B.button.removeClass("pressed")}return Mercury.notify('Mercury was unable to load %s for the "%s" dialog.',B.url,B.name)}})}};A.prototype.loadContent=function(B){this.loaded=true;this.element.removeClass("loading");this.element.html(B);if(Mercury.config.localization.enabled){return this.element.localize(Mercury.locale())}};return A})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Palette=(function(C){B(D,C);function D(G,F,E){this.url=G;this.name=F;this.options=E!=null?E:{};D.__super__.constructor.apply(this,arguments)}D.prototype.build=function(){var E;this.element=jQuery("<div>",{"class":"mercury-palette mercury-"+this.name+"-palette loading",style:"display:none"});return this.element.appendTo((E=jQuery(this.options.appendTo).get(0))!=null?E:"body")};D.prototype.bindEvents=function(){var E=this;Mercury.on("hide:dialogs",function(G,F){if(F!==E){return E.hide()}});return D.__super__.bindEvents.apply(this,arguments)};D.prototype.position=function(F){var E,G;this.element.css({top:0,left:0,display:"block",visibility:"hidden"});E=this.button.offset();G=this.element.width();if(E.left+G>jQuery(window).width()){E.left=E.left-G+this.button.width()}return this.element.css({top:E.top+this.button.height(),left:E.left,display:F?"block":"none",visibility:"visible"})};return D})(Mercury.Dialog)}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Select=(function(C){B(D,C);function D(G,F,E){this.url=G;this.name=F;this.options=E!=null?E:{};D.__super__.constructor.apply(this,arguments)}D.prototype.build=function(){var E;this.element=jQuery("<div>",{"class":"mercury-select mercury-"+this.name+"-select loading",style:"display:none"});return this.element.appendTo((E=jQuery(this.options.appendTo).get(0))!=null?E:"body")};D.prototype.bindEvents=function(){var E=this;Mercury.on("hide:dialogs",function(G,F){if(F!==E){return E.hide()}});this.element.on("mousedown",function(F){return F.preventDefault()});return D.__super__.bindEvents.apply(this,arguments)};D.prototype.position=function(G){var L,H,I,F,K,E,J;this.element.css({top:0,left:0,display:"block",visibility:"hidden"});E=this.button.offset();I=this.element.width();H=this.element.height();L=jQuery(document).height();J=E.top+(this.button.height()/2)-(H/2);if(J<E.top-100){J=E.top-100}if(J<20){J=20}F=this.loaded?"auto":H;if(J+H>=L-20){F=L-J-20}K=E.left;if(K+I>jQuery(window).width()){K=K-I+this.button.width()}return this.element.css({top:J,left:K,height:F,display:G?"block":"none",visibility:"visible"})};return D})(Mercury.Dialog)}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Panel=(function(C){B(D,C);function D(G,F,E){this.url=G;this.name=F;this.options=E!=null?E:{};D.__super__.constructor.apply(this,arguments)}D.prototype.build=function(){var E;this.element=jQuery("<div>",{"class":"mercury-panel loading",style:"display:none;"});this.titleElement=jQuery("<h1><span>"+(Mercury.I18n(this.options.title))+"</span></h1>").appendTo(this.element);this.paneElement=jQuery("<div>",{"class":"mercury-panel-pane"}).appendTo(this.element);if(this.options.closeButton){jQuery("<a/>",{"class":"mercury-panel-close"}).appendTo(this.titleElement).css({opacity:0})}return this.element.appendTo((E=jQuery(this.options.appendTo).get(0))!=null?E:"body")};D.prototype.bindEvents=function(){var E=this;Mercury.on("resize",function(){return E.position(E.visible)});Mercury.on("hide:panels",function(G,F){if(F===E){return }E.button.removeClass("pressed");return E.hide()});this.titleElement.find(".mercury-panel-close").on("click",function(F){F.preventDefault();return Mercury.trigger("hide:panels")});this.element.on("mousedown",function(F){return F.stopPropagation()});this.element.on("ajax:beforeSend",function(G,H,F){return F.success=function(I){E.loadContent(I);return E.resize()}});return D.__super__.bindEvents.apply(this,arguments)};D.prototype.show=function(){Mercury.trigger("hide:panels",this);return D.__super__.show.apply(this,arguments)};D.prototype.resize=function(){var E,F,G,H=this;this.titleElement.find(".mercury-panel-close").css({opacity:0});this.paneElement.css({display:"none"});G=this.element.width();this.paneElement.css({visibility:"hidden",width:"auto",display:"block"});F=this.element.width();this.paneElement.css({visibility:"visible",display:"none"});E=this.element.offset();this.element.animate({left:E.left-(F-G),width:F},200,"easeInOutSine",function(){H.titleElement.find(".mercury-panel-close").animate({opacity:1},100);H.paneElement.css({display:"block",width:F});return H.makeDraggable()});if(!this.visible){return this.hide()}};D.prototype.position=function(G){var H,E,I,J,F;this.element.css({display:"block",visibility:"hidden"});J=this.element.offset();H=this.element.width();E=Mercury.displayRect.height-16;F=E-this.titleElement.outerHeight();this.paneElement.css({height:F,overflowY:F<30?"hidden":"auto"});if(!this.moved){I=Mercury.displayRect.width-H-20}if(I<=8){I=8}if(this.pinned||H+J.left>Mercury.displayRect.width-20){I=Mercury.displayRect.width-H-20}this.element.css({top:Mercury.displayRect.top+8,left:I,height:E,display:G?"block":"none",visibility:"visible"});this.makeDraggable();if(!G){return this.element.hide()}};D.prototype.loadContent=function(E){this.loaded=true;this.element.removeClass("loading");this.paneElement.css({visibility:"hidden"});this.paneElement.html(E);if(Mercury.config.localization.enabled){return this.paneElement.localize(Mercury.locale())}};D.prototype.makeDraggable=function(){var E,F=this;E=this.element.width();return this.element.draggable({handle:"h1 span",axis:"x",opacity:0.7,scroll:false,addClasses:false,iframeFix:true,containment:[8,0,Mercury.displayRect.width-E-20,0],stop:function(){var G;G=F.element.offset().left;F.moved=true;F.pinned=G>Mercury.displayRect.width-E-30?true:false;return true}})};return D})(Mercury.Dialog)}).call(this);(function(){this.Mercury.modal=function(B,A){if(A==null){A={}}Mercury.modal.show(B,A);return Mercury.modal};jQuery.extend(Mercury.modal,{minWidth:400,show:function(B,A){var C=this;this.url=B;this.options=A!=null?A:{};Mercury.trigger("focus:window");this.initialize();if(this.visible){this.update()}else{this.appear()}if(this.options.content){return setTimeout(500,function(){return C.loadContent(C.options.content)})}},initialize:function(){if(this.initialized){return }this.build();this.bindEvents();return this.initialized=true},build:function(){var A,B;this.element=jQuery("<div>",{"class":"mercury-modal loading"});this.element.html('<h1 class="mercury-modal-title"><span></span><a>&times;</a></h1>');this.element.append('<div class="mercury-modal-content-container"><div class="mercury-modal-content"></div></div>');this.overlay=jQuery("<div>",{"class":"mercury-modal-overlay"});this.titleElement=this.element.find(".mercury-modal-title");this.contentContainerElement=this.element.find(".mercury-modal-content-container");this.contentElement=this.element.find(".mercury-modal-content");this.element.appendTo((A=jQuery(this.options.appendTo).get(0))!=null?A:"body");return this.overlay.appendTo((B=jQuery(this.options.appendTo).get(0))!=null?B:"body")},bindEvents:function(){var A=this;Mercury.on("refresh",function(){return A.resize(true)});Mercury.on("resize",function(){return A.position()});this.overlay.on("click",function(){if(A.options.allowHideUsingOverlay){return A.hide()}});this.titleElement.find("a").on("click",function(){return A.hide()});this.element.on("ajax:beforeSend",function(C,D,B){return B.success=function(E){return A.loadContent(E)}});return jQuery(document).on("keydown",function(B){if(B.keyCode===27&&A.visible){return A.hide()}})},appear:function(){var A=this;this.showing=true;this.position();this.overlay.show();return this.overlay.animate({opacity:1},200,"easeInOutSine",function(){A.element.css({top:-A.element.height()});A.setTitle();A.element.show();return A.element.animate({top:0},200,"easeInOutSine",function(){A.visible=true;A.showing=false;return A.load()})})},resize:function(C){var A,E,B,D,F=this;B=C?"visible":"hidden";E=this.titleElement.outerHeight();D=this.contentElement.outerWidth();if(this.contentPane){this.contentPane.css({height:"auto"})}this.contentElement.css({height:"auto",visibility:B,display:"block"});A=this.contentElement.outerHeight()+E;if(D<this.minWidth){D=this.minWidth}if(A>Mercury.displayRect.fullHeight-20||this.options.fullHeight){A=Mercury.displayRect.fullHeight-20}return this.element.stop().animate({left:(Mercury.displayRect.width-D)/2,width:D,height:A},200,"easeInOutSine",function(){var G;F.contentElement.css({visibility:"visible",display:"block"});if(F.contentPane.length){F.contentElement.css({height:A-E,overflow:"visible"});G=F.contentControl.length?F.contentControl.outerHeight():0;F.contentPane.css({height:A-E-G-40});return F.contentPane.find(".mercury-display-pane").css({width:D-40})}else{return F.contentElement.css({height:A-E,overflow:"auto"})}})},position:function(){var D,A,E,B,C;B=Mercury.displayRect.width;if(this.contentPane){this.contentPane.css({height:"auto"})}this.contentElement.css({height:"auto"});this.element.css({width:"auto",height:"auto",display:"block",visibility:"hidden"});C=this.element.width();A=this.element.height();if(C<this.minWidth){C=this.minWidth}if(A>Mercury.displayRect.fullHeight-20||this.options.fullHeight){A=Mercury.displayRect.fullHeight-20}E=this.titleElement.outerHeight();if(this.contentPane&&this.contentPane.length){this.contentElement.css({height:A-E,overflow:"visible"});D=this.contentControl.length?this.contentControl.outerHeight():0;this.contentPane.css({height:A-E-D-40});this.contentPane.find(".mercury-display-pane").css({width:C-40})}else{this.contentElement.css({height:A-E,overflow:"auto"})}return this.element.css({left:(B-C)/2,width:C,height:A,display:this.visible?"block":"none",visibility:"visible"})},update:function(){this.reset();this.resize();return this.load()},load:function(){var A=this;this.setTitle();if(!this.url){return }this.element.addClass("loading");if(Mercury.preloadedViews[this.url]){return setTimeout((function(){return A.loadContent(Mercury.preloadedViews[A.url])}),10)}else{return jQuery.ajax(this.url,{headers:Mercury.ajaxHeaders(),type:this.options.loadType||"GET",data:this.options.loadData,success:function(B){return A.loadContent(B)},error:function(){A.hide();return Mercury.notify("Mercury was unable to load %s for the modal.",A.url)}})}},loadContent:function(B,A){if(A==null){A=null}this.initialize();this.options=A||this.options;this.setTitle();this.loaded=true;this.element.removeClass("loading");this.contentElement.html(B);this.contentElement.css({display:"none",visibility:"hidden"});this.contentPane=this.element.find(".mercury-display-pane-container");this.contentControl=this.element.find(".mercury-display-controls");if(this.options.afterLoad){this.options.afterLoad.call(this)}if(this.options.handler){if(Mercury.modalHandlers[this.options.handler]){Mercury.modalHandlers[this.options.handler].call(this)}else{if(Mercury.lightviewHandlers[this.options.handler]){Mercury.lightviewHandlers[this.options.handler].call(this)}}}if(Mercury.config.localization.enabled){this.element.localize(Mercury.locale())}return this.resize()},setTitle:function(){var A;this.titleElement.find("span").html(Mercury.I18n(this.options.title));A=this.titleElement.find("a");if(this.options.closeButton===false){return A.hide()}else{return A.show()}},reset:function(){this.titleElement.find("span").html("");return this.contentElement.html("")},hide:function(){if(this.showing){return }this.options={};this.initialized=false;Mercury.trigger("focus:frame");this.element.hide();this.overlay.hide();this.reset();return this.visible=false}})}).call(this);(function(){this.Mercury.lightview=function(B,A){if(A==null){A={}}Mercury.lightview.show(B,A);return Mercury.lightview};jQuery.extend(Mercury.lightview,{minWidth:400,show:function(B,A){var C=this;this.url=B;this.options=A!=null?A:{};Mercury.trigger("focus:window");this.initialize();if(this.visible){this.update()}else{this.appear()}if(this.options.content){return setTimeout(500,function(){return C.loadContent(C.options.content)})}},initialize:function(){if(this.initialized){return }this.build();this.bindEvents();return this.initialized=true},build:function(){var A,B;this.element=jQuery("<div>",{"class":"mercury-lightview loading"});this.element.html('<h1 class="mercury-lightview-title"><span></span></h1>');this.element.append('<div class="mercury-lightview-content"></div>');this.overlay=jQuery("<div>",{"class":"mercury-lightview-overlay"});this.titleElement=this.element.find(".mercury-lightview-title");if(this.options.closeButton){this.titleElement.append('<a class="mercury-lightview-close"></a>')}this.contentElement=this.element.find(".mercury-lightview-content");this.element.appendTo((A=jQuery(this.options.appendTo).get(0))!=null?A:"body");return this.overlay.appendTo((B=jQuery(this.options.appendTo).get(0))!=null?B:"body")},bindEvents:function(){var A=this;Mercury.on("refresh",function(){return A.resize(true)});Mercury.on("resize",function(){if(A.visible){return A.position()}});this.overlay.on("click",function(){if(!A.options.closeButton){return A.hide()}});this.titleElement.find(".mercury-lightview-close").on("click",function(){return A.hide()});this.element.on("ajax:beforeSend",function(C,D,B){return B.success=function(E){return A.loadContent(E)}});return jQuery(document).on("keydown",function(B){if(B.keyCode===27&&A.visible){return A.hide()}})},appear:function(){var A=this;this.showing=true;this.position();this.overlay.show().css({opacity:0});return this.overlay.animate({opacity:1},200,"easeInOutSine",function(){A.setTitle();A.element.show().css({opacity:0});return A.element.stop().animate({opacity:1},200,"easeInOutSine",function(){A.visible=true;A.showing=false;return A.load()})})},resize:function(E){var A,G,D,C,B,F,H=this;B=E?"visible":"hidden";C=Mercury.displayRect.width;D=Mercury.displayRect.fullHeight;G=this.titleElement.outerHeight();F=this.contentElement.outerWidth();if(F>C-40||this.options.fullSize){F=C-40}if(this.contentPane){this.contentPane.css({height:"auto"})}this.contentElement.css({height:"auto",visibility:B,display:"block"});A=this.contentElement.outerHeight()+G;if(A>D-20||this.options.fullSize){A=D-20}if(F<300){F=300}if(A<150){A=150}return this.element.stop().animate({top:((D-A)/2)+10,left:(Mercury.displayRect.width-F)/2,width:F,height:A},200,"easeInOutSine",function(){var I;H.contentElement.css({visibility:"visible",display:"block"});if(H.contentPane.length){H.contentElement.css({height:A-G,overflow:"visible"});I=H.contentControl.length?H.contentControl.outerHeight():0;H.contentPane.css({height:A-G-I-40});return H.contentPane.find(".mercury-display-pane").css({width:F-40})}else{return H.contentElement.css({height:A-G-30,overflow:"auto"})}})},position:function(){var E,A,F,C,B,D;B=Mercury.displayRect.width;C=Mercury.displayRect.fullHeight;if(this.contentPane){this.contentPane.css({height:"auto"})}this.contentElement.css({height:"auto"});this.element.css({width:"auto",height:"auto",display:"block",visibility:"hidden"});D=this.contentElement.width()+40;A=this.contentElement.height()+this.titleElement.outerHeight()+30;if(D>B-40||this.options.fullSize){D=B-40}if(A>C-20||this.options.fullSize){A=C-20}if(D<300){D=300}if(A<150){A=150}F=this.titleElement.outerHeight();if(this.contentPane&&this.contentPane.length){this.contentElement.css({height:A-F,overflow:"visible"});E=this.contentControl.length?this.contentControl.outerHeight():0;this.contentPane.css({height:A-F-E-40});this.contentPane.find(".mercury-display-pane").css({width:D-40})}else{this.contentElement.css({height:A-F-30,overflow:"auto"})}return this.element.css({top:((C-A)/2)+10,left:(B-D)/2,width:D,height:A,display:this.visible?"block":"none",visibility:"visible"})},update:function(){this.reset();this.resize();return this.load()},load:function(){var A=this;this.setTitle();if(!this.url){return }this.element.addClass("loading");if(Mercury.preloadedViews[this.url]){return setTimeout((function(){return A.loadContent(Mercury.preloadedViews[A.url])}),10)}else{return jQuery.ajax(this.url,{headers:Mercury.ajaxHeaders(),type:this.options.loadType||"GET",data:this.options.loadData,success:function(B){return A.loadContent(B)},error:function(){A.hide();return Mercury.notify("Mercury was unable to load %s for the lightview.",A.url)}})}},loadContent:function(B,A){if(A==null){A=null}this.initialize();this.options=A||this.options;this.setTitle();this.loaded=true;this.element.removeClass("loading");this.contentElement.html(B);this.contentElement.css({display:"none",visibility:"hidden"});this.contentPane=this.element.find(".mercury-display-pane-container");this.contentControl=this.element.find(".mercury-display-controls");if(this.options.afterLoad){this.options.afterLoad.call(this)}if(this.options.handler){if(Mercury.modalHandlers[this.options.handler]){Mercury.modalHandlers[this.options.handler].call(this)}else{if(Mercury.lightviewHandlers[this.options.handler]){Mercury.lightviewHandlers[this.options.handler].call(this)}}}if(Mercury.config.localization.enabled){this.element.localize(Mercury.locale())}return this.resize()},setTitle:function(){return this.titleElement.find("span").html(Mercury.I18n(this.options.title))},reset:function(){this.titleElement.find("span").html("");return this.contentElement.html("")},hide:function(){if(this.showing){return }this.options={};this.initialized=false;Mercury.trigger("focus:frame");this.element.hide();this.overlay.hide();this.reset();return this.visible=false}})}).call(this);(function(){this.Mercury.Statusbar=(function(){function A(B){this.options=B!=null?B:{};this.visible=this.options.visible;this.build();this.bindEvents()}A.prototype.build=function(){var B;this.element=jQuery("<div>",{"class":"mercury-statusbar"});this.aboutElement=jQuery("<a>",{"class":"mercury-statusbar-about"}).appendTo(this.element).html("Mercury Editor v"+Mercury.version);this.pathElement=jQuery("<div>",{"class":"mercury-statusbar-path"}).appendTo(this.element);if(!this.visible){this.element.css({visibility:"hidden"})}return this.element.appendTo((B=jQuery(this.options.appendTo).get(0))!=null?B:"body")};A.prototype.bindEvents=function(){var B=this;Mercury.on("region:update",function(D,C){if(C.region&&jQuery.type(C.region.path)==="function"){return B.setPath(C.region.path())}});return this.aboutElement.on("click",function(){return Mercury.lightview("/mercury/lightviews/about.html",{title:"Mercury Editor v"+Mercury.version})})};A.prototype.height=function(){return this.element.outerHeight()};A.prototype.top=function(){var B,C;C=this.element.offset().top;B=parseInt(this.element.css("bottom"))<0?C-this.element.outerHeight():C;if(this.visible){return B}else{return C+this.element.outerHeight()}};A.prototype.setPath=function(E){var C,F,D,B;F=[];for(D=0,B=E.length;D<B;D++){C=E[D];F.push("<a>"+(C.tagName.toLowerCase())+"</a>")}return this.pathElement.html("<span><strong>"+(Mercury.I18n("Path:"))+" </strong>"+(F.reverse().join(" &raquo; "))+"</span>")};A.prototype.show=function(){this.visible=true;this.element.css({opacity:0,visibility:"visible"});return this.element.animate({opacity:1},200,"easeInOutSine")};A.prototype.hide=function(){this.visible=false;return this.element.css({visibility:"hidden"})};return A})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty;this.Mercury.Toolbar=(function(){function B(C){this.options=C!=null?C:{};this.visible=this.options.visible;this.build();this.bindEvents()}B.prototype.build=function(){var G,L,H,C,J,K,I,D,F,E;this.element=jQuery("<div>",{"class":"mercury-toolbar-container",style:"width:10000px"});if(!this.visible){this.element.css({display:"none"})}this.element.appendTo((F=jQuery(this.options.appendTo).get(0))!=null?F:"body");E=Mercury.config.toolbars;for(D in E){if(!A.call(E,D)){continue}H=E[D];if(H._custom){continue}I=jQuery("<div>",{"class":"mercury-toolbar mercury-"+D+"-toolbar"}).appendTo(this.element);if(H._regions){I.attr("data-regions",H._regions)}C=jQuery("<div>",{"class":"mercury-toolbar-button-container"}).appendTo(I);for(L in H){if(!A.call(H,L)){continue}K=H[L];if(L==="_regions"){continue}G=this.buildButton(L,K);if(G){G.appendTo(C)}}if(C.css("white-space")==="nowrap"){J=new Mercury.Toolbar.Expander(D,{appendTo:I,"for":C});J.appendTo(this.element)}if(Mercury.config.toolbars.primary&&D!=="primary"){I.addClass("disabled")}}return this.element.css({width:"100%"})};B.prototype.buildButton=function(D,K){var E,F,J,G,C,H,I;if(D[0]==="_"){return false}switch(jQuery.type(K)){case"array":I=K[0],H=K[1],G=K[2];return new Mercury.Toolbar.Button(D,I,H,G,{appendDialogsTo:this.element});case"object":J=new Mercury.Toolbar.ButtonGroup(D,K);for(E in K){if(!A.call(K,E)){continue}C=K[E];F=this.buildButton(E,C);if(F){F.appendTo(J)}}return J;case"string":return jQuery("<hr>",{"class":"mercury-"+(K==="-"?"line-separator":"separator")});default:throw Mercury.I18n('Unknown button structure -- please provide an array, object, or string for "%s".',D)}};B.prototype.bindEvents=function(){var C=this;Mercury.on("region:focused",function(H,F){var K,G,J,E,I,D;I=C.element.find(".mercury-toolbar");D=[];for(J=0,E=I.length;J<E;J++){G=I[J];G=jQuery(G);if(K=G.data("regions")){if(K.split(",").indexOf(F.region.type())>-1){D.push(G.removeClass("disabled"))}else{D.push(void 0)}}else{D.push(void 0)}}return D});Mercury.on("region:blurred",function(H,F){var K,G,J,E,I,D;I=C.element.find(".mercury-toolbar");D=[];for(J=0,E=I.length;J<E;J++){G=I[J];G=jQuery(G);if(K=G.data("regions")){if(K.split(",").indexOf(F.region.type())>-1){D.push(G.addClass("disabled"))}else{D.push(void 0)}}else{D.push(void 0)}}return D});this.element.on("click",function(){return Mercury.trigger("hide:dialogs")});return this.element.on("mousedown",function(D){return D.preventDefault()})};B.prototype.height=function(){if(this.visible){return this.element.outerHeight()}else{return 0}};B.prototype.show=function(){this.visible=true;this.element.css({top:-this.element.outerHeight(),display:"block"});return this.element.animate({top:0},200,"easeInOutSine")};B.prototype.hide=function(){this.visible=false;return this.element.hide()};return B})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty;this.Mercury.Toolbar.Button=(function(){function B(E,G,D,F,C){this.name=E;this.title=G;this.summary=D!=null?D:null;this.types=F!=null?F:{};this.options=C!=null?C:{};if(this.title){this.title=Mercury.I18n(this.title)}if(this.summary){this.summary=Mercury.I18n(this.summary)}this.build();this.bindEvents();return this.element}B.prototype.build=function(){var E,C,F,G,H,D;this.element=jQuery("<div>",{title:(G=this.summary)!=null?G:this.title,"class":"mercury-button mercury-"+this.name+"-button"}).html("<em>"+this.title+"</em>");this.element.data("expander",'<div class="mercury-expander-button" data-button="'+this.name+'"><em></em><span>'+this.title+"</span></div>");this.handled={};H=this.types;D=[];for(F in H){if(!A.call(H,F)){continue}E=H[F];switch(F){case"preload":D.push(true);break;case"regions":this.element.addClass("disabled");D.push(this.handled[F]=jQuery.isFunction(E)?E.call(this,this.name):E);break;case"toggle":D.push(this.handled[F]=true);break;case"mode":D.push(this.handled[F]=E===true?this.name:E);break;case"context":D.push(this.handled[F]=jQuery.isFunction(E)?E:Mercury.Toolbar.Button.contexts[this.name]);break;case"palette":this.element.addClass("mercury-button-palette");C=jQuery.isFunction(E)?E.call(this,this.name):E;D.push(this.handled[F]=typeof C==="string"?new Mercury.Palette(C,this.name,this.defaultDialogOptions()):C);break;case"select":this.element.addClass("mercury-button-select").find("em").html(this.title);C=jQuery.isFunction(E)?E.call(this,this.name):E;D.push(this.handled[F]=typeof C==="string"?new Mercury.Select(C,this.name,this.defaultDialogOptions()):C);break;case"panel":this.element.addClass("mercury-button-panel");this.handled.toggle=true;C=jQuery.isFunction(E)?E.call(this,this.name):E;D.push(this.handled[F]=typeof C==="string"?new Mercury.Panel(C,this.name,this.defaultDialogOptions()):C);break;case"modal":D.push(this.handled[F]=jQuery.isFunction(E)?E.call(this,this.name):E);break;case"lightview":D.push(this.handled[F]=jQuery.isFunction(E)?E.call(this,this.name):E);break;default:throw Mercury.I18n('Unknown button type "%s" used for the "%s" button.',F,this.name)}}return D};B.prototype.bindEvents=function(){var C=this;Mercury.on("button",function(E,D){if(D.action===C.name){return C.element.click()}});Mercury.on("mode",function(E,D){if(C.handled.mode===D.mode&&C.handled.toggle){return C.togglePressed()}});Mercury.on("region:update",function(F,D){var E;if(C.handled.context&&D.region&&jQuery.type(D.region.currentElement)==="function"){E=D.region.currentElement();if(E.length&&C.handled.context.call(C,E,D.region.element)){return C.element.addClass("active")}else{return C.element.removeClass("active")}}else{return C.element.removeClass("active")}});Mercury.on("region:focused",function(E,D){if(C.handled.regions&&D.region&&D.region.type()){if(C.handled.regions.indexOf(D.region.type())>-1){return C.element.removeClass("disabled")}else{return C.element.addClass("disabled")}}});Mercury.on("region:blurred",function(){if(C.handled.regions){return C.element.addClass("disabled")}});this.element.on("mousedown",function(){return C.element.addClass("active")});this.element.on("mouseup",function(){return C.element.removeClass("active")});return this.element.on("click",function(F){var H,D,E,G;if(C.element.closest(".disabled").length){return }H=false;G=C.handled;for(E in G){if(!A.call(G,E)){continue}D=G[E];switch(E){case"toggle":if(!C.handled.mode){C.togglePressed()}break;case"mode":H=true;Mercury.trigger("mode",{mode:D});break;case"modal":H=true;Mercury.modal(C.handled.modal,{title:C.summary||C.title,handler:C.name});break;case"lightview":H=true;Mercury.lightview(C.handled.lightview,{title:C.summary||C.title,handler:C.name,closeButton:true});break;case"palette":case"select":case"panel":F.stopPropagation();H=true;C.handled[E].toggle()}}if(!H){Mercury.trigger("action",{action:C.name})}if(C.options.regions&&C.options.regions.length){return Mercury.trigger("focus:frame")}})};B.prototype.defaultDialogOptions=function(){return{title:this.summary||this.title,preload:this.types.preload,appendTo:this.options.appendDialogsTo||"body",closeButton:true,"for":this.element}};B.prototype.togglePressed=function(){return this.element.toggleClass("pressed")};return B})();this.Mercury.Toolbar.Button.contexts={backColor:function(B){return this.element.css("background-color",B.css("background-color"))},foreColor:function(B){return this.element.css("background-color",B.css("color"))},bold:function(B){var C;C=B.css("font-weight");return C==="bold"||C>400},italic:function(B){return B.css("font-style")==="italic"},overline:function(D){var C,F,B,E;if(D.css("text-decoration")==="overline"){return true}E=D.parentsUntil(this.element);for(F=0,B=E.length;F<B;F++){C=E[F];if(jQuery(C).css("text-decoration")==="overline"){return true}}return false},strikethrough:function(B,C){return B.css("text-decoration")==="line-through"||!!B.closest("strike",C).length},underline:function(B,C){return B.css("text-decoration")==="underline"||!!B.closest("u",C).length},subscript:function(B,C){return !!B.closest("sub",C).length},superscript:function(B,C){return !!B.closest("sup",C).length},justifyLeft:function(B){return B.css("text-align").indexOf("left")>-1},justifyCenter:function(B){return B.css("text-align").indexOf("center")>-1},justifyRight:function(B){return B.css("text-align").indexOf("right")>-1},justifyFull:function(B){return B.css("text-align").indexOf("justify")>-1},insertOrderedList:function(B,C){return !!B.closest("ol",C.element).length},insertUnorderedList:function(B,C){return !!B.closest("ul",C.element).length}}}).call(this);(function(){this.Mercury.Toolbar.ButtonGroup=(function(){function A(C,B){this.name=C;this.options=B!=null?B:{};this.build();this.bindEvents();this.regions=this.options._regions;return this.element}A.prototype.build=function(){this.element=jQuery("<div>",{"class":"mercury-button-group mercury-"+this.name+"-group"});if(this.options._context||this.options._regions){return this.element.addClass("disabled")}};A.prototype.bindEvents=function(){var B=this;Mercury.on("region:update",function(F,C){var E,D;E=Mercury.Toolbar.ButtonGroup.contexts[B.name];if(E){if(C.region&&jQuery.type(C.region.currentElement)==="function"){D=C.region.currentElement();if(D.length&&E.call(B,D,C.region.element)){return B.element.removeClass("disabled")}else{return B.element.addClass("disabled")}}}});Mercury.on("region:focused",function(D,C){if(B.regions&&C.region&&C.region.type()){if(B.regions.indexOf(C.region.type())>-1){if(!B.options._context){return B.element.removeClass("disabled")}}else{return B.element.addClass("disabled")}}});return Mercury.on("region:blurred",function(D,C){if(B.options.regions){return B.element.addClass("disabled")}})};return A})();this.Mercury.Toolbar.ButtonGroup.contexts={table:function(A,B){return !!A.closest("table",B).length}}}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Toolbar.Expander=(function(D){B(C,D);function C(F,E){this.name=F;this.options=E;this.container=this.options["for"];this.containerWidth=this.container.outerWidth();C.__super__.constructor.call(this,null,this.name,this.options);return this.element}C.prototype.build=function(){var E;this.container.css({whiteSpace:"normal"});this.trigger=jQuery("<div>",{"class":"mercury-toolbar-expander"}).appendTo((E=jQuery(this.options.appendTo).get(0))!=null?E:"body");this.element=jQuery("<div>",{"class":"mercury-palette mercury-expander mercury-"+this.name+"-expander",style:"display:none"});return this.windowResize()};C.prototype.bindEvents=function(){var E=this;Mercury.on("hide:dialogs",function(G,F){if(F!==E){return E.hide()}});Mercury.on("resize",function(){return E.windowResize()});C.__super__.bindEvents.apply(this,arguments);this.trigger.click(function(H){var G,K,J,F,I;H.stopPropagation();K=[];I=E.container.find(".mercury-button");for(J=0,F=I.length;J<F;J++){G=I[J];G=jQuery(G);if(G.position().top>5){K.push(G.data("expander"))}}E.loadContent(K.join(""));return E.toggle()});return this.element.click(function(H){var G,F;F=jQuery(H.target).closest("[data-button]").data("button");G=E.container.find(".mercury-"+F+"-button");return G.click()})};C.prototype.windowResize=function(){if(this.containerWidth>jQuery(window).width()){this.trigger.show()}else{this.trigger.hide()}return this.hide()};C.prototype.position=function(F){var E,G;this.element.css({top:0,left:0,display:"block",visibility:"hidden"});E=this.trigger.offset();G=this.element.width();if(E.left+G>jQuery(window).width()){E.left=E.left-G+this.trigger.width()}return this.element.css({top:E.top+this.trigger.height(),left:E.left,display:F?"block":"none",visibility:"visible"})};return C})(Mercury.Palette)}).call(this);(function(){this.Mercury.tooltip=function(C,B,A){if(A==null){A={}}Mercury.tooltip.show(C,B,A);return Mercury.tooltip};jQuery.extend(Mercury.tooltip,{show:function(C,B,A){this.forElement=C;this.content=B;this.options=A!=null?A:{};this.document=this.forElement.get(0).ownerDocument;this.initialize();if(this.visible){return this.update()}else{return this.appear()}},initialize:function(){if(this.initialized){return }this.build();this.bindEvents();return this.initialized=true},build:function(){var A;this.element=jQuery("<div>",{"class":"mercury-tooltip"});return this.element.appendTo((A=jQuery(this.options.appendTo).get(0))!=null?A:"body")},bindEvents:function(){var B,D,A,C,E=this;Mercury.on("resize",function(){if(E.visible){return E.position()}});this.element.on("mousedown",function(F){F.preventDefault();return F.stopPropagation()});C=this.forElement.parentsUntil(jQuery("body",this.document));for(D=0,A=C.length;D<A;D++){B=C[D];if(!(B.scrollHeight>B.clientHeight)){continue}jQuery(B).on("scroll",function(){if(E.visible){return E.position()}})}return jQuery(this.document).on("scroll",function(){if(E.visible){return E.position()}})},appear:function(){var A=this;this.update();this.element.show();return this.element.animate({opacity:1},200,"easeInOutSine",function(){return A.visible=true})},update:function(){this.element.html(this.content);return this.position()},position:function(){var C,D,B,A;D=this.forElement.offset();A=this.element.width();B=D.top+(Mercury.displayRect.top-jQuery(this.document).scrollTop())+this.forElement.outerHeight();C=D.left-jQuery(this.document).scrollLeft();if((C+A+25)>Mercury.displayRect.width){C=C-(C+A+25)-Mercury.displayRect.width}C=C<=0?0:C;return this.element.css({top:B,left:C})},hide:function(){if(!this.initialized){return }this.element.hide();return this.visible=false}})}).call(this);(function(){var A=Object.prototype.hasOwnProperty;this.Mercury.Snippet=(function(){B.all=[];B.displayOptionsFor=function(D,C){if(C==null){C={}}Mercury.modal(Mercury.config.snippets.optionsUrl.replace(":name",D),jQuery.extend({title:"Snippet Options",handler:"insertSnippet",snippetName:D},C));return Mercury.snippet=null};B.create=function(G,F){var H,E,C,I,D,J;if(this.all.length>0){E="snippet_0";J=this.all;for(H=0,D=J.length;H<D;H++){I=J[H];if(I.identity===E){E="snippet_"+(H+1)}}}else{E="snippet_"+this.all.length}C=new Mercury.Snippet(G,E,F);this.all.push(C);return C};B.find=function(D){var E,G,C,F;F=this.all;for(G=0,C=F.length;G<C;G++){E=F[G];if(E.identity===D){return E}}return null};B.load=function(G){var F,E,C,D;D=[];for(E in G){if(!A.call(G,E)){continue}F=G[E];C=new Mercury.Snippet(F.name,E,F.options);D.push(this.all.push(C))}return D};B.clearAll=function(){delete this.all;return this.all=[]};function B(E,C,D){this.name=E;this.identity=C;if(D==null){D={}}this.version=0;this.data="";this.wrapperTag="div";this.history=new Mercury.HistoryBuffer();this.setOptions(D)}B.prototype.getHTML=function(D,E){var C;if(E==null){E=null}C=jQuery("<"+this.wrapperTag+">",{"class":""+this.name+"-snippet",contenteditable:"false","data-snippet":this.identity,"data-version":this.version},D);C.html("["+this.identity+"]");this.loadPreview(C,E);return C};B.prototype.getText=function(C){return"[--"+this.identity+"--]"};B.prototype.loadPreview=function(C,E){var D=this;if(E==null){E=null}return jQuery.ajax(Mercury.config.snippets.previewUrl.replace(":name",this.name),{headers:Mercury.ajaxHeaders(),type:Mercury.config.snippets.method,data:this.options,success:function(F){D.data=F;C.html(F);if(E){return E()}},error:function(){return Mercury.notify('Error loading the preview for the "%s" snippet.',D.name)}})};B.prototype.displayOptions=function(){Mercury.snippet=this;return Mercury.modal(Mercury.config.snippets.optionsUrl.replace(":name",this.name),{title:"Snippet Options",handler:"insertSnippet",loadType:Mercury.config.snippets.method,loadData:this.options})};B.prototype.setOptions=function(C){this.options=C;delete this.options.authenticity_token;delete this.options.utf8;if(this.options.wrapperTag){this.wrapperTag=this.options.wrapperTag}this.version+=1;return this.history.push(this.options)};B.prototype.setVersion=function(C){if(C==null){C=null}C=parseInt(C);if(C&&this.history.stack[C-1]){this.version=C-1;this.options=this.history.stack[this.version];return true}return false};B.prototype.serialize=function(){return{name:this.name,options:this.options}};return B})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.SnippetToolbar=(function(D){B(C,D);function C(E,F){this.document=E;this.options=F!=null?F:{};this._boundEvents=[];C.__super__.constructor.call(this,this.options)}C.prototype.build=function(){var H,E,G,I,J,F;this.element=jQuery("<div>",{"class":"mercury-toolbar mercury-snippet-toolbar",style:"display:none"});this.element.appendTo((I=jQuery(this.options.appendTo).get(0))!=null?I:"body");J=Mercury.config.toolbars.snippets;F=[];for(E in J){if(!A.call(J,E)){continue}G=J[E];H=this.buildButton(E,G);if(H){F.push(H.appendTo(this.element))}else{F.push(void 0)}}return F};C.prototype.bindEvents=function(){var E=this;this.bindReleasableEvent(Mercury,"show:toolbar",function(G,F){if(!F.snippet){return }F.snippet.mouseout(function(){return E.hide()});return E.show(F.snippet)});this.bindReleasableEvent(Mercury,"hide:toolbar",function(G,F){if(!(F.type&&F.type==="snippet")){return }return E.hide(F.immediately)});this.bindReleasableEvent(jQuery(this.document),"scroll",function(){if(E.visible){return E.position()}});this.element.mousemove(function(){return clearTimeout(E.hideTimeout)});return this.element.mouseout(function(){return E.hide()})};C.prototype.bindReleasableEvent=function(G,E,F){G.on(E,F);return this._boundEvents.push([G,E,F])};C.prototype.show=function(E){this.snippet=E;Mercury.tooltip.hide();this.position();return this.appear()};C.prototype.position=function(){var F,G,E;G=this.snippet.offset();E=G.top+Mercury.displayRect.top-jQuery(this.document).scrollTop()-this.height()+10;F=G.left-jQuery(this.document).scrollLeft();return this.element.css({top:E,left:F})};C.prototype.appear=function(){clearTimeout(this.hideTimeout);if(this.visible){return }this.visible=true;this.element.css({display:"block",opacity:0});return this.element.stop().animate({opacity:1},200,"easeInOutSine")};C.prototype.hide=function(E){var F=this;if(E==null){E=false}clearTimeout(this.hideTimeout);if(E){this.element.hide();return this.visible=false}else{return this.hideTimeout=setTimeout(function(){F.element.stop().animate({opacity:0},300,"easeInOutSine",function(){return F.element.hide()});return F.visible=false},500)}};C.prototype.release=function(){var F,G,J,I,E,H,K;this.element.off();this.element.remove();H=this._boundEvents;for(I=0,E=H.length;I<E;I++){K=H[I],J=K[0],F=K[1],G=K[2];J.off(F,G)}return this._boundEvents=[]};return C})(Mercury.Toolbar)}).call(this);(function(){this.Mercury.Region=(function(){function A(C,D,B){this.element=C;this.window=D;this.options=B!=null?B:{};Mercury.log("building "+(this.type()),this.element,this.options);this.document=this.window.document;this.name=this.element.attr(Mercury.config.regions.identifier);this.history=new Mercury.HistoryBuffer();this.build();this.bindEvents();this.pushHistory();this.element.data("region",this)}A.prototype.type=function(){return"unknown"};A.prototype.build=function(){};A.prototype.focus=function(){};A.prototype.bindEvents=function(){var B=this;Mercury.on("mode",function(D,C){if(C.mode==="preview"){return B.togglePreview()}});Mercury.on("focus:frame",function(){if(B.previewing||Mercury.region!==B){return }return B.focus()});Mercury.on("action",function(D,C){if(B.previewing||Mercury.region!==B){return }if(C.action){return B.execCommand(C.action,C)}});this.element.on("mousemove",function(D){var C;if(B.previewing||Mercury.region!==B){return }C=jQuery(D.target).closest("[data-snippet]");if(C.length){B.snippet=C;if(B.snippet.data("snippet")){return Mercury.trigger("show:toolbar",{type:"snippet",snippet:B.snippet})}}});return this.element.on("mouseout",function(){if(B.previewing){return }return Mercury.trigger("hide:toolbar",{type:"snippet",immediately:false})})};A.prototype.content=function(H,D){var C,E,G,B,F;if(H==null){H=null}if(D==null){D=false}if(H!==null){return this.element.html(H)}else{C=jQuery("<div>").appendTo(this.document.createDocumentFragment());C.html(this.element.html().replace(/^\s+|\s+$/g,""));if(D){F=C.find("[data-snippet]");for(G=0,B=F.length;G<B;G++){E=F[G];E=jQuery(E);E.attr({contenteditable:null,"data-version":null});E.html("["+(E.data("snippet"))+"]")}}return C.html()}};A.prototype.togglePreview=function(){if(this.previewing){this.previewing=false;this.element.attr(Mercury.config.regions.attribute,this.type());if(Mercury.region===this){return this.focus()}}else{this.previewing=true;this.element.removeAttr(Mercury.config.regions.attribute);return Mercury.trigger("region:blurred",{region:this})}};A.prototype.execCommand=function(C,B){if(B==null){B={}}this.focus();if(C!=="redo"){this.pushHistory()}Mercury.log("execCommand",C,B.value);if(!B.already_handled){return Mercury.changes=true}};A.prototype.pushHistory=function(){return this.history.push(this.content())};A.prototype.snippets=function(){var D,E,C,G,B,F;C={};F=this.element.find("[data-snippet]");for(G=0,B=F.length;G<B;G++){D=F[G];E=Mercury.Snippet.find(jQuery(D).data("snippet"));if(!E){continue}E.setVersion(jQuery(D).data("version"));C[E.identity]=E.serialize()}return C};A.prototype.dataAttributes=function(){var B,F,E,C,D;F={};D=Mercury.config.regions.dataAttributes;for(E=0,C=D.length;E<C;E++){B=D[E];F[B]=this.element.attr("data-"+B)}return F};A.prototype.serialize=function(){return{type:this.type(),data:this.dataAttributes(),value:this.content(null,true),snippets:this.snippets()}};return A})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty;this.Mercury.uploader=function(C,B){if(Mercury.config.uploading.enabled){Mercury.uploader.show(C,B)}return Mercury.uploader};jQuery.extend(Mercury.uploader,{show:function(C,B){this.options=B!=null?B:{};this.file=new Mercury.uploader.File(C);if(this.file.errors){alert("Error: "+this.file.errors);return }if(!this.supported()){return }Mercury.trigger("focus:window");this.initialize();return this.appear()},initialize:function(){if(this.initialized){return }this.build();this.bindEvents();return this.initialized=true},supported:function(){var B;B=new XMLHttpRequest;if(window.Uint8Array&&window.ArrayBuffer&&!XMLHttpRequest.prototype.sendAsBinary){XMLHttpRequest.prototype.sendAsBinary=function(G){var F,E,D,C;D=new Uint8Array(G.length);for(E=0,C=G.length;E<C;E++){F=G[E];D[E]=G.charCodeAt(E)&255}return this.send(D.buffer)}}return !!(B.upload&&B.sendAsBinary&&(Mercury.uploader.fileReaderSupported()||Mercury.uploader.formDataSupported()))},fileReaderSupported:function(){return !!window.FileReader},formDataSupported:function(){return !!window.FormData},build:function(){var B,C;this.element=jQuery("<div>",{"class":"mercury-uploader",style:"display:none"});this.element.append('<div class="mercury-uploader-preview"><b><img/></b></div>');this.element.append('<div class="mercury-uploader-details"></div>');this.element.append('<div class="mercury-uploader-progress"><span></span><div class="mercury-uploader-indicator"><div><b>0%</b></div></div></div>');this.updateStatus("Processing...");this.overlay=jQuery("<div>",{"class":"mercury-uploader-overlay",style:"display:none"});this.element.appendTo((B=jQuery(this.options.appendTo).get(0))!=null?B:"body");return this.overlay.appendTo((C=jQuery(this.options.appendTo).get(0))!=null?C:"body")},bindEvents:function(){var B=this;return Mercury.on("resize",function(){return B.position()})},appear:function(){var B=this;this.fillDisplay();this.position();this.overlay.show();return this.overlay.animate({opacity:1},200,"easeInOutSine",function(){B.element.show();return B.element.animate({opacity:1},200,"easeInOutSine",function(){B.visible=true;return B.loadImage()})})},position:function(){var B,C;C=this.element.outerWidth();B=this.element.outerHeight();return this.element.css({top:(Mercury.displayRect.height-B)/2,left:(Mercury.displayRect.width-C)/2})},fillDisplay:function(){var B;B=[Mercury.I18n("Name: %s",this.file.name),Mercury.I18n("Size: %s",this.file.readableSize),Mercury.I18n("Type: %s",this.file.type)];return this.element.find(".mercury-uploader-details").html(B.join("<br/>"))},loadImage:function(){var B=this;if(Mercury.uploader.fileReaderSupported()){return this.file.readAsDataURL(function(C){B.element.find(".mercury-uploader-preview b").html(jQuery("<img>",{src:C}));return B.upload()})}else{return this.upload()}},upload:function(){var B,C,D=this;C=new XMLHttpRequest;jQuery.each(["onloadstart","onprogress","onload","onabort","onerror"],function(F,E){return C.upload[E]=function(G){return D.uploaderEvents[E].call(D,G)}});C.onload=function(G){var E,H;if(G.currentTarget.status>=400){D.updateStatus("Error: Unable to upload the file");Mercury.notify("Unable to process response: %s",G.currentTarget.status);return D.hide()}else{try{E=Mercury.config.uploading.handler?Mercury.config.uploading.handler(G.target.responseText):jQuery.parseJSON(G.target.responseText);H=E.url||E.image.url;if(!H){throw"Malformed response from server."}Mercury.trigger("action",{action:"insertImage",value:{src:H}});return D.hide()}catch(F){D.updateStatus("Error: Unable to upload the file");Mercury.notify("Unable to process response: %s",F);return D.hide()}}};C.open("post",Mercury.config.uploading.url,true);C.setRequestHeader("Accept","application/json, text/javascript, text/html, application/xml, text/xml, */*");C.setRequestHeader("X-Requested-With","XMLHttpRequest");C.setRequestHeader(Mercury.config.csrfHeader,Mercury.csrfToken);if(Mercury.uploader.fileReaderSupported()){return this.file.readAsBinaryString(function(E){var F;F=new Mercury.uploader.MultiPartPost(Mercury.config.uploading.inputName,D.file,E);D.file.updateSize(F.delta);C.setRequestHeader("Content-Type","multipart/form-data; boundary="+F.boundary);return C.sendAsBinary(F.body)})}else{B=new FormData();B.append(Mercury.config.uploading.inputName,this.file.file,this.file.file.name);return C.send(B)}},updateStatus:function(D,B){var C;this.element.find(".mercury-uploader-progress span").html(Mercury.I18n(D).toString());if(B){C=Math.floor(B*100/this.file.size)+"%";this.element.find(".mercury-uploader-indicator div").css({width:C});return this.element.find(".mercury-uploader-indicator b").html(C).show()}},hide:function(B){var C=this;if(B==null){B=0}return setTimeout(function(){return C.element.animate({opacity:0},200,"easeInOutSine",function(){return C.overlay.animate({opacity:0},200,"easeInOutSine",function(){C.overlay.hide();C.element.hide();C.reset();C.visible=false;return Mercury.trigger("focus:frame")})})},B*1000)},reset:function(){this.element.find(".mercury-uploader-preview b").html("");this.element.find(".mercury-uploader-indicator div").css({width:0});this.element.find(".mercury-uploader-indicator b").html("0%").hide();return this.updateStatus("Processing...")},uploaderEvents:{onloadstart:function(){return this.updateStatus("Uploading...")},onprogress:function(B){return this.updateStatus("Uploading...",B.loaded)},onabort:function(){this.updateStatus("Aborted");return this.hide(1)},onload:function(){return this.updateStatus("Successfully uploaded...",this.file.size)},onerror:function(){this.updateStatus("Error: Unable to upload the file");return this.hide(3)}}});Mercury.uploader.File=(function(){function B(C){var D;this.file=C;this.fullSize=this.size=this.file.size||this.file.fileSize;this.readableSize=this.size.toBytes();this.name=this.file.name||this.file.fileName;this.type=this.file.type||this.file.fileType;D=[];if(this.size>=Mercury.config.uploading.maxFileSize){D.push(Mercury.I18n("Too large"))}if(!(Mercury.config.uploading.allowedMimeTypes.indexOf(this.type)>-1)){D.push(Mercury.I18n("Unsupported format"))}if(D.length){this.errors=D.join(" / ")}}B.prototype.readAsDataURL=function(E){var C,D=this;if(E==null){E=null}C=new FileReader();C.readAsDataURL(this.file);return C.onload=function(){if(E){return E(C.result)}}};B.prototype.readAsBinaryString=function(E){var C,D=this;if(E==null){E=null}C=new FileReader();C.readAsBinaryString(this.file);return C.onload=function(){if(E){return E(C.result)}}};B.prototype.updateSize=function(C){return this.fullSize=this.size+C};return B})();Mercury.uploader.MultiPartPost=(function(){function B(C,D,E,F){this.inputName=C;this.file=D;this.contents=E;this.formInputs=F!=null?F:{};this.boundary="Boundaryx20072377098235644401115438165x";this.body="";this.buildBody();this.delta=this.body.length-this.file.size}B.prototype.buildBody=function(){var F,C,E,D;F="--"+this.boundary;D=this.formInputs;for(C in D){if(!A.call(D,C)){continue}E=D[C];this.body+=""+F+'\r\nContent-Disposition: form-data; name="'+C+'"\r\n\r\n'+(unescape(encodeURIComponent(E)))+"\r\n"}return this.body+=""+F+'\r\nContent-Disposition: form-data; name="'+this.inputName+'"; filename="'+this.file.name+'"\r\nContent-Type: '+this.file.type+"\r\nContent-Transfer-Encoding: binary\r\n\r\n"+this.contents+"\r\n"+F+"--"};return B})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,C=function(G,E){for(var D in E){if(A.call(E,D)){G[D]=E[D]}}function F(){this.constructor=G}F.prototype=E.prototype;G.prototype=new F;G.__super__=E.prototype;return G},B=Array.prototype.indexOf||function(F){for(var E=0,D=this.length;E<D;E++){if(E in this&&this[E]===F){return E}}return -1};this.Mercury.Regions.Full=(function(F){var E;C(D,F);D.supported=document.designMode&&!jQuery.browser.konqueror&&!jQuery.browser.msie;D.supportedText="Chrome 10+, Firefox 4+, Safari 5+";E="full";D.prototype.type=function(){return E};function D(H,I,G){this.element=H;this.window=I;this.options=G!=null?G:{};D.__super__.constructor.apply(this,arguments)}D.prototype.build=function(){var H,J,G,I;if(jQuery.browser.mozilla&&this.content()===""){this.content("&nbsp;")}this.element.data({originalOverflow:this.element.css("overflow")});this.element.css({overflow:"auto"});this.specialContainer=jQuery.browser.mozilla&&this.element.get(0).tagName!=="DIV";this.element.get(0).contentEditable=true;I=this.element.find("[data-snippet]");for(J=0,G=I.length;J<G;J++){H=I[J];H.contentEditable=false;jQuery(H).attr("data-version","1")}if(!this.document.mercuryEditing){this.document.mercuryEditing=true;try{this.document.execCommand("styleWithCSS",false,false);this.document.execCommand("insertBROnReturn",false,true);this.document.execCommand("enableInlineTableEditing",false,false);return this.document.execCommand("enableObjectResizing",false,false)}catch(K){}}};D.prototype.bindEvents=function(){var G=this;D.__super__.bindEvents.apply(this,arguments);Mercury.on("region:update",function(){var I,H,J;if(G.previewing||Mercury.region!==G){return }setTimeout((function(){return G.selection().forceSelection(G.element.get(0))}),1);H=G.currentElement();if(H.length){J=H.closest("table",G.element);if(J.length){Mercury.tableEditor(J,H.closest("tr, td"),"<br/>")}I=H.closest("a",G.element);if(I.length&&I.attr("href")){return Mercury.tooltip(I,'<a href="'+(I.attr("href"))+'" target="_blank">'+(I.attr("href"))+"</a>",{position:"below"})}else{return Mercury.tooltip.hide()}}});this.element.on("dragenter",function(H){if(G.previewing){return }if(!Mercury.snippet){H.preventDefault()}return H.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("dragover",function(H){if(G.previewing){return }if(!Mercury.snippet){H.preventDefault()}H.originalEvent.dataTransfer.dropEffect="copy";if(jQuery.browser.webkit){clearTimeout(G.dropTimeout);return G.dropTimeout=setTimeout((function(){return G.element.trigger("possible:drop")}),10)}});this.element.on("drop",function(H){if(G.previewing){return }clearTimeout(G.dropTimeout);G.dropTimeout=setTimeout((function(){return G.element.trigger("possible:drop")}),1);if(!H.originalEvent.dataTransfer.files.length){return }H.preventDefault();G.focus();return Mercury.uploader(H.originalEvent.dataTransfer.files[0])});this.element.on("possible:drop",function(){var H;if(G.previewing){return }if(H=G.element.find("img[data-snippet]").get(0)){G.focus();Mercury.Snippet.displayOptionsFor(jQuery(H).data("snippet"));return G.document.execCommand("undo",false,null)}});this.element.on("paste",function(H){if(G.previewing||Mercury.region!==G){return }if(G.specialContainer){H.preventDefault();return }if(G.pasting){return }Mercury.changes=true;return G.handlePaste(H.originalEvent)});this.element.on("focus",function(){if(G.previewing){return }Mercury.region=G;setTimeout((function(){return G.selection().forceSelection(G.element.get(0))}),1);return Mercury.trigger("region:focused",{region:G})});this.element.on("blur",function(){if(G.previewing){return }Mercury.trigger("region:blurred",{region:G});return Mercury.tooltip.hide()});this.element.on("click",function(H){if(G.previewing){return jQuery(H.target).closest("a").attr("target","_parent")}});this.element.on("dblclick",function(H){var I;if(G.previewing){return }I=jQuery(H.target).closest("img",G.element);if(I.length){G.selection().selectNode(I.get(0),true);return Mercury.trigger("button",{action:"insertMedia"})}});this.element.on("mouseup",function(){if(G.previewing){return }G.pushHistory();return Mercury.trigger("region:update",{region:G})});this.element.on("keydown",function(I){var H;if(G.previewing){return }switch(I.keyCode){case 90:if(!I.metaKey){return }I.preventDefault();if(I.shiftKey){G.execCommand("redo")}else{G.execCommand("undo")}return ;case 13:if(jQuery.browser.webkit&&G.selection().commonAncestor().closest("li, ul, ol",G.element).length===0){I.preventDefault();G.document.execCommand("insertParagraph",false,null)}else{if(G.specialContainer||jQuery.browser.opera){I.preventDefault();G.document.execCommand("insertHTML",false,"<br/>")}}break;case 9:I.preventDefault();H=G.selection().commonAncestor();if(H.closest("li",G.element).length){if(!I.shiftKey){G.execCommand("indent")}else{if(H.parents("ul, ol").length>1){G.execCommand("outdent")}}}else{G.execCommand("insertHTML",{value:"&nbsp;&nbsp;"})}}if(I.metaKey){switch(I.keyCode){case 66:G.execCommand("bold");I.preventDefault();break;case 73:G.execCommand("italic");I.preventDefault();break;case 85:G.execCommand("underline");I.preventDefault()}}return G.pushHistory(I.keyCode)});return this.element.on("keyup",function(){if(G.previewing){return }Mercury.trigger("region:update",{region:G});return Mercury.changes=true})};D.prototype.focus=function(){var H=this;if(Mercury.region!==this){setTimeout((function(){return H.element.focus()}),10);try{this.selection().selection.collapseToStart()}catch(G){}}else{setTimeout((function(){return H.element.focus()}),10)}Mercury.trigger("region:focused",{region:this});return Mercury.trigger("region:update",{region:this})};D.prototype.content=function(T,V,N){var I,Q,M,O,U,H,P,K,S,G,L,J;if(T==null){T=null}if(V==null){V=true}if(N==null){N=false}if(T!==null){I=jQuery("<div>").appendTo(this.document.createDocumentFragment());I.html(T);L=I.find("[data-snippet]");for(K=0,S=L.length;K<S;K++){M=L[K];M.contentEditable=false;M=jQuery(M);if(H=Mercury.Snippet.find(M.data("snippet"))){if(!M.data("version")){try{P=parseInt(M.html().match(/\/(\d+)\]/)[1]);if(P){H.setVersion(P);M.attr({"data-version":P});M.html(H.data)}}catch(R){}}}}this.element.html(I.html());return this.selection().selectMarker(this.element)}else{this.element.find("meta").remove();if(N){U=this.selection();U.placeMarker()}I=jQuery("<div>").appendTo(this.document.createDocumentFragment());I.html(this.element.html().replace(/^\s+|\s+$/g,""));if(V){J=I.find("[data-snippet]");for(O=0,G=J.length;O<G;O++){M=J[O];M=jQuery(M);if(H=Mercury.Snippet.find(M.data("snippet"))){H.data=M.html()}M.html("["+(M.data("snippet"))+"/"+(M.data("version"))+"]");M.attr({contenteditable:null,"data-version":null})}}Q=I.html();if(N){U.removeMarker()}return Q}};D.prototype.togglePreview=function(){if(this.previewing){this.element.get(0).contentEditable=true;this.element.css({overflow:"auto"})}else{this.content(this.content());this.element.get(0).contentEditable=false;this.element.css({overflow:this.element.data("originalOverflow")});this.element.blur()}return D.__super__.togglePreview.apply(this,arguments)};D.prototype.execCommand=function(K,H){var J,I;if(H==null){H={}}D.__super__.execCommand.apply(this,arguments);if(J=Mercury.config.behaviors[K]||Mercury.Regions.Full.actions[K]){J.call(this,this.selection(),H)}else{if(K==="indent"){I=this.element.get(0).previousSibling}if(K==="insertHTML"&&H.value&&H.value.get){H.value=jQuery("<div>").html(H.value).html()}try{this.document.execCommand(K,false,H.value)}catch(G){if(K==="indent"&&this.element.prev()!==I){this.element.prev().remove()}}}return this.element.find("img").one("error",function(){return jQuery(this).attr({src:"/assets/mercury/missing-image.png",title:"Image not found"})})};D.prototype.pushHistory=function(I){var H,K,G,J=this;H=[13,46,8];G=2.5;if(I){K=H.indexOf(I)}clearTimeout(this.historyTimeout);if(K>=0&&K!==this.lastKnownKeyCode){this.history.push(this.content(null,false,true))}else{if(I){this.historyTimeout=setTimeout((function(){return J.history.push(J.content(null,false,true))}),G*1000)}else{this.history.push(this.content(null,false,true))}}return this.lastKnownKeyCode=K};D.prototype.selection=function(){return new Mercury.Regions.Full.Selection(this.window.getSelection(),this.document)};D.prototype.path=function(){var G;G=this.selection().commonAncestor();if(!G){return[]}if(G.get(0)===this.element.get(0)){return[]}else{return G.parentsUntil(this.element)}};D.prototype.currentElement=function(){var G,H;G=[];H=this.selection();if(H.range){G=H.commonAncestor();if(G.get(0).nodeType===3){G=G.parent()}}return G};D.prototype.handlePaste=function(I){var H,G,J=this;if(Mercury.config.pasting.sanitize==="text"&&I.clipboardData){this.execCommand("insertHTML",{value:I.clipboardData.getData("text/plain")});I.preventDefault()}else{G=this.selection();G.placeMarker();H=jQuery("#mercury_sanitizer",this.document).focus();return setTimeout(function(){var K;K=J.sanitize(H);G.selectMarker(J.element);G.removeMarker();J.element.focus();return J.execCommand("insertHTML",{value:K})},1)}};D.prototype.sanitize=function(H){var T,U,I,R,Q,P,N,M,S,G,O,L,K,J;H.find("["+Mercury.config.regions.attribute+"]").remove();if(Mercury.config.pasting.sanitize){switch(Mercury.config.pasting.sanitize){case"blacklist":H.find("[style]").removeAttr("style");H.find('[class="Apple-style-span"]').removeClass("Apple-style-span");Q=H.html();break;case"whitelist":O=H.find("*");for(N=0,S=O.length;N<S;N++){P=O[N];T=false;L=Mercury.config.pasting.whitelist;for(I in L){U=L[I];if(P.tagName.toLowerCase()===I.toLowerCase()){T=true;K=jQuery(P.attributes);for(M=0,G=K.length;M<G;M++){R=K[M];if(J=R.name,B.call(U,J)<0){jQuery(P).removeAttr(R.name)}}break}}if(!T){jQuery(P).replaceWith(jQuery(P).contents())}}Q=H.html();break;default:Q=H.text()}}else{Q=H.html();if(Q.indexOf("<!--StartFragment-->")>-1||Q.indexOf('="mso-')>-1||Q.indexOf("<o:")>-1||Q.indexOf('="Mso')>-1){Q=H.text()}}H.html("");return Q};D.actions={insertRowBefore:function(){return Mercury.tableEditor.addRow("before")},insertRowAfter:function(){return Mercury.tableEditor.addRow("after")},insertColumnBefore:function(){return Mercury.tableEditor.addColumn("before")},insertColumnAfter:function(){return Mercury.tableEditor.addColumn("after")},deleteColumn:function(){return Mercury.tableEditor.removeColumn()},deleteRow:function(){return Mercury.tableEditor.removeRow()},increaseColspan:function(){return Mercury.tableEditor.increaseColspan()},decreaseColspan:function(){return Mercury.tableEditor.decreaseColspan()},increaseRowspan:function(){return Mercury.tableEditor.increaseRowspan()},decreaseRowspan:function(){return Mercury.tableEditor.decreaseRowspan()},undo:function(){return this.content(this.history.undo())},redo:function(){return this.content(this.history.redo())},horizontalRule:function(){return this.execCommand("insertHorizontalRule")},removeFormatting:function(G){return G.insertTextNode(G.textContent())},backColor:function(H,G){return H.wrap('<span style="background-color:'+(G.value.toHex())+'">',true)},overline:function(G){return G.wrap('<span style="text-decoration:overline">',true)},style:function(H,G){return H.wrap('<span class="'+G.value+'">',true)},replaceHTML:function(H,G){return this.content(G.value)},insertImage:function(H,G){return this.execCommand("insertHTML",{value:jQuery("<img/>",G.value)})},insertTable:function(H,G){return this.execCommand("insertHTML",{value:G.value})},insertLink:function(I,H){var G;G=jQuery("<"+H.value.tagName+">",this.document).attr(H.value.attrs).html(H.value.content);return I.insertNode(G)},replaceLink:function(J,H){var G,I;G=jQuery("<"+H.value.tagName+">",this.document).attr(H.value.attrs).html(H.value.content);J.selectNode(H.node);I=jQuery("<div>").html(J.content()).find("a").html();return J.replace(jQuery(G,J.context).html(I))},insertSnippet:function(H,G){var J,I;I=G.value;if((J=this.element.find("[data-snippet="+I.identity+"]")).length){H.selectNode(J.get(0))}return H.insertNode(I.getHTML(this.document))},editSnippet:function(){var G;if(!this.snippet){return }G=Mercury.Snippet.find(this.snippet.data("snippet"));return G.displayOptions()},removeSnippet:function(){if(this.snippet){this.snippet.remove()}return Mercury.trigger("hide:toolbar",{type:"snippet",immediately:true})}};return D})(Mercury.Region);Mercury.Regions.Full.Selection=(function(){function D(F,E){this.selection=F;this.context=E;if(!(this.selection.rangeCount>=1)){return }this.range=this.selection.getRangeAt(0);this.fragment=this.range.cloneContents();this.clone=this.range.cloneRange();this.collapsed=this.selection.isCollapsed}D.prototype.commonAncestor=function(E){var F;if(E==null){E=false}if(!this.range){return null}F=this.range.commonAncestorContainer;if(F.nodeType===3&&E){F=F.parentNode}return jQuery(F)};D.prototype.wrap=function(F,E){if(E==null){E=false}F=jQuery(F,this.context).html(this.fragment);if(E){this.replace(F)}return F};D.prototype.textContent=function(){return this.range.cloneContents().textContent};D.prototype.content=function(){return this.range.cloneContents()};D.prototype.is=function(E){var F;F=this.content();if(jQuery(F).length===1&&jQuery(F.firstChild).is(E)){return jQuery(F.firstChild)}return false};D.prototype.forceSelection=function(F){var G,E;if(!jQuery.browser.webkit){return }E=this.context.createRange();if(this.range){if(this.commonAncestor(true).closest("[data-snippet]").length){G=this.context.createTextNode("\x00");F.appendChild(G)}}else{if(F.lastChild&&F.lastChild.nodeType===3&&F.lastChild.textContent.replace(/^[\s+|\n+]|[\s+|\n+]$/,"")===""){G=F.lastChild;F.lastChild.textContent="\x00"}else{G=this.context.createTextNode("\x00");F.appendChild(G)}}if(G){E.setStartBefore(G);E.setEndBefore(G);return this.selection.addRange(E)}};D.prototype.selectMarker=function(F){var G,E;G=F.find("em.mercury-marker");if(!G.length){return }E=this.context.createRange();E.setStartBefore(G.get(0));if(G.length>=2){E.setEndBefore(G.get(1))}G.remove();this.selection.removeAllRanges();return this.selection.addRange(E)};D.prototype.placeMarker=function(){var F,E;if(!this.range){return }this.startMarker=jQuery('<em class="mercury-marker"/>',this.context).get(0);this.endMarker=jQuery('<em class="mercury-marker"/>',this.context).get(0);F=this.range.cloneRange();F.collapse(false);F.insertNode(this.endMarker);if(!this.range.collapsed){E=this.range.cloneRange();E.collapse(true);E.insertNode(this.startMarker)}this.selection.removeAllRanges();return this.selection.addRange(this.range)};D.prototype.removeMarker=function(){jQuery(this.startMarker).remove();return jQuery(this.endMarker).remove()};D.prototype.insertTextNode=function(E){var F;F=this.context.createTextNode(E);this.range.extractContents();this.range.insertNode(F);this.range.selectNodeContents(F);return this.selection.addRange(this.range)};D.prototype.insertNode=function(E){if(E.get){E=E.get(0)}if(jQuery.type(E)==="string"){E=jQuery(E,this.context).get(0)}this.range.deleteContents();this.range.insertNode(E);this.range.selectNodeContents(E);return this.selection.addRange(this.range)};D.prototype.selectNode=function(F,E){if(E==null){E=false}this.range.selectNode(F);if(E){this.selection.removeAllRanges()}return this.selection.addRange(this.range)};D.prototype.replace=function(E,F){if(E.get){E=E.get(0)}if(jQuery.type(E)==="string"){E=jQuery(E,this.context).get(0)}this.range.deleteContents();this.range.insertNode(E);this.range.selectNodeContents(E);this.selection.addRange(this.range);if(F){return this.range.collapse(false)}};return D})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Regions.Image=(function(E){var D;B(C,E);C.supported=document.getElementById;C.supportedText="IE 7+, Chrome 10+, Firefox 4+, Safari 5+, Opera 8+";D="image";C.prototype.type=function(){return D};function C(G,H,F){this.element=G;this.window=H;this.options=F!=null?F:{};C.__super__.constructor.apply(this,arguments)}C.prototype.bindEvents=function(){var F=this;Mercury.on("mode",function(H,G){if(G.mode==="preview"){return F.togglePreview()}});Mercury.on("focus:frame",function(){if(F.previewing||Mercury.region!==F){return }return F.focus()});Mercury.on("action",function(H,G){if(F.previewing||Mercury.region!==F){return }if(G.action){return F.execCommand(G.action,G)}});this.element.on("dragenter",function(G){if(F.previewing){return }G.preventDefault();return G.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("dragover",function(G){if(F.previewing){return }G.preventDefault();return G.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("drop",function(G){if(F.previewing){return }if(G.originalEvent.dataTransfer.files.length){G.preventDefault();F.focus();return Mercury.uploader(G.originalEvent.dataTransfer.files[0])}});return this.element.on("focus",function(){return F.focus()})};C.prototype.togglePreview=function(){if(this.previewing){this.previewing=false;this.element.attr(Mercury.config.regions.attribute,D);return this.build()}else{this.previewing=true;this.element.removeAttr(Mercury.config.regions.attribute);return Mercury.trigger("region:blurred",{region:this})}};C.prototype.focus=function(){if(this.previewing){return }Mercury.region=this;Mercury.trigger("region:focused",{region:this});return Mercury.trigger("region:update",{region:this})};C.prototype.execCommand=function(H,F){var G;if(F==null){F={}}C.__super__.execCommand.apply(this,arguments);if(G=Mercury.Regions.Image.actions[H]){return G.call(this,F)}};C.prototype.pushHistory=function(){return this.history.push({src:this.element.attr("src")})};C.prototype.updateSrc=function(F){return this.element.attr("src",F)};C.prototype.serialize=function(){return{type:D,data:this.dataAttributes(),attributes:{src:this.element.attr("src")}}};C.actions={undo:function(){var F;if(F=this.history.undo()){return this.updateSrc(F.src)}},redo:function(){var F;if(F=this.history.redo()){return this.updateSrc(F.src)}},insertImage:function(F){return this.updateSrc(F.value.src)}};return C})(Mercury.Region)}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Regions.Markdown=(function(E){var D;B(C,E);C.supported=document.getElementById;C.supportedText="IE 7+, Chrome 10+, Firefox 4+, Safari 5+, Opera 8+";D="markdown";C.prototype.type=function(){return D};function C(G,H,F){this.element=G;this.window=H;this.options=F!=null?F:{};C.__super__.constructor.apply(this,arguments);this.converter=new Showdown.converter()}C.prototype.build=function(){var F,H,G;G="100%";F=this.element.height();H=this.element.html().replace(/^\s+|\s+$/g,"").replace("&gt;",">");this.textarea=jQuery("<textarea>",this.document).val(H).addClass("mercury-textarea");this.textarea.css({border:0,background:"transparent",display:"block","overflow-y":"hidden",width:G,height:F,fontFamily:'"Courier New", Courier, monospace'});this.element.empty().append(this.textarea);this.previewElement=jQuery("<div>",this.document);this.element.append(this.previewElement);this.container=this.element;this.container.data("region",this);this.element=this.textarea;return this.resize()};C.prototype.bindEvents=function(){var F=this;Mercury.on("mode",function(H,G){if(G.mode==="preview"){return F.togglePreview()}});Mercury.on("focus:frame",function(){if(!F.previewing&&Mercury.region===F){return F.focus()}});Mercury.on("action",function(H,G){if(F.previewing||Mercury.region!==F){return }if(G.action){return F.execCommand(G.action,G)}});Mercury.on("unfocus:regions",function(){if(F.previewing||Mercury.region!==F){return }F.element.blur();F.container.removeClass("focus");return Mercury.trigger("region:blurred",{region:F})});this.element.on("dragenter",function(G){if(F.previewing){return }G.preventDefault();return G.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("dragover",function(G){if(F.previewing){return }G.preventDefault();return G.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("drop",function(G){if(F.previewing){return }if(Mercury.snippet){G.preventDefault();F.focus();Mercury.Snippet.displayOptionsFor(Mercury.snippet)}if(G.originalEvent.dataTransfer.files.length){G.preventDefault();F.focus();return Mercury.uploader(G.originalEvent.dataTransfer.files[0])}});this.element.on("focus",function(){if(F.previewing){return }Mercury.region=F;F.container.addClass("focus");return Mercury.trigger("region:focused",{region:F})});this.element.on("keydown",function(K){var H,G,J,I,M,L;if(F.previewing){return }F.resize();switch(K.keyCode){case 90:if(!K.metaKey){return }K.preventDefault();if(K.shiftKey){F.execCommand("redo")}else{F.execCommand("undo")}return ;case 13:I=F.selection();L=F.element.val();M=L.lastIndexOf("\n",I.start);H=L.indexOf("\n",I.end);if(H<M){H=L.length}if(L[M]==="\n"){M=L.lastIndexOf("\n",I.start-1)}if(L[M+1]==="-"){I.replace("\n- ",false,true);K.preventDefault()}if(/\d/.test(L[M+1])){G=L.substring(M,H);if(/(\d+)\./.test(G)){J=parseInt(RegExp.$1);I.replace("\n"+(J+=1)+". ",false,true);K.preventDefault()}}break;case 9:K.preventDefault();F.execCommand("insertHTML",{value:"  "})}if(K.metaKey){switch(K.keyCode){case 66:F.execCommand("bold");K.preventDefault();break;case 73:F.execCommand("italic");K.preventDefault();break;case 85:F.execCommand("underline");K.preventDefault()}}return F.pushHistory(K.keyCode)});this.element.on("keyup",function(){if(F.previewing){return }Mercury.changes=true;F.resize();return Mercury.trigger("region:update",{region:F})});this.element.on("mouseup",function(){if(F.previewing){return }F.focus();return Mercury.trigger("region:focused",{region:F})});return this.previewElement.on("click",function(G){if(F.previewing){return $(G.target).closest("a").attr("target","_parent")}})};C.prototype.focus=function(){return this.element.focus()};C.prototype.content=function(G,F){if(G==null){G=null}if(F==null){F=true}if(G!==null){if(jQuery.type(G)==="string"){return this.element.val(G)}else{this.element.val(G.html);return this.selection().select(G.selection.start,G.selection.end)}}else{return this.element.val()}};C.prototype.contentAndSelection=function(){return{html:this.content(null,false),selection:this.selection().serialize()}};C.prototype.togglePreview=function(){var F;if(this.previewing){this.previewing=false;this.container.attr(Mercury.config.regions.attribute,D);this.previewElement.hide();this.element.show();if(Mercury.region===this){return this.focus()}}else{this.previewing=true;this.container.removeAttr(Mercury.config.regions.attribute);F=this.converter.makeHtml(this.element.val());this.previewElement.html(F);this.previewElement.show();this.element.hide();return Mercury.trigger("region:blurred",{region:this})}};C.prototype.execCommand=function(H,F){var G;if(F==null){F={}}C.__super__.execCommand.apply(this,arguments);if(G=Mercury.Regions.Markdown.actions[H]){G.call(this,this.selection(),F)}return this.resize()};C.prototype.pushHistory=function(H){var G,J,F,I=this;G=[13,46,8];F=2.5;if(H){J=G.indexOf(H)}clearTimeout(this.historyTimeout);if(J>=0&&J!==this.lastKnownKeyCode){this.history.push(this.contentAndSelection())}else{if(H){this.historyTimeout=setTimeout((function(){return I.history.push(I.contentAndSelection())}),F*1000)}else{this.history.push(this.contentAndSelection())}}return this.lastKnownKeyCode=J};C.prototype.selection=function(){return new Mercury.Regions.Markdown.Selection(this.element)};C.prototype.resize=function(){this.element.css({height:this.element.get(0).scrollHeight-100});return this.element.css({height:this.element.get(0).scrollHeight})};C.prototype.snippets=function(){};C.actions={undo:function(){return this.content(this.history.undo())},redo:function(){return this.content(this.history.redo())},insertHTML:function(H,F){var G;if(F.value.get&&(G=F.value.get(0))){F.value=jQuery("<div>").html(G).html()}return H.replace(F.value,false,true)},insertImage:function(G,F){return G.replace("![add alt text]("+encodeURI(F.value.src)+")",true)},insertTable:function(G,F){return G.replace(F.value.replace(/<br>|<br\/>/ig,""),false,true)},insertLink:function(G,F){return G.replace("["+F.value.content+"]("+F.value.attrs.href+" 'optional title')",true)},insertUnorderedList:function(F){return F.addList("unordered")},insertOrderedList:function(F){return F.addList("ordered")},style:function(G,F){return G.wrap('<span class="'+F.value+'">',"</span>")},formatblock:function(H,F){var J,G,I;I={h1:["# "," #"],h2:["## "," ##"],h3:["### "," ###"],h4:["#### "," ####"],h5:["##### "," #####"],h6:["###### "," ######"],pre:["    ",""],blockquote:["> ",""],p:["\n","\n"]};for(G in I){J=I[G];H.unWrapLine(""+J[0],""+J[1])}if(F.value==="blockquote"){Mercury.Regions.Markdown.actions.indent.call(this,H,F);return }return H.wrapLine(""+I[F.value][0],""+I[F.value][1])},bold:function(F){return F.wrap("**","**")},italic:function(F){return F.wrap("_","_")},subscript:function(F){return F.wrap("<sub>","</sub>")},superscript:function(F){return F.wrap("<sup>","</sup>")},indent:function(F){return F.wrapLine("> ","",false,true)},outdent:function(F){return F.unWrapLine("> ","",false,true)},horizontalRule:function(F){return F.replace("\n- - -\n")},insertSnippet:function(G,F){var H;H=F.value;return G.replace(H.getText())}};return C})(Mercury.Region);Mercury.Regions.Markdown.Selection=(function(){function C(D){this.element=D;this.el=this.element.get(0);this.getDetails()}C.prototype.serialize=function(){return{start:this.start,end:this.end}};C.prototype.getDetails=function(){this.length=this.el.selectionEnd-this.el.selectionStart;this.start=this.el.selectionStart;this.end=this.el.selectionEnd;return this.text=this.element.val().substr(this.start,this.length)};C.prototype.replace=function(I,E,D){var H,G,F;if(E==null){E=false}if(D==null){D=false}this.getDetails();F=this.element.val();G=this.element.val();this.element.val(F.substr(0,this.start)+I+F.substr(this.end,F.length));H=this.element.val()!==G;if(E){this.select(this.start,this.start+I.length)}if(D){this.select(this.start+I.length,this.start+I.length)}return H};C.prototype.select=function(E,D){this.start=E;this.end=D;this.element.focus();this.el.selectionStart=this.start;this.el.selectionEnd=this.end;return this.getDetails()};C.prototype.wrap=function(E,D){this.getDetails();this.deselectNewLines();this.replace(E+this.text+D,this.text!=="");if(this.text===""){return this.select(this.start+E.length,this.start+E.length)}};C.prototype.wrapLine=function(I,G,H,E){var F,D,K,J;if(H==null){H=true}if(E==null){E=false}this.getDetails();D=this.serialize();J=this.element.val();K=J.lastIndexOf("\n",this.start);F=J.indexOf("\n",this.end);if(F<K){F=J.length}if(J[K]==="\n"){K=J.lastIndexOf("\n",this.start-1)}this.select(K+1,F);this.replace(I+this.text+G,H);if(E){return this.select(D.start+I.length,D.end+I.length)}};C.prototype.unWrapLine=function(F,K,G,D){var I,H,J,M,N,E,L;if(G==null){G=true}if(D==null){D=false}this.getDetails();N=this.serialize();L=this.element.val();E=L.lastIndexOf("\n",this.start);H=L.indexOf("\n",this.end);if(H<E){H=L.length}if(L[E]==="\n"){E=L.lastIndexOf("\n",this.start-1)}this.select(E+1,H);window.something=this.text;J=new RegExp("^"+(F.regExpEscape()));M=new RegExp(""+(K.regExpEscape())+"$");I=this.replace(this.text.replace(J,"").replace(M,""),G);if(D&&I){return this.select(N.start-F.length,N.end-F.length)}};C.prototype.addList=function(H){var F,G,E,D,J,I;I=this.element.val();J=I.lastIndexOf("\n",this.start);F=I.indexOf("\n",this.end);if(F<J){F=I.length}if(I[J]==="\n"){J=I.lastIndexOf("\n",this.start-1)}this.select(J+1,F);D=this.text.split("\n");if(H==="unordered"){return this.replace("- "+D.join("\n- "),true)}else{return this.replace(((function(){var L,K;K=[];for(G=0,L=D.length;G<L;G++){E=D[G];K.push(""+(G+1)+". "+E)}return K})()).join("\n"),true)}};C.prototype.deselectNewLines=function(){var D,E;E=this.text;D=E.replace(/\n+$/g,"").length;return this.select(this.start,this.start+D)};C.prototype.placeMarker=function(){return this.wrap("[mercury-marker]","[mercury-marker]")};C.prototype.removeMarker=function(){var D,F,E;E=this.element.val();F=E.indexOf("[mercury-marker]");if(!(F>-1)){return }D=E.indexOf("[mercury-marker]",F+1)-"[mercury-marker]".length;this.element.val(this.element.val().replace(/\[mercury-marker\]/g,""));return this.select(F,D)};C.prototype.textContent=function(){return this.text};return C})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Regions.Simple=(function(D){var C;B(E,D);E.supported=document.getElementById;E.supportedText="IE 7+, Chrome 10+, Firefox 4+, Safari 5+, Opera 8+";C="simple";E.prototype.type=function(){return C};function E(G,H,F){this.element=G;this.window=H;this.options=F!=null?F:{};Mercury.log("building "+C,this.element,this.options);E.__super__.constructor.apply(this,arguments)}E.prototype.build=function(){var F,H,G;if(this.element.css("display")==="block"){G="100%";F=this.element.height()}else{G=this.element.width();F=this.element.height()}H=this.element.text();this.textarea=jQuery("<textarea>",this.document).val(H).addClass("mercury-textarea");this.textarea.css({border:0,background:"transparent","overflow-y":"hidden",width:G,height:F,fontFamily:"inherit",fontSize:"inherit",fontWeight:"inherit",fontStyle:"inherit",color:"inherit","min-height":0,padding:"0",margin:0,"border-radius":0,display:"inherit",lineHeight:"inherit",textAlign:"inherit"});this.element.empty().append(this.textarea);this.container=this.element;this.container.data("region",this);this.element=this.textarea;return this.resize()};E.prototype.bindEvents=function(){var F=this;Mercury.on("mode",function(H,G){if(G.mode==="preview"){return F.togglePreview()}});Mercury.on("focus:frame",function(){if(!F.previewing&&Mercury.region===F){return F.focus()}});Mercury.on("action",function(H,G){if(F.previewing||Mercury.region!==F){return }if(G.action){return F.execCommand(G.action,G)}});Mercury.on("unfocus:regions",function(){if(F.previewing||Mercury.region!==F){return }F.element.blur();F.container.removeClass("focus");return Mercury.trigger("region:blurred",{region:F})});return this.bindElementEvents()};E.prototype.bindElementEvents=function(){var F=this;this.element.on("focus",function(){if(F.previewing){return }Mercury.region=F;F.container.addClass("focus");return Mercury.trigger("region:focused",{region:F})});this.element.on("keydown",function(K){var H,G,J,I,M,L;if(F.previewing){return }F.resize();switch(K.keyCode){case 90:if(!K.metaKey){return }K.preventDefault();if(K.shiftKey){F.execCommand("redo")}else{F.execCommand("undo")}return ;case 13:I=F.selection();L=F.element.val();M=L.lastIndexOf("\n",I.start);H=L.indexOf("\n",I.end);if(H<M){H=L.length}if(L[M]==="\n"){M=L.lastIndexOf("\n",I.start-1)}if(L[M+1]==="-"){I.replace("\n- ",false,true)}if(/\d/.test(L[M+1])){G=L.substring(M,H);if(/(\d+)\./.test(G)){J=parseInt(RegExp.$1);I.replace("\n"+(J+=1)+". ",false,true)}}K.preventDefault();break;case 9:K.preventDefault();F.execCommand("insertHTML",{value:"  "})}return F.pushHistory(K.keyCode)});this.element.on("keyup",function(){if(F.previewing){return }Mercury.changes=true;F.resize();return Mercury.trigger("region:update",{region:F})});this.element.on("mouseup",function(){if(F.previewing){return }F.focus();return Mercury.trigger("region:focused",{region:F})});return this.element.on("paste",function(G){if(F.previewing||Mercury.region!==F){return }if(F.specialContainer){G.preventDefault();return }if(F.pasting){return }Mercury.changes=true;return F.handlePaste(G.originalEvent)})};E.prototype.handlePaste=function(F){this.execCommand("insertHTML",{value:F.clipboardData.getData("text/plain").replace(/\n/g," ")});F.preventDefault()};E.prototype.path=function(){return[this.container.get(0)]};E.prototype.focus=function(){return this.element.focus()};E.prototype.content=function(G,F){if(G==null){G=null}if(F==null){F=true}if(G!==null){if(jQuery.type(G)==="string"){return this.element.val(G)}else{this.element.val(G.html);return this.selection().select(G.selection.start,G.selection.end)}}else{return this.element.val()}};E.prototype.contentAndSelection=function(){return{html:this.content(null,false),selection:this.selection().serialize()}};E.prototype.togglePreview=function(){var F;if(this.previewing){this.previewing=false;this.element=this.container;this.container.attr(Mercury.config.regions.attribute,C);this.build();this.bindElementEvents();if(Mercury.region===this){return this.focus()}}else{this.previewing=true;F=jQuery("<div></div>").text(this.element.val()).html();this.container.removeAttr(Mercury.config.regions.attribute);this.container.html(F);return Mercury.trigger("region:blurred",{region:this})}};E.prototype.execCommand=function(H,F){var G;if(F==null){F={}}E.__super__.execCommand.apply(this,arguments);if(G=Mercury.Regions.Simple.actions[H]){G.call(this,this.selection(),F)}return this.resize()};E.prototype.pushHistory=function(H){var G,J,F,I=this;G=[13,46,8];F=2.5;if(H){J=G.indexOf(H)}clearTimeout(this.historyTimeout);if(J>=0&&J!==this.lastKnownKeyCode){this.history.push(this.contentAndSelection())}else{if(H){this.historyTimeout=setTimeout((function(){return I.history.push(I.contentAndSelection())}),F*1000)}else{this.history.push(this.contentAndSelection())}}return this.lastKnownKeyCode=J};E.prototype.selection=function(){return new Mercury.Regions.Simple.Selection(this.element)};E.prototype.resize=function(){this.element.css({height:this.element.get(0).scrollHeight-100});return this.element.css({height:this.element.get(0).scrollHeight})};E.prototype.snippets=function(){};E.actions={undo:function(){return this.content(this.history.undo())},redo:function(){return this.content(this.history.redo())},insertHTML:function(H,F){var G;if(F.value.get&&(G=F.value.get(0))){F.value=jQuery("<div>").html(G).html()}return H.replace(F.value,false,true)}};return E})(Mercury.Region);Mercury.Regions.Simple.Selection=(function(){function C(D){this.element=D;this.el=this.element.get(0);this.getDetails()}C.prototype.serialize=function(){return{start:this.start,end:this.end}};C.prototype.getDetails=function(){this.length=this.el.selectionEnd-this.el.selectionStart;this.start=this.el.selectionStart;this.end=this.el.selectionEnd;return this.text=this.element.val().substr(this.start,this.length)};C.prototype.replace=function(I,E,D){var H,G,F;if(E==null){E=false}if(D==null){D=false}this.getDetails();F=this.element.val();G=this.element.val();this.element.val(F.substr(0,this.start)+I+F.substr(this.end,F.length));H=this.element.val()!==G;if(E){this.select(this.start,this.start+I.length)}if(D){this.select(this.start+I.length,this.start+I.length)}return H};C.prototype.select=function(E,D){this.start=E;this.end=D;this.element.focus();this.el.selectionStart=this.start;this.el.selectionEnd=this.end;return this.getDetails()};C.prototype.wrap=function(E,D){this.getDetails();this.deselectNewLines();this.replace(E+this.text+D,this.text!=="");if(this.text===""){return this.select(this.start+E.length,this.start+E.length)}};C.prototype.deselectNewLines=function(){var D,E;E=this.text;D=E.replace(/\n+$/g,"").length;return this.select(this.start,this.start+D)};C.prototype.placeMarker=function(){return this.wrap("[mercury-marker]","[mercury-marker]")};C.prototype.removeMarker=function(){var D,F,E;E=this.element.val();F=E.indexOf("[mercury-marker]");if(!(F>-1)){return }D=E.indexOf("[mercury-marker]",F+1)-"[mercury-marker]".length;this.element.val(this.element.val().replace(/\[mercury-marker\]/g,""));return this.select(F,D)};C.prototype.textContent=function(){return this.text};return C})()}).call(this);(function(){var A=Object.prototype.hasOwnProperty,B=function(F,D){for(var C in D){if(A.call(D,C)){F[C]=D[C]}}function E(){this.constructor=F}E.prototype=D.prototype;F.prototype=new E;F.__super__=D.prototype;return F};this.Mercury.Regions.Snippets=(function(E){var D;B(C,E);C.supported=document.getElementById;C.supportedText="IE 7+, Chrome 10+, Firefox 4+, Safari 5+, Opera 8+";D="snippets";C.prototype.type=function(){return D};function C(G,H,F){this.element=G;this.window=H;this.options=F!=null?F:{};Mercury.log("building "+D,this.element,this.options);C.__super__.constructor.apply(this,arguments);this.makeSortable()}C.prototype.build=function(){var G,I,F,H;H=this.element.find("[data-snippet]");for(I=0,F=H.length;I<F;I++){G=H[I];jQuery(G).attr("data-version",0)}if(this.element.css("minHeight")==="0px"){return this.element.css({minHeight:20})}};C.prototype.bindEvents=function(){var F=this;C.__super__.bindEvents.apply(this,arguments);Mercury.on("unfocus:regions",function(G){if(F.previewing){return }if(Mercury.region===F){F.element.removeClass("focus");F.element.sortable("destroy");return Mercury.trigger("region:blurred",{region:F})}});Mercury.on("focus:window",function(G){if(F.previewing){return }if(Mercury.region===F){F.element.removeClass("focus");F.element.sortable("destroy");return Mercury.trigger("region:blurred",{region:F})}});this.element.on("mouseup",function(){if(F.previewing){return }F.focus();return Mercury.trigger("region:focused",{region:F})});this.element.on("dragover",function(G){if(F.previewing){return }G.preventDefault();return G.originalEvent.dataTransfer.dropEffect="copy"});this.element.on("drop",function(G){if(F.previewing||!Mercury.snippet){return }F.focus();G.preventDefault();return Mercury.Snippet.displayOptionsFor(Mercury.snippet)});jQuery(this.document).on("keydown",function(G){if(F.previewing||Mercury.region!==F){return }switch(G.keyCode){case 90:if(!G.metaKey){return }G.preventDefault();if(G.shiftKey){return F.execCommand("redo")}else{return F.execCommand("undo")}}});return jQuery(this.document).on("keyup",function(){if(F.previewing||Mercury.region!==F){return }return Mercury.changes=true})};C.prototype.focus=function(){Mercury.region=this;this.makeSortable();return this.element.addClass("focus")};C.prototype.togglePreview=function(){if(this.previewing){this.makeSortable()}else{this.element.sortable("destroy");this.element.removeClass("focus")}return C.__super__.togglePreview.apply(this,arguments)};C.prototype.execCommand=function(H,F){var G;if(F==null){F={}}C.__super__.execCommand.apply(this,arguments);if(G=Mercury.Regions.Snippets.actions[H]){return G.call(this,F)}};C.prototype.makeSortable=function(){var F=this;return this.element.sortable("destroy").sortable({document:this.document,scroll:false,containment:"parent",items:"[data-snippet]",opacity:0.4,revert:100,tolerance:"pointer",beforeStop:function(){Mercury.trigger("hide:toolbar",{type:"snippet",immediately:true});return true},stop:function(){setTimeout((function(){return F.pushHistory()}),100);return true}})};C.actions={undo:function(){return this.content(this.history.undo())},redo:function(){return this.content(this.history.redo())},insertSnippet:function(F){var H,G,I=this;G=F.value;if((H=this.element.find("[data-snippet="+G.identity+"]")).length){return H.replaceWith(G.getHTML(this.document,function(){return I.pushHistory()}))}else{return this.element.append(G.getHTML(this.document,function(){return I.pushHistory()}))}},editSnippet:function(){var F;if(!this.snippet){return }F=Mercury.Snippet.find(this.snippet.data("snippet"));return F.displayOptions()},removeSnippet:function(){if(this.snippet){this.snippet.remove()}return Mercury.trigger("hide:toolbar",{type:"snippet",immediately:true})}};return C})(Mercury.Region)}).call(this);(function(){this.Mercury.dialogHandlers.backColor=function(){var A=this;return this.element.find(".picker, .last-picked").on("click",function(C){var B;B=jQuery(C.target).css("background-color");A.element.find(".last-picked").css({background:B});A.button.css({backgroundColor:B});return Mercury.trigger("action",{action:"backColor",value:B})})}}).call(this);(function(){this.Mercury.dialogHandlers.foreColor=function(){var A=this;return this.element.find(".picker, .last-picked").on("click",function(C){var B;B=jQuery(C.target).css("background-color");A.element.find(".last-picked").css({background:B});A.button.css({backgroundColor:B});return Mercury.trigger("action",{action:"foreColor",value:B})})}}).call(this);(function(){this.Mercury.dialogHandlers.formatblock=function(){var A=this;return this.element.find("[data-tag]").on("click",function(C){var B;B=jQuery(C.target).data("tag");return Mercury.trigger("action",{action:"formatblock",value:B})})}}).call(this);(function(){this.Mercury.dialogHandlers.snippetPanel=function(){var A=this;this.element.find("input.filter").on("keyup",function(){var D,G,F,C,E,B;G=A.element.find("input.filter").val();E=A.element.find("li[data-filter]");B=[];for(F=0,C=E.length;F<C;F++){D=E[F];if(LiquidMetal.score(jQuery(D).data("filter"),G)===0){B.push(jQuery(D).hide())}else{B.push(jQuery(D).show())}}return B});return this.element.find("img[data-snippet]").on("dragstart",function(){return Mercury.snippet=jQuery(this).data("snippet")})}}).call(this);(function(){this.Mercury.dialogHandlers.style=function(){var A=this;return this.element.find("[data-class]").on("click",function(C){var B;B=jQuery(C.target).data("class");return Mercury.trigger("action",{action:"style",value:B})})}}).call(this);(function(){this.Mercury.modalHandlers.htmlEditor=function(){var A,B=this;A=Mercury.region.content(null,true,false);this.element.find("textarea").val(A);return this.element.find("form").on("submit",function(C){var D;C.preventDefault();D=B.element.find("textarea").val().replace(/\n/g,"");Mercury.trigger("action",{action:"replaceHTML",value:D});return B.hide()})}}).call(this);(function(){this.Mercury.modalHandlers.insertCharacter=function(){var A=this;return this.element.find(".character").on("click",function(B){Mercury.trigger("action",{action:"insertHTML",value:"&"+(jQuery(B.target).attr("data-entity"))+";"});return A.hide()})}}).call(this);(function(){this.Mercury.modalHandlers.insertLink=function(){var E,B,K,A,G,J,I,C,H,D,F=this;this.element.find("label input").on("click",function(){return jQuery(this).closest("label").next(".selectable").focus()});this.element.find(".selectable").on("focus",function(){return jQuery(this).prev("label").find("input[type=radio]").prop("checked",true)});this.element.find("#link_target").on("change",function(){F.element.find(".link-target-options").hide();F.element.find("#"+(F.element.find("#link_target").val())+"_options").show();return F.resize(true)});E=this.element.find("#link_existing_bookmark");D=jQuery("a[name]",window.mercuryInstance.document);for(C=0,H=D.length;C<H;C++){G=D[C];E.append(jQuery("<option>",{value:jQuery(G).attr("name")}).text(jQuery(G).text()))}if(Mercury.region&&Mercury.region.selection){I=Mercury.region.selection();if(I&&I.commonAncestor){B=I.commonAncestor(true).closest("a")}if(B&&B.length){K=B;this.element.find("#link_text_container").hide();if(B.attr("href")&&B.attr("href").indexOf("#")===0){E.val(B.attr("href").replace(/[^#]*#/,""));E.prev("label").find("input[type=radio]").prop("checked",true)}else{this.element.find("#link_external_url").val(B.attr("href"))}if(B.attr("name")){J=this.element.find("#link_new_bookmark");J.val(B.attr("name"));J.prev("label").find("input[type=radio]").prop("checked",true)}if(B.attr("target")){this.element.find("#link_target").val(B.attr("target"))}if(B.attr("href")&&B.attr("href").indexOf("javascript:void")===0){A=B.attr("href");this.element.find("#link_external_url").val(A.match(/window.open\('([^']+)',/)[1]);this.element.find("#link_target").val("popup");this.element.find("#link_popup_width").val(A.match(/width=(\d+),/)[1]);this.element.find("#link_popup_height").val(A.match(/height=(\d+),/)[1]);this.element.find("#popup_options").show()}}if(I.textContent){this.element.find("#link_text").val(I.textContent())}}return this.element.find("form").on("submit",function(P){var M,L,O,R,N,Q;P.preventDefault();O=F.element.find("#link_text").val();R=F.element.find("#link_target").val();N=F.element.find("input[name=link_type]:checked").val();switch(N){case"existing_bookmark":L={href:"#"+(F.element.find("#link_existing_bookmark").val())};break;case"new_bookmark":L={name:""+(F.element.find("#link_new_bookmark").val())};break;default:L={href:F.element.find("#link_"+N).val()}}switch(R){case"popup":M={width:parseInt(F.element.find("#link_popup_width").val())||500,height:parseInt(F.element.find("#link_popup_height").val())||500,menubar:"no",toolbar:"no"};L.href="javascript:void(window.open('"+L.href+"', 'popup_window', '"+(jQuery.param(M).replace(/&/g,","))+"'))";break;default:if(R){L.target=R}}Q={tagName:"a",attrs:L,content:O};if(K){Mercury.trigger("action",{action:"replaceLink",value:Q,node:K.get(0)})}else{Mercury.trigger("action",{action:"insertLink",value:Q})}return F.hide()})}}).call(this);(function(){this.Mercury.modalHandlers.insertMedia=function(){var B,C,A,D,E=this;this.element.find("label input").on("click",function(){return jQuery(this).closest("label").next(".selectable").focus()});this.element.find(".selectable").on("focus",function(G){var F;F=jQuery(G.target);F.prev("label").find("input[type=radio]").prop("checked",true);E.element.find(".media-options").hide();E.element.find("#"+(F.attr("id").replace("media_",""))).show();return E.resize(true)});if(Mercury.region&&Mercury.region.selection){A=Mercury.region.selection();if(A.is&&(C=A.is("img"))){this.element.find("#media_image_url").val(C.attr("src"));this.element.find("#media_image_alignment").val(C.attr("align"));setTimeout((function(){return E.element.find("#media_image_url").focus()}),300)}if(A.is&&(B=A.is("iframe"))){D=B.attr("src");if(D.indexOf("http://www.youtube.com")>-1){this.element.find("#media_youtube_url").val("http://youtu.be/"+(D.match(/\/embed\/(\w+)/)[1]));this.element.find("#media_youtube_width").val(B.width());this.element.find("#media_youtube_height").val(B.height());setTimeout((function(){return E.element.find("#media_youtube_url").focus()}),300)}else{if(D.indexOf("http://player.vimeo.com")>-1){this.element.find("#media_vimeo_url").val("http://vimeo.com/"+(D.match(/\/video\/(\w+)/)[1]));this.element.find("#media_vimeo_width").val(B.width());this.element.find("#media_vimeo_height").val(B.height());setTimeout((function(){return E.element.find("#media_vimeo_url").focus()}),300)}}}}return this.element.find("form").on("submit",function(J){var M,G,I,L,H,F,K;J.preventDefault();H=E.element.find("input[name=media_type]:checked").val();switch(H){case"image_url":G={src:E.element.find("#media_image_url").val()};if(M=E.element.find("#media_image_alignment").val()){G.align=M}Mercury.trigger("action",{action:"insertImage",value:G});break;case"youtube_url":F=E.element.find("#media_youtube_url").val();if(!/^https?:\/\/youtu.be\//.test(F)){Mercury.notify("Error: The provided youtube share url was invalid.");return }I=F.replace(/https?:\/\/youtu.be\//,"");L="http";if(/^https:/.test(F)){L="https"}K=jQuery("<iframe>",{width:E.element.find("#media_youtube_width").val()||560,height:E.element.find("#media_youtube_height").val()||349,src:""+L+"://www.youtube.com/embed/"+I+"?wmode=transparent",frameborder:0,allowfullscreen:"true"});Mercury.trigger("action",{action:"insertHTML",value:K});break;case"vimeo_url":F=E.element.find("#media_vimeo_url").val();if(!/^https?:\/\/vimeo.com\//.test(F)){Mercury.notify("Error: The provided vimeo url was invalid.");return }I=F.replace(/^https?:\/\/vimeo.com\//,"");L="http";if(/^https:/.test(F)){L="https"}K=jQuery("<iframe>",{width:E.element.find("#media_vimeo_width").val()||400,height:E.element.find("#media_vimeo_height").val()||225,src:""+L+"://player.vimeo.com/video/"+I+"?title=1&byline=1&portrait=0&color=ffffff",frameborder:0});Mercury.trigger("action",{action:"insertHTML",value:K})}return E.hide()})}}).call(this);(function(){this.Mercury.modalHandlers.insertSnippet=function(){var A=this;return this.element.find("form").on("submit",function(D){var B,C;D.preventDefault();B=A.element.find("form").serializeObject();if(Mercury.snippet){C=Mercury.snippet;C.setOptions(B);Mercury.snippet=null}else{C=Mercury.Snippet.create(A.options.snippetName,B)}Mercury.trigger("action",{action:"insertSnippet",value:C});return A.hide()})}}).call(this);(function(){this.Mercury.modalHandlers.insertTable=function(){var A,B,C=this;B=this.element.find("#table_display table");B.on("click",function(E){var D;D=jQuery(E.target);B=D.closest("table");B.find(".selected").removeAttr("class");D.addClass("selected");return Mercury.tableEditor(B,D,"&nbsp;")});A=B.find("td, th").first();A.addClass("selected");Mercury.tableEditor(B,A,"&nbsp;");this.element.find("input.action").on("click",function(D){var E;E=jQuery(D.target).attr("name");switch(E){case"insertRowBefore":return Mercury.tableEditor.addRow("before");case"insertRowAfter":return Mercury.tableEditor.addRow("after");case"deleteRow":return Mercury.tableEditor.removeRow();case"insertColumnBefore":return Mercury.tableEditor.addColumn("before");case"insertColumnAfter":return Mercury.tableEditor.addColumn("after");case"deleteColumn":return Mercury.tableEditor.removeColumn();case"increaseColspan":return Mercury.tableEditor.increaseColspan();case"decreaseColspan":return Mercury.tableEditor.decreaseColspan();case"increaseRowspan":return Mercury.tableEditor.increaseRowspan();case"decreaseRowspan":return Mercury.tableEditor.decreaseRowspan()}});this.element.find("#table_alignment").on("change",function(){return B.attr({align:C.element.find("#table_alignment").val()})});this.element.find("#table_border").on("keyup",function(){return B.attr({border:parseInt(C.element.find("#table_border").val())})});this.element.find("#table_spacing").on("keyup",function(){return B.attr({cellspacing:parseInt(C.element.find("#table_spacing").val())})});return this.element.find("form").on("submit",function(E){var D,F;E.preventDefault();B.find(".selected").removeAttr("class");B.find("td, th").html("<br/>");D=jQuery("<div>").html(B).html();F=D.replace(/^\s+|\n/gm,"").replace(/(<\/.*?>|<table.*?>|<tbody>|<tr>)/g,"$1\n");Mercury.trigger("action",{action:"insertTable",value:F});return C.hide()})}}).call(this);(function(){if(Mercury.onload){Mercury.onload()}jQuery(window).trigger("mercury:loaded")}).call(this);